#include <stdio.h>
#include <stdlib.h>

#define HEADERS_FILENAME        "all_headers"
#define SOURCES_FILENAME        "all_sources"
#define MAX_PATH                1024

unsigned long   dwNumTotalLines = 0;
unsigned long   dwNumLines = 0;

void    CountFile( char *FileName )
{       FILE       *fp;

        dwNumLines = 0;

        if ( FileName == NULL )
           return;

        fp = fopen( FileName, "rt" );

        if ( fp == NULL )
           return;

        printf( "Counting file %s : ", FileName );

        while ( !feof( fp ) ) {
              char pLine[ MAX_PATH ];

              memset( pLine, 0, MAX_PATH );

              fscanf( fp, "%s\n", pLine );
              dwNumLines++;
        }

        fclose( fp );

        printf( "%d\n", dwNumLines );

        dwNumTotalLines += dwNumLines;
}

int     main( int argc, char *argv[] )
{       FILE  *fHandle;

        dwNumTotalLines = 0;
        dwNumLines = 0;

        fHandle = fopen( HEADERS_FILENAME, "rt" );

        if ( fHandle == NULL ) {
           printf( "Error file %s not found.", HEADERS_FILENAME );
           return( -1 );
        }

        while ( !feof( fHandle ) ) {
              char     pStr[ MAX_PATH ];

              memset( pStr, 0, MAX_PATH );

              fscanf( fHandle, "%s\n", pStr );

              CountFile( pStr );

        }

        fclose( fHandle );

        fHandle = fopen( SOURCES_FILENAME, "rt" );

        if ( fHandle == NULL ) {
           printf( "Error file %s not found.", SOURCES_FILENAME );
           return( -2 );
        }

        while ( !feof( fHandle ) ) {
              char     pStr[ MAX_PATH ];

              memset( pStr, 0, MAX_PATH );

              fscanf( fHandle, "%s\n", pStr );

              CountFile( pStr );

        }

        fclose( fHandle );

        printf( "\nTotal Lines : %d\n", dwNumTotalLines );

        return( 0 );

}

