//---------------------------------------------------------------------------
//
//	$FileName	::	BIOS.cpp
//	$Purpose	::	PlayStation BIOS support (INTERNAL)
//	$Extra		::	Based on Pcsx Team's PlayStation emulator
//	$Version	::	0.1.002
//
//---------------------------------------------------------------------------
#include <vcl.h>
//---------------------------------------------------------------------------
#pragma hdrstop
//---------------------------------------------------------------------------
#include "BIOS.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
//!	Exportable variable reference
//---------------------------------------------------------------------------
__declspec( dllexport )	BIOS	*PsxBIOS = NULL;	//!<	Exported to other units
//---------------------------------------------------------------------------
static  DWORD	softPC0		= 0X00000000;
static	DWORD	pra		= 0X00000000;
static  int 	softInt	 	= 0;
static  EvCB 	*Event		= NULL;		//	Event chain
static  EvCB 	*HwEV		= NULL;		// 0xf0	Hardware Events
static  EvCB 	*EvEV		= NULL;		// 0xf1	???
static  EvCB 	*RcEV		= NULL;		// 0xf2	Receive Events ??
static  EvCB 	*UeEV		= NULL;		// 0xf3	User Events
static  EvCB 	*SwEV		= NULL;		// 0xf4	Software Events
static  EvCB 	*ThEV		= NULL;		// 0xff	Thread Events
static	DWORD	*heap_addr = NULL;
	malloc_chunk *chunk = NULL;
//---------------------------------------------------------------------------
/* System calls A0 */
//---------------------------------------------------------------------------
void bios_setjmp() { // 13
	unsigned long *jmp_buf= (unsigned long*)CPU->GenRegs[ 4 ];
	int i;

	jmp_buf[ 0 ] = CPU->GenRegs[ 31 ];	//	return address
	jmp_buf[ 1 ] = CPU->GenRegs[ 29 ];	//	stack pointer
	jmp_buf[ 2 ] = CPU->GenRegs[ 30 ]; 	//	frame pointer

	for ( i=0; i<8; i++ ) 	// 	stack arguments s0 - s7
		jmp_buf[ 3 + i ] = CPU->GenRegs[ 16 + i ];

	jmp_buf[ 11 ] = CPU->GenRegs[ 28 ];	//	general pointer

	CPU->GenRegs[ 2 ] = 0;

        CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void bios_strcat() { // 15
	//strcat( (char*)&RAM[ CPU->GenRegs[ 4 ] ], (char*)Ra1 );
        CPU->GenRegs[ 2 ] = CPU->GenRegs[ 4 ];
        CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void bios_strncat() { // 16
	//strncat( (char*)&RAM[ CPU->GenRegs[ 4 ] ], (char*)Ra1, CPU->GenRegs[ 6 ] );

        CPU->GenRegs[ 2 ] = CPU->GenRegs[ 4 ];
        CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void bios_strcmp() { // 17
	//CPU->GenRegs[ 2 ] = strcmp( (char*)&RAM[ CPU->GenRegs[ 4 ] ], (char*)Ra1 );
        CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void bios_strncmp() { // 18
	//CPU->GenRegs[ 2 ] = strncmp( (char*)&RAM[ CPU->GenRegs[ 4 ] ], (char*)Ra1, CPU->GenRegs[ 6 ]);
        CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void bios_strcpy() { // 19
	//strcpy( (char*)&RAM[ CPU->GenRegs[ 4 ] ], (char*)Ra1);
        CPU->GenRegs[ 2 ] = CPU->GenRegs[ 4 ];
        CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void bios_strncpy() { // 1a
	//strncpy( (char*)&RAM[ CPU->GenRegs[ 4 ] ], (char*)Ra1, CPU->GenRegs[ 6 ] );
        CPU->GenRegs[ 2 ] = CPU->GenRegs[ 4 ];
        CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void bios_strlen() { // 1b
	//CPU->GenRegs[ 2 ] = strlen( (char*)&RAM[ CPU->GenRegs[ 4 ] ] );
        CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void bios_memcpy() { // 2a
//	memcpy( (char*)&RAM[ CPU->GenRegs[ 4 ] ], (char*)Ra1, CPU->GenRegs[ 6 ] );

        CPU->GenRegs[ 2 ] = CPU->GenRegs[ 4 ];
        CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void bios_memset() { // 2b
//	memset( (void*)&RAM[ CPU->GenRegs[ 4 ] ], CPU->GenRegs[ 5 ], CPU->GenRegs[ 6 ] );
        CPU->GenRegs[ 2 ] = CPU->GenRegs[ 4 ];
        CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void bios_memmove() { // 2c
//	memmove( (void*)&RAM[ CPU->GenRegs[ 4 ] ], (void*)Ra1, CPU->GenRegs[ 6 ] );
        CPU->GenRegs[ 2 ] = CPU->GenRegs[ 4 ];
        CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void bios_memcmp() { // 2d
//	CPU->GenRegs[ 2 ] = memcmp( (void*)&RAM[ CPU->GenRegs[ 4 ] ], (void*)Ra1, CPU->GenRegs[ 6 ] );
        CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void bios_memchr() { // 2e
	//void *ret = memchr(CPU->GenRegs[ 4 ], CPU->GenRegs[ 5 ], CPU->GenRegs[ 6 ]);
	//if (ret != NULL) CPU->GenRegs[ 2 ] = (unsigned long)((char*)ret - CPU->GenRegs[ 4 ]) + CPU->GenRegs[ 4 ];
	//else
        CPU->GenRegs[ 2 ] = 0;
	CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void bios_rand() { // 2f
	CPU->GenRegs[ 2 ] = 1+(int) (32767.0*rand()/(RAND_MAX+1.0));
	CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void bios_srand() { // 30
	srand(CPU->GenRegs[ 4 ]); CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void 	bios_malloc( void )	// 33	LPVOID	malloc( size_t )
{	malloc_chunk *chunk = NULL;
	malloc_chunk *fd = NULL;

	fprintf( stderr, "malloc %lx\n", CPU->GenRegs[ 4 ] );

	chunk = (malloc_chunk *)heap_addr;
	if ( chunk == NULL ) {
        	CPU->GenRegs[ 2 ] = 0;
                return;
        }

	for (; ((CPU->GenRegs[ 4 ] > chunk->size) || (chunk->stat == INUSE)) || (chunk->fd != NULL); chunk = chunk->fd);

        printf ("chunk %lx\n",chunk->size);

	/* split free chunk */
	fd = chunk + sizeof(malloc_chunk) + CPU->GenRegs[ 4 ];

	fd->stat = chunk->stat;
	fd->size = chunk->size - CPU->GenRegs[ 4 ];
	fd->fd = chunk->fd;
	fd->bk = chunk;

	/* set new chunk */
	chunk->stat = INUSE;
	chunk->size = CPU->GenRegs[ 4 ];
	chunk->fd   = fd;

	//CPU->GenRegs[ 2 ]  = ((unsigned long)chunk - (unsigned long)RAM) + sizeof(malloc_chunk);
	CPU->GenRegs[ 2 ] |= 0x80000000;

	printf ("malloc %lx,%lx\n", CPU->GenRegs[ 2 ], CPU->GenRegs[ 4 ]);

	CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
//	r4 'a0' = Start address of heap in RAM
//	r5 'a1' = end address of heap in RAM
//---------------------------------------------------------------------------
void 	bios_InitHeap( void )	// 	SysCall 0x39	KERNEL :: InitHeap( LPVOID *lpstart, LPVOID lpEnd )
{
	//	a0 = ( RAM_BASE + KERNEL_SIZE )
        //	a1 = ( HEAP_SIZE ), usually 16K

	//	Set heap start address
	heap_addr = (DWORD*)&PsxMem->lpPsxRAM[ ( CPU->GenRegs[ 4 ] & 0x001FFFFF ) ];

	//heap_addr = (unsigned long*)CPU->GenRegs[ 4 ];

	chunk = (malloc_chunk*)&heap_addr;

	chunk->stat = 0;

	if ( ( ( CPU->GenRegs[ 4 ] & 0x001FFFFF ) + CPU->GenRegs[ 5 ] ) >= 0x200000 )
        	chunk->size = 0x1ffffc - (CPU->GenRegs[ 4 ] & 0x1fffff);
	else
        	chunk->size = CPU->GenRegs[ 5 ];

	chunk->fd = NULL;
	chunk->bk = NULL;

	CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void bios_printf() { // 3f
	char par[1024];
	char par2[1024];
	char tmp[1024];

	int parE = 0;
	int parS = 0;
	int parC = 4;

	//memcpy( par, (void*)&RAM[ CPU->GenRegs[ 4 ] ], 1024 );

	//uRAM32( CPU->GenRegs[ 29 ]      ) = CPU->GenRegs[ 4 ];
	//uRAM32( CPU->GenRegs[ 29 ] + 4  ) = CPU->GenRegs[ 5 ];
	//uRAM32( CPU->GenRegs[ 29 ] + 8  ) = CPU->GenRegs[ 6 ];
	//uRAM32( CPU->GenRegs[ 29 ] + 12 ) = CPU->GenRegs[ 7 ];

	while ( par[ parE ] ) {
		if ( par[ parE ] == '%' && par[ parE + 1 ] != '%' && par[ parE + 1 ] != 's') {
		    parE += 2;
		    parC += 4;
		}
		if ( !par[ parE ] ) break;
		if ( par[ parE ] == '%' && par[ parE + 1 ] == 's') {
			//uRAM32( CPU->GenRegs[ 29 ] + parC ) = (DWORD)RAM8( uRAM32( CPU->GenRegs[ 29 ] + parC ) );
			parE += 2;
			parC += 4;
		}
		else
			parE++;
	}

	parS = 0; parE = 0;

	while ( par[ parS ] ) {
		if ( par[ parS ] == '\n')
			par2[ parE++ ] = '\r';
		par2[ parE++ ] = par[ parS++ ];
	}

	par2[ parE++ ] = 0;

	//sprintf( tmp, par2, uRAM32(CPU->GenRegs[ 29 ] + 4), uRAM32(CPU->GenRegs[ 29 ] + 8), uRAM32(CPU->GenRegs[ 29 ] + 12), uRAM32(CPU->GenRegs[ 29 ] + 16), uRAM32(CPU->GenRegs[ 29 ] + 20), uRAM32(CPU->GenRegs[ 29 ] + 24), uRAM32(CPU->GenRegs[ 29 ] + 28));

	printf( tmp );

	CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void bios_FlushCache() { // 44
	CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void bios_GPU_cw() { // 49
	//	GPU_writeData(CPU->GenRegs[ 4 ]);	//	NOT IMPLEMENTED YET
	CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void bios_GetC0Table() { // 56
	CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void bios_GetB0Table() { // 57
	CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void bios__96_remove() { // 72
	CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
/* System calls B0 */
//---------------------------------------------------------------------------
void bios_SetRCnt() { // 02
	CPU->GenRegs[ 4 ]&= 0x3;
	if ( CPU->GenRegs[ 4 ] != 3 ) {
		unsigned long mode=0;

		psx_counters->WriteTarget( CPU->GenRegs[ 4 ], CPU->GenRegs[ 5 ] );

		if ( CPU->GenRegs[ 6 ] &  0x1000 )
                	mode |= 0x050; // Interrupt Mode

		if ( CPU->GenRegs[ 6 ] &  0x0100 )
                	mode |= 0x008; // Count to 0xffff

		if ( CPU->GenRegs[ 6 ] &  0x0010 )
                	mode |= 0x001; // Timer stop mode

		if ( CPU->GenRegs[ 4 ] == 2 ) {
                	if ( CPU->GenRegs[ 6 ] & 0x0001 )
                        	mode |= 0x200;
                } else {// System Clock mode
                	if ( CPU->GenRegs[ 6 ] & 0x0001 )
                        	mode |= 0x100;
                }

		psx_counters->WriteMode( CPU->GenRegs[ 4 ], mode );
	}
	CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void bios_GetRCnt() { // 03
	CPU->GenRegs[ 4 ]&= 0x3;
	if ( CPU->GenRegs[ 4 ] != 3 )
        	CPU->GenRegs[ 2 ] = psx_counters->ReadCount( CPU->GenRegs[ 4 ] );
	else
        	CPU->GenRegs[ 2 ] = 0;
	CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void bios_StartRCnt() { // 04
	CPU->GenRegs[ 4 ]&= 0x3;
	if (CPU->GenRegs[ 4 ] != 3) lpHW->dwHWM[0x1074]|= (1<<(CPU->GenRegs[ 4 ]+4));
	else lpHW->dwHWM[0x1074]|= 0x1;
	CPU->GenRegs[ 2 ] = 1; CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void bios_StopRCnt() { // 05
	CPU->GenRegs[ 4 ]&= 0x3;
	if (CPU->GenRegs[ 4 ] != 3) lpHW->dwHWM[0x1074]&= ~(1<<(CPU->GenRegs[ 4 ]+4));
	else lpHW->dwHWM[0x1074]&= ~0x1;
	CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void bios_ResetRCnt() { // 06
	CPU->GenRegs[ 4 ]&= 0x3;
	if (CPU->GenRegs[ 4 ] != 3) {
		psx_counters->WriteMode( CPU->GenRegs[ 4 ], 0 );

		psx_counters->WriteTarget( CPU->GenRegs[ 4 ], 0 );

                psx_counters->WriteCount( CPU->GenRegs[ 4 ], 0 );
	}
	CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
/* gets ev for use with Event */
//---------------------------------------------------------------------------
#define GetEv() \
	ev = CPU->GenRegs[ 4 ]>>28; \
	if (ev == 0xf) ev = 0x5; \
	ev*= 32; \
	ev+= CPU->GenRegs[ 4 ]&0x1f; \
        fprintf( stderr, "BIOS GetEV() ev = 0x%8x\n", ev );
//---------------------------------------------------------------------------
void	bios_DeliverEvent()
{ // 07
	int ev;

        CPU->GenRegs[ 31 ] = CPU->PC;	//	Save old PC
	GetEv();			//	Which event
        CPU->PC = Event[ ev ].fhandler;	//	call

}
//---------------------------------------------------------------------------
void bios_OpenEvent() { // 08
	int ev;

	fprintf( stderr, "syscall b0:08; OpenEvent (class:%lx, spec:%lx, mode:%lx, func:%lx)\n",
        	CPU->GenRegs[ 4 ],	//	EVENT CLASS
                CPU->GenRegs[ 5 ],	//	EVENT SPEC
                CPU->GenRegs[ 6 ],	//	EVENT MODE
                CPU->GenRegs[ 7 ]);	//	EVENT FUNCTION

	GetEv();

	Event[ ev ].status   = EvStWAIT;
	Event[ ev ].mode     = CPU->GenRegs[ 6 ];
	Event[ ev ].fhandler = CPU->GenRegs[ 7 ];

	CPU->GenRegs[ 2 ] = CPU->GenRegs[ 4 ];
	CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void bios_CloseEvent() { // 09
	int ev;

	GetEv();

	Event[ev].status = EvStUNUSED;

	CPU->GenRegs[ 2 ] = 1; CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void bios_WaitEvent() { // 0a
	int ev;

	GetEv();

	printf ("syscall WaitEvent %lx\n", CPU->GenRegs[ 4 ]);

	Event[ev].status = EvStACTIVE;

	CPU->GenRegs[ 2 ] = 1; CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void bios_TestEvent() { // 0b
	int ev;

	GetEv();

	if ( Event[ ev ].status == EvStALREADY ) {
        	Event[ ev ].status = EvStACTIVE;
                CPU->GenRegs[ 2 ] = 1;
        } else
        	CPU->GenRegs[ 2 ] = 0;

        CPU->GenRegs[ 2 ]=1;
	CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void bios_EnableEvent() { // 0c
	int ev;

	GetEv();

	Event[ev].status = EvStACTIVE;

	CPU->GenRegs[ 2 ] = 1;
        CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void bios_DisableEvent() { // 0d
	int ev;

	GetEv();

	Event[ev].status = EvStWAIT;

	CPU->GenRegs[ 2 ] = 1; CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void bios_PAD_init() { // 15
        lpHW->dwHWM[ 0x1074 ] = ( lpHW->dwHWM[ 0x1704 ] | 0x1 );

	//pad_buf = (int*)Ra1;
	//*pad_buf = -1;

        //CPU->CP0.Status.IM |= 0x401;

	//cpuRegs.CP0.n.Status |= 0x401;
	CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void bios_PAD_dr() { // 16
	CPU->GenRegs[ 2 ] = -1;
	CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void bios_ReturnFromException() { // 17
	//memcpy(cpuRegs.GPR.r, regs, 32*4);

        //CPU->Lo = CPU->GenRegs[ 32 ];
        //CPU->Hi = CPU->GenRegs[ 33 ];
        //CPU->PC = CPU->GenRegs[ 34 ];

	//cpuRegs.GPR.n.lo = regs[32];
	//cpuRegs.GPR.n.hi = regs[33];

	//cpuRegs.pc = regs[34];

	//CPU->PC = cpuRegs.CP0.n.EPC;
	//if (cpuRegs.CP0.n.Cause & 0x80000000) CPU->PC+=4;

	//cpuRegs.CP0.n.Status = (cpuRegs.CP0.n.Status & 0xfffffff0) |
	//					  ((cpuRegs.CP0.n.Status & 0x3c) >> 2);
}
//---------------------------------------------------------------------------
void bios_ResetEntryInt() { // 18
	//jmp_int = NULL;
	CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void bios_HookEntryInt() { // 19
	//jmp_int = (unsigned long*)CPU->GenRegs[ 4 ];
	CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void bios_write() { // 35/03
    if (CPU->GenRegs[ 4 ] == 1) {
	  ;	//SysPrintf(Ra1);
    }
	CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void bios_putchar () { // 3d
    char tmp[12];

    sprintf (tmp,"%c",(char)CPU->GenRegs[ 4 ]);
    //SysPrintf(tmp);

    CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void bios_puts () { // 3e/3f
    //SysPrintf(CPU->GenRegs[ 4 ]);

    CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void bios_ChangeClearPad() { // 5b
	CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
/* System calls C0 */
//---------------------------------------------------------------------------
void bios_SysEnqIntRP() { // 02

	CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void bios_SysDeqIntRP() { // 03
	CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void bios_ChangeClearRCnt() { // 0a
	CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
void bios_dummy() {
	printf( "unk %lx call: %lx\n", CPU->PC & 0x1fffff, CPU->GenRegs[ 9 ] );
        CPU->PC = CPU->GenRegs[ 31 ];
}
//---------------------------------------------------------------------------
//!	BIOS class constructor
//
//!	Provides a most basic initialisation of the BIOS emulation layer. Does nothing
//! more than clear the memory areas used by this class.
//---------------------------------------------------------------------------
__fastcall	BIOS :: BIOS( void ) : TObject()
{
	lpEventList = new TList;

        if ( lpEventList == NULL )
        	throw "BIOS Failure. Unable to create Event List.";

        lpEventList->Clear();
        lpEventList->Capacity = MAX_EVENTS;

        lpPsxBIOS = new DWORD[ 0x00080000 ];

	ZeroMemory( BIOSA0, sizeof( void* ) * 256 );	//!<	Clear BIOS a0 call area
        ZeroMemory( BIOSB0, sizeof( void* ) * 256 );	//!<	Clear BIOS b0 call area
        ZeroMemory( BIOSC0, sizeof( void* ) * 256 );	//!<	Clear BIOS c0 call area
        ZeroMemory( lpPsxBIOS, sizeof( DWORD ) * 0x00080000 );
}
//---------------------------------------------------------------------------
//!	BIOS class destructor
//
//!	Duh, just deletes this class
//---------------------------------------------------------------------------
__fastcall	BIOS :: ~BIOS( void )
{
	if ( lpEventList != NULL ) {
        	lpEventList->Clear();
                delete lpEventList;
        }

        if ( lpPsxBIOS != NULL )
        	delete []lpPsxBIOS;

	delete this;
}
//---------------------------------------------------------------------------
DWORD	__fastcall	BIOS :: GROM( DWORD Index )
{	DWORD dwValue = 0x00000000;
	dwValue = lpPsxBIOS[ ( Index & 0x0007FFFF ) ];
        return( dwValue );
}
//---------------------------------------------------------------------------
//!	BIOS method 'Initialise'.
//
//!	Initialises the bios call tables to a known state, clears them just in
//! case the areas haven't been cleared previously.
//---------------------------------------------------------------------------
int	__fastcall	BIOS :: Initialise( void )
{	DWORD	Size = 0x00000000;
	int 	i = -1;

        //this->InitHeap();

        heap_addr = new DWORD[ 16384 ];	//	This should point to the end of the exe code and data
        // segment, and be below the stack

        //	Ie RAM is laid out like this

//  0K
//        OS WORKSPACE, file tables, root directories, thread tables, mem tables, etc
// 576K   EXE HEADER
//        CODE SECTION
//        DATA SECTION (INITIALISED)
//        STACK END
//        	...
//        STACK START
//        HEAP START
//        	...
// 2MB    HEAP END	(UNINITIALISED)
// 	  HWM/BIOS/ROM etc onwards

        if ( heap_addr == NULL )
        	return( false );

        ZeroMemory( heap_addr, sizeof( DWORD ) * 16384 );
        ZeroMemory( BIOSA0, sizeof( void* ) * 256 );
        ZeroMemory( BIOSB0, sizeof( void* ) * 256 );
        ZeroMemory( BIOSC0, sizeof( void* ) * 256 );

	for( i = 0; i < 256; i++) {
		if ( BIOSA0[ i ] == NULL )
                	BIOSA0[ i ] = bios_dummy;

		if ( BIOSB0[ i ] == NULL )
                	BIOSB0[ i ] = bios_dummy;

		if ( BIOSC0[ i ] == NULL )
                	BIOSC0[ i ] = bios_dummy;
	}

	BIOSA0[ 0x3e ] = bios_puts;
	BIOSA0[ 0x3f ] = bios_printf;

	BIOSB0[ 0x3d ] = bios_putchar;
	BIOSB0[ 0x3f ] = bios_puts;

	BIOSA0[0x03] = bios_write;
	BIOSA0[0x13] = bios_setjmp;
	BIOSA0[0x15] = bios_strcat;
	BIOSA0[0x16] = bios_strncat;
	BIOSA0[0x17] = bios_strcmp;
	BIOSA0[0x18] = bios_strncmp;
	BIOSA0[0x19] = bios_strcpy;
	BIOSA0[0x1a] = bios_strncpy;
	BIOSA0[0x1b] = bios_strlen;
	BIOSA0[0x2a] = bios_memcpy;
	BIOSA0[0x2b] = bios_memset;
	BIOSA0[0x2c] = bios_memmove;
	BIOSA0[0x2d] = bios_memcmp;
	BIOSA0[0x2e] = bios_memchr;
	BIOSA0[0x2f] = bios_rand;
	BIOSA0[0x30] = bios_srand;
	BIOSA0[0x33] = bios_malloc;
	BIOSA0[0x39] = bios_InitHeap;
	BIOSA0[0x44] = bios_FlushCache;
	BIOSA0[0x49] = bios_GPU_cw;
	BIOSA0[0x72] = bios__96_remove;

	BIOSB0[0x02] = bios_SetRCnt;
	BIOSB0[0x03] = bios_GetRCnt;
	BIOSB0[0x04] = bios_StartRCnt;
	BIOSB0[0x05] = bios_StopRCnt;
	BIOSB0[0x06] = bios_ResetRCnt;
	BIOSB0[0x07] = bios_DeliverEvent;
	BIOSB0[0x08] = bios_OpenEvent;
	BIOSB0[0x09] = bios_CloseEvent;
	BIOSB0[0x0a] = bios_WaitEvent;
	BIOSB0[0x0b] = bios_TestEvent;
	BIOSB0[0x0c] = bios_EnableEvent;
	BIOSB0[0x0d] = bios_DisableEvent;
	BIOSB0[0x15] = bios_PAD_init;
	BIOSB0[0x16] = bios_PAD_dr;
	BIOSB0[0x17] = bios_ReturnFromException;
	BIOSB0[0x18] = bios_HookEntryInt;
	BIOSB0[0x19] = bios_ResetEntryInt;
	BIOSB0[0x35] = bios_write;
	BIOSB0[0x56] = bios_GetC0Table;
	BIOSB0[0x57] = bios_GetB0Table;
	BIOSB0[0x5b] = bios_ChangeClearPad;

	BIOSC0[0x02] = bios_SysEnqIntRP;
	BIOSC0[0x03] = bios_SysDeqIntRP;
	BIOSC0[0x0a] = bios_ChangeClearRCnt;

        //!	BIOS Event Support
        //
        //!	Basic event support, mainly ignored at present

	Size = sizeof( EvCB );

	Event = new EvCB[ 6 ];

	if ( Event == NULL ) {
        	MessageBox( NULL, "Error allocating memory [BIOS]", "Emulator", MB_OK );
                //	SysClose();
//                exit(1);
        }

        ZeroMemory( Event, sizeof( EvCB ) * 6 );

	HwEV = Event;
	EvEV = Event + Size;
	RcEV = Event + Size*2;
	UeEV = Event + Size*3;
	SwEV = Event + Size*4;
	ThEV = Event + Size*5;

        //if ( FileExists( "Emulator.cfg" ) )
        //	LoadState( "Emulator.cfg" );

        //if ( ( !Config.InternalBIOS ) && ( Config.lpszBIOSFileName != NULL ) )
        if ( LoadBIOS( "bios.bin" ) != 0 )
        	fprintf( stderr, "\nWARNING 'bios' missing.\n" );

        return( 0 );
}
//---------------------------------------------------------------------------
void	__fastcall	BIOS :: Terminate( void )	//!<	DUH! called before destructor
{
	free( Event );	//	free event buffers
}
//---------------------------------------------------------------------------
//	This is THE last thing to be reset in the emulator
//---------------------------------------------------------------------------
void	__fastcall	BIOS :: Reset( void )
{
	Initialise();
}
//---------------------------------------------------------------------------
//	This handles most of the software interrupts, and some instances will
// also handles hardware interrupt 5 at times.
//---------------------------------------------------------------------------
void	__fastcall	BIOS :: Interrupt( void )
{
        //	Master Interrupt Flag enabled ?
        if ( CPU->CP0.CtrlRegs.Status.IE == 0 ) {	//	master interrupt is disabled
                return;
        }

	//	If Error Level make sure cpu is in KERNEL mode
	if ( CPU->CP0.CtrlRegs.Status.ERL ) {
        	if ( CPU->CP0.CtrlRegs.Status.KSU != CPUMODE_KERNEL )
                	CPU->CP0.CtrlRegs.Status.KSU = CPUMODE_KERNEL;
        } // otherwise, not really sure what mode should be in, so no further
        // mode checking is done

        //	Hardware Interrupt 0 Enabled ?
        // for what purpose would this be ? as the BIOS, uses SW0 and HW5 ?
        // strangeness, included from the original pcsx only, may (probably)
        // will be removed soon(ish).
	//if ( !( CPU->CP0.CtrlRegs.Status.IM & 0x04 ) ) {	//
        //	return;
        //}

        //	Hardware Interrupt 5 Signaled ?
	if ( CPU->CP0.CtrlRegs.Cause.IP & 0x100 ) {
        	//	Yeap, ah but is it enabled ?
                if ( CPU->CP0.CtrlRegs.Status.IM & 0x100 ) {
                	//	Yeap, so process it
                        CPU->CP0.CtrlRegs.Cause.IP &= ~0x100;	//	Turn off
                }
                //	else just return;
		return;
	}

	//if ( lpHW->dwHWM[ 0x1070 ] & 0x1 ) { // Vsync
		//if ( pad_buf != NULL ) {
			//PadDataS pad;

			//PAD1_readPort1(&pad);
			//*pad_buf = ((pad.buttonStatus & 0xff) << 8) | (pad.buttonStatus >> 8);
			//PAD2_readPort2(&pad);
			//*pad_buf|=(((pad.buttonStatus & 0xff) << 8) | (pad.buttonStatus >> 8)) << 16;
		//}
	//}

	if ( lpHW->dwHWM[ 0x1070 ] & 0x70 ) { // Rcnt 0,1,2
		int i;

		for ( i=0; i<3; i++) {
			if ( psx_counters->lpCounters[ i ].mode & 0x50 ) {
				if ( RcEV[ i ].status == EvStACTIVE ) {
					softInt = 1;
					softPC0 = RcEV[ i ].fhandler;
					return;
				}
			}
		}
	}

        //	Turn off error level, if on
        CPU->CP0.CtrlRegs.Status.IM &= ~0x04;
}
//---------------------------------------------------------------------------
void	__fastcall	BIOS :: Exception( void )
{
	switch ( CPU->CP0.CtrlRegs.Cause.ExcCode ) {

		case ( CAUSE_INT ) : {		//	Interrupt request

			Interrupt();		//	Get BIOS to handle if suitable for BIOS intervention otherwise ignored, by BIOS

			if ( softInt ) {
				//cpuRegs.CP0.n.Cause|= 0x100;
				CPU->PC = softPC0;
				pra = CPU->GenRegs[ 31 ];
				CPU->GenRegs[ 31 ] = 0x00000080;
				softInt = 0;
				printf("soft int\n");
				return;
			}

			//if ( jmp_int != NULL ) {
			//	int i;
                        //
			//	CPU->GenRegs[ 31 ] = jmp_int[ 0 ];
			//	CPU->GenRegs[ 29 ] = jmp_int[ 1 ];
			//	CPU->GenRegs[ 30 ] = jmp_int[ 2 ]; // fp
			//	for ( i=0; i<8; i++ ) // s0-s7
			//		 CPU->GenRegs[ 16 + i ] = jmp_int[ 3 + i ];
			//	CPU->GenRegs[ 28 ] = jmp_int[ 11 ];
                        //
			//	CPU->GenRegs[ 2 ] = 1;
			//	CPU->PC = CPU->GenRegs[ 31 ];
			//	//hwWrite16(0x1f801070, 0xffff);
			//	printf("jmp int\n");
			//	return;
			//}
			//else hwWrite16(0x1f801070, 0);
			break;
                }

		case ( CAUSE_SYS ) : {	// 	Syscall request
			switch ( CPU->GenRegs[ 4 ] ) {
				case 1: // EnterCritical - disable irq's
					;//cpuRegs.CP0.n.Status&=~0x404; break;
				case 2: // ExitCritical - enable irq's
					;//cpuRegs.CP0.n.Status|= 0x404; break;
			}
			//CPU->PC = cpuRegs.CP0.n.EPC + 4;

			//cpuRegs.CP0.n.Status = (cpuRegs.CP0.n.Status & 0xfffffff0) |
			//					  ((cpuRegs.CP0.n.Status & 0x3c) >> 2);
			return;
                }

		default : {
			break;
                }
	}

	//CPU->PC = cpuRegs.CP0.n.EPC;

	//if ( cpuRegs.CP0.n.Cause & 0x80000000 )
        //	CPU->PC += 4;

	//cpuRegs.CP0.n.Status = ( cpuRegs.CP0.n.Status & 0xfffffff0 ) | ( ( cpuRegs.CP0.n.Status & 0x3c ) >> 2 );
}
//---------------------------------------------------------------------------
//	Loads a file into the PsxMem->lpPsxROM area
//---------------------------------------------------------------------------
int	__fastcall	BIOS :: LoadBIOS( AnsiString asFileName )
{	FILE	*fHandle = NULL;

	if ( ( asFileName.Length() <= 0 ) || ( !FileExists( asFileName ) ) )
        	return( -1 );

        fHandle = fopen( asFileName.c_str(), "rb" );

        if ( fHandle == NULL )
        	return( -1 );

        fprintf( stderr, "Loading BIOS from file : %s ", asFileName.c_str() );

        //Config.InternalBIOS = 0;
        //Config.lpszBIOSFileName = asFileName.c_str();

        fread( lpPsxBIOS, 1, 0x80000, fHandle );
        fclose( fHandle );

        fprintf( stderr, "load complete.\n" );
	return( 0 );
}
//---------------------------------------------------------------------------
