//---------------------------------------------------------------------------
#ifndef CountersH
#define CountersH
//---------------------------------------------------------------------------
#ifndef EMULATOR_DLL_H
#include "EmulatorDLL.h"
#endif
//---------------------------------------------------------------------------
//	PlayStation Counter Operating Modes
//---------------------------------------------------------------------------
#define CNTMODE_TO_TARGET	0x08
#define CNTMODE_TO_MAX		~CNTMODE_TO_TARGET
#define CNTDIR_INCREMENTING	0x01
#define CNTDIR_DECREMENTING	~CNTDIR_INCREMENTING
//---------------------------------------------------------------------------
#define CNTTYPE_CLOCK_CYCLE	0x0100
#define CNTTYPE_INSTR_CYCLE	0x0200
#define CNTTYPE_MEM_READ	0x0400
#define CNTTYPE_MEM_WRITE	0x0800
#define CNTTYPE_BRANCH		0x1000
#define CNTTYPE_CACHE		0x2000
#define CNTTYPE_TLB		0x4000
//---------------------------------------------------------------------------
//	PlayStation Root Counter Structure Definition
//---------------------------------------------------------------------------
typedef struct _psx_counter_def_ {
	unsigned long count, mode, target;
	unsigned long sCycle, eCycle, rate, interrupt;
} Counter, *lpCounter;
//---------------------------------------------------------------------------
#define MAX_COUNTERS	4
//---------------------------------------------------------------------------
#define	RCOUNTER_0_SYSCLOCK	0
#define RCOUNTER_1_             1
#define RCOUNTER_2_             2
#define RCOUNTER_3_VSYNC	3
//---------------------------------------------------------------------------
class	PSX_Counter : public TObject
	{
		friend	class	BIOS;
        	friend	class	HW;
                friend	class	PSX_CDROM;

        	protected:
                	void	__fastcall	Reset		( int Index );
                        void	__fastcall	UpDate		( int Index );
                        void	__fastcall	Set		( void );
                        void	__fastcall	UpdateVSyncRate	( void );

                        void	__fastcall	WriteCount	( int Index, DWORD Value );
                        void	__fastcall	WriteMode	( int Index, DWORD Value );
                        void	__fastcall	WriteTarget	( int Index, DWORD Value );

                        DWORD	__fastcall	ReadCount	( int Index );
                private:
                	Counter	*lpCounters;
                public:
                		__fastcall	PSX_Counter	( void );
                                __fastcall	~PSX_Counter	( void );

                	int	__fastcall	Initialise	( void );
                        void	__fastcall	Terminate	( void );

                        void	__fastcall	ResetAll	( void );

                        friend	void	bios_SetRCnt	( void );
                        friend	void	bios_GetRCnt	( void );
                        friend	void	bios_ResetRCnt	( void );
        };
//---------------------------------------------------------------------------
__declspec( dllimport )	PSX_Counter	*psx_counters;
//---------------------------------------------------------------------------
#endif	//	CountersH
//---------------------------------------------------------------------------
