//---------------------------------------------------------------------------
//
//	$FileName	::	DMA.h
//	$Purpose	::	PlayStation DMA Emulation
//
//---------------------------------------------------------------------------
#ifndef DMAH
#define DMAH
//---------------------------------------------------------------------------
#ifndef Emulator_DLL_H
#include "EmulatorDLL.h"
#endif
//---------------------------------------------------------------------------
#define NUM_DMA_CHANNELS	7
//---------------------------------------------------------------------------
//!	PlayStation DMA Channel Emulation Definition.
//---------------------------------------------------------------------------
typedef	struct	_psx_dma_channel_def_ {
	DWORD	Addr;			//!	Address for transfer
        DWORD	Count;			//!	number of bytes to transfer
        DWORD	Control;		//!	direction, and type of transfer
        } DMAChannel, *lpDMAChannel;
//---------------------------------------------------------------------------
class	CPSX_DMA : public TObject
	{
        	friend	class	PSX_MEM;
                friend	class	CPSX_MDEC;	//	MDEC <--> DMA Interface
                friend	class	BIOS;
                friend	class	R3000A;
                friend	class	GTE;
                friend	class	HW;
                protected:
                	void	__fastcall	DoDMA	( int Index );
                private:
                		lpDMAChannel	lpDMAChannels;
                                DWORD	IrqCtrl;
                                DWORD	IrqMask;

                                DWORD	__fastcall	GAddress	( int Index );
                                DWORD	__fastcall	GCount		( int Index );
                                DWORD	__fastcall	GControl	( int Index );

                                void	__fastcall	SAddress	( int Index, DWORD Value );
                                void	__fastcall	SCount		( int Index, DWORD Value );
                                void	__fastcall	SControl	( int Index, DWORD Value );
                public:
                		__fastcall	CPSX_DMA	( void );
                                __fastcall	~CPSX_DMA	( void );
                	int	__fastcall	Initialise	( void );
                        void	__fastcall	Terminate	( void );
                        void	__fastcall	Reset		( int Channel = -1 );

                        void	__inline	SignalInterrupt ( int Channel = -1 ) {
                        	DoDMA( Channel );
                        };
                __published:
                	__property	DWORD	Address[ int Index ] = { read=GAddress, write=SAddress };
                        __property	DWORD	Count  [ int Index ] = { read=GCount,   write=SCount   };
                        __property	DWORD	Control[ int Index ] = { read=GControl, write=SControl };
        };
//---------------------------------------------------------------------------
__declspec( dllimport ) CPSX_DMA	*PSX_DMA;
//---------------------------------------------------------------------------
#endif
//---------------------------------------------------------------------------
