//---------------------------------------------------------------------------
#include <vcl.h>
//---------------------------------------------------------------------------
#pragma hdrstop
//---------------------------------------------------------------------------
#include "ELF.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
__declspec( dllexport )	int	__fastcall	LoadELF( char *ExeFilePath )
{	elfhdr		*lpELFHeader;
	FILE		*fHandle;
        elf_phdr        *lpELFPHeader;
        elf_shdr	*lpELFSHeader;

	if ( ExeFilePath == NULL )
        	return( -1 );

        fHandle = fopen( ExeFilePath, "rb" );	//	Open in binary mode
        if ( fHandle == NULL )
        	return( -1 );

        lpELFHeader = new elfhdr;
        if ( lpELFHeader == NULL ) {
        	fclose( fHandle );
                return( -1 );
        }

        ZeroMemory( lpELFHeader, sizeof( elfhdr ) );

        //	Read header, and make sure it is an elf file
        fread( lpELFHeader, 1, sizeof( elfhdr ), fHandle );

        if ( strcmp( (char*)lpELFHeader->e_ident, ELFMAG ) != 0 ) {
        	//	Not elf file
                printf( "%s is not in ELF format.\n", ExeFilePath );
                delete lpELFHeader;
                fclose( fHandle );
                return( -1 );
        }

        //	Make sure it is an executable file
        if ( lpELFHeader->e_type != ET_EXEC ) {	//	Not an executable file
        	printf( "%s is not an executable, type is : %d.\n", ExeFilePath, lpELFHeader->e_type );
                fclose( fHandle );
                delete lpELFHeader;
                return( -1 );
        }

        //	Is it for the MIPS 32 R3000 CPU'S ?
        if ( lpELFHeader->e_machine != EM_MIPS ) {
        	printf( "%s is not a MIPS ELF file. It is %d.\n", ExeFilePath, lpELFHeader->e_machine );
                fclose( fHandle );
                delete lpELFHeader;
                return( -1 );
        }

        //	Now we need to decode sections the file and load into the emulator's ram
        // space, really need to set the CPU regs correctly as well

        //	Decode the program header section
        lpELFPHeader = new elf_phdr;
        if ( lpELFPHeader == NULL ) {
        	delete lpELFHeader;
                fclose( fHandle );
                return( -1 );
        }

        ZeroMemory( lpELFPHeader, sizeof( elf_phdr ) );

        //	seek to program header offset and then read the header
        fseek( fHandle, SEEK_CUR, lpELFHeader->e_phoff );
        fread( lpELFPHeader, 1, sizeof( elf_phdr ), fHandle );

        fclose( fHandle );
        delete lpELFHeader;

	return( 1 );
}
//---------------------------------------------------------------------------
