//---------------------------------------------------------------------------
//
//	$FILENAME	::	kernel.h
//	$PURPOSE	::	PlayStation Emulated Kernel Level Header File
//
//---------------------------------------------------------------------------
#ifndef KernelH
#define KernelH
//---------------------------------------------------------------------------
#ifndef	EMULATOR_DLL_H
#include "EmulatorDLL.h"
#endif
//---------------------------------------------------------------------------
class	PSX_Kernel : public TObject
	{
        	friend	class	BIOS;	//	BIOS <--> Kernel interaction
        	protected:
                	virtual	void	__fastcall	InstallExceptionHandlers( void );
                        virtual	void	__fastcall	InstallDevices		( void );
                        virtual	void	__fastcall	SysInitMemory		( void );
                        virtual	void	__fastcall	InitDefInt		( void );

                        virtual	void	__fastcall	FlushStdInOutPut	( void );
                        virtual	void	__fastcall	KernelRedirection	( int Flag );
                        virtual	LPVOID	__fastcall	PatchA0Table		( WORD Index, LPVOID lpPtr );
                private:

                	HANDLE		hKernel;
                        WNDCLASS	wKernel;



                	DWORD		*lpKMemory;	//	Private KERNEL memory

                	void	__fastcall	InitException		( void );
                        void	__fastcall	ExceptionHandler	( void );

                        void	__fastcall	SysInitKMem		( void );

                        void	__fastcall	SysEnqIntRP		( WORD Index, LPVOID lpBuffer );
                        void	__fastcall	SysDeqIntRP		( WORD Index, LPVOID lpBuffer );

                        LPVOID	__fastcall	get_free_EvCB_slot	( void );
                        LPVOID	__fastcall	get_free_TCB_slot	( void );

                        void	__fastcall	ChangeClearRCnt		( void );

                        void	__fastcall	_cdevinput		( void );
                        void	__fastcall	_cdevscan		( void );
                        void	__fastcall	ioabort			( void );

                        char	__fastcall	_circgetc		( LPVOID lpBuffer );
                        void	__fastcall	_circputc		( char ch, LPVOID lpBuffer );
                public:
                		__fastcall	PSX_Kernel		( void );
                        	__fastcall	~PSX_Kernel		( void );

                        int	__fastcall	Initialise		( void );
                        void	__fastcall	Terminate		( void );
                        void	__fastcall	Reset			( void );

                        DWORD	__fastcall	SystemError		( LPSTR lpszMessage );

                        int	__fastcall	Exec			( LPVOID lpBuffer );

                        void	__fastcall	ConsoleMode	( void );
        };
//---------------------------------------------------------------------------
__declspec( dllimport )	PSX_Kernel	*lpKernel;
//---------------------------------------------------------------------------
#endif
//---------------------------------------------------------------------------
