//---------------------------------------------------------------------------
//
//	$FileName	::	MDec.cpp
//	$Author		::	Chris Brooklyn
//	$Purpose	::	To provide MPEG video decompression
//
//---------------------------------------------------------------------------
#include <vcl.h>
//---------------------------------------------------------------------------
#pragma hdrstop
//---------------------------------------------------------------------------
#include "MDec.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
__declspec( dllexport )	CPSX_MDEC	*PSX_MDEC = NULL;
static	FILE	*fMDECLog = NULL;
//---------------------------------------------------------------------------
static	void	idct1( int *block )
{
	int val = RANGE( DESCALE( block[ 0 ], PASS1_BITS + 3 ) );
	int i;
	for ( i=0; i<DCTSIZE2; i++ )
        	block[ i ] = val;
}
//---------------------------------------------------------------------------
void 	idct( int *block, int k )
{	int tmp0, tmp1, tmp2, tmp3, tmp4, tmp5, tmp6, tmp7;
	int z5, z10, z11, z12, z13;
        int *ptr;
        int i;

        if ( !k ) {
        	idct1(block);
                return;
        }

        ptr = block;
        for (i = 0; i< DCTSIZE; i++,ptr++) {
        	if ((ptr[DCTSIZE*1] | ptr[DCTSIZE*2] | ptr[DCTSIZE*3] | ptr[DCTSIZE*4] | ptr[DCTSIZE*5] | ptr[DCTSIZE*6] | ptr[DCTSIZE*7]) == 0) {
                	ptr[DCTSIZE*0] = ptr[DCTSIZE*1] = ptr[DCTSIZE*2] = ptr[DCTSIZE*3] =
                        ptr[DCTSIZE*4] = ptr[DCTSIZE*5] = ptr[DCTSIZE*6] = ptr[DCTSIZE*7] =

                        	ptr[DCTSIZE*0];

                        continue;
                }

                z10 = ptr[DCTSIZE*0] + ptr[DCTSIZE*4];
                z11 = ptr[DCTSIZE*0] - ptr[DCTSIZE*4];
                z13 = ptr[DCTSIZE*2] + ptr[DCTSIZE*6];
                z12 = MULTIPLY(ptr[DCTSIZE*2] - ptr[DCTSIZE*6], FIX_1_414213562) - z13;

		tmp0 = z10 + z13;
                tmp3 = z10 - z13;
                tmp1 = z11 + z12;
                tmp2 = z11 - z12;

		z13 = ptr[DCTSIZE*3] + ptr[DCTSIZE*5];
                z10 = ptr[DCTSIZE*3] - ptr[DCTSIZE*5];
                z11 = ptr[DCTSIZE*1] + ptr[DCTSIZE*7];
                z12 = ptr[DCTSIZE*1] - ptr[DCTSIZE*7];

                z5 = MULTIPLY(z12 - z10, FIX_1_847759065);
                tmp7 = z11 + z13;
                tmp6 = MULTIPLY(z10, FIX_2_613125930) + z5 - tmp7;
                tmp5 = MULTIPLY(z11 - z13, FIX_1_414213562) - tmp6;
                tmp4 = MULTIPLY(z12, FIX_1_082392200) - z5 + tmp5;

                ptr[DCTSIZE*0] = (tmp0 + tmp7);
                ptr[DCTSIZE*7] = (tmp0 - tmp7);
                ptr[DCTSIZE*1] = (tmp1 + tmp6);
                ptr[DCTSIZE*6] = (tmp1 - tmp6);
                ptr[DCTSIZE*2] = (tmp2 + tmp5);
                ptr[DCTSIZE*5] = (tmp2 - tmp5);
                ptr[DCTSIZE*4] = (tmp3 + tmp4);
                ptr[DCTSIZE*3] = (tmp3 - tmp4);
        }

        ptr = block;
        for (i = 0; i < DCTSIZE; i++ ,ptr+=DCTSIZE) {
        	if ((ptr[1] | ptr[2] | ptr[3] | ptr[4] | ptr[5] | ptr[6] | ptr[7]) == 0) {
                	ptr[0] = ptr[1] = ptr[2] = ptr[3] = ptr[4] = ptr[5] = ptr[6] = ptr[7] =
                        	RANGE(DESCALE(ptr[0], PASS1_BITS+3));;

                        continue;
                }

                z10 = ptr[0] + ptr[4];
                z11 = ptr[0] - ptr[4];
                z13 = ptr[2] + ptr[6];
                z12 = MULTIPLY(ptr[2] - ptr[6], FIX_1_414213562) - z13;

                tmp0 = z10 + z13;
                tmp3 = z10 - z13;
                tmp1 = z11 + z12;
                tmp2 = z11 - z12;

                z13 = ptr[3] + ptr[5];
                z10 = ptr[3] - ptr[5];
                z11 = ptr[1] + ptr[7];
                z12 = ptr[1] - ptr[7];

                z5 = MULTIPLY(z12 - z10, FIX_1_847759065);
                tmp7 = z11 + z13;
                tmp6 = MULTIPLY(z10, FIX_2_613125930) + z5 - tmp7;
                tmp5 = MULTIPLY(z11 - z13, FIX_1_414213562) - tmp6;
                tmp4 = MULTIPLY(z12, FIX_1_082392200) - z5 + tmp5;

                ptr[0] = RANGE(DESCALE(tmp0 + tmp7, PASS1_BITS+3));;
                ptr[7] = RANGE(DESCALE(tmp0 - tmp7, PASS1_BITS+3));;
                ptr[1] = RANGE(DESCALE(tmp1 + tmp6, PASS1_BITS+3));;
                ptr[6] = RANGE(DESCALE(tmp1 - tmp6, PASS1_BITS+3));;
                ptr[2] = RANGE(DESCALE(tmp2 + tmp5, PASS1_BITS+3));;
                ptr[5] = RANGE(DESCALE(tmp2 - tmp5, PASS1_BITS+3));;
                ptr[4] = RANGE(DESCALE(tmp3 + tmp4, PASS1_BITS+3));;
                ptr[3] = RANGE(DESCALE(tmp3 - tmp4, PASS1_BITS+3));;
        }
}

unsigned short* rl2blk(int *blk,unsigned short *mdec_rl);
void iqtab_init(int *iqtab,unsigned char *iq_y);
//void round_init(void);
void yuv2rgb24(int *blk,unsigned char *image);
void yuv2rgb15(int *blk,unsigned short *image);

struct {
	unsigned long command;
	unsigned long status;
	unsigned short *rl;
	int rlsize;
} mdec;

//int iq_y[DCTSIZE2],iq_uv[DCTSIZE2];	lpIQTable and lpIQYTable

//void mdecInit(void) {
//	mdec.rl = (unsigned short*)&RAM[0x100000];
//	mdec.command = 0;
//	mdec.status = 0;
//	round_init();
//}

/* C mdec Decoder */

static int zscan[DCTSIZE2] = {
	0 ,1 ,8 ,16,9 ,2 ,3 ,10,
	17,24,32,25,18,11,4 ,5 ,
	12,19,26,33,40,48,41,34,
	27,20,13,6 ,7 ,14,21,28,
	35,42,49,56,57,50,43,36,
	29,22,15,23,30,37,44,51,
	58,59,52,45,38,31,39,46,
	53,60,61,54,47,55,62,63
};

static int aanscales[DCTSIZE2] = {
	  16384, 22725, 21407, 19266, 16384, 12873,  8867,  4520,
	  22725, 31521, 29692, 26722, 22725, 17855, 12299,  6270,
	  21407, 29692, 27969, 25172, 21407, 16819, 11585,  5906,
	  19266, 26722, 25172, 22654, 19266, 15137, 10426,  5315,
	  16384, 22725, 21407, 19266, 16384, 12873,  8867,  4520,
	  12873, 17855, 16819, 15137, 12873, 10114,  6967,  3552,
	   8867, 12299, 11585, 10426,  8867,  6967,  4799,  2446,
	   4520,  6270,  5906,  5315,  4520,  3552,  2446,  1247
};

void iqtab_init(int *iqtab,unsigned char *iq_y)
{
	int i;

	for(i=0;i<DCTSIZE2;i++) {
		iqtab[i] =iq_y[i] *aanscales[zscan[i]]>>(CONST_BITS14-IFAST_SCALE_BITS);
	}
}

/*	// From Filefrmt.pdf

	RL data syntax:
		header
		macroblock
		...
		macroblock
		footer

	header:
		16bit: magic (0x3800)
		16bit: size

	macroblock:
		Cb block
		Cr block
		Y1 block
		Y2 block
		Y3 block
		Y4 block

	block:
		5bit: quant, 10bit: dc
		5bit: run, 10bit: level
		...
		5bit: run, 10bit: level
		nop (0xfe00)

	footer:
		nop

	block conversion:
		zigzag -> dequantize -> idct -> yuv2rgb

	zigzag transformation:

	the blk_zig value is the level value of the block

	blk_zig[0] = blk_dct[0]/iq_tab[0];
	for (i = 1; i < 64; i++) {
		j = zscan[i];
		blk_zig[i] = blk_dct[j]*16/(iqtab[j]*q_scale);
	}

	reverse it:
	blk_dct[0] = blk_zig[0]*iq_tab[0];
	for (i = 1; i < 64; i++) {
		j = zscan[i];
		blk_dct[j] = blk_zig[i]/(16/(iqtab[j]*q_scale));
	}

	(run, level) (the number of zeros preceding level, value of the element)

	run-level example:
		-229     -19     0 -2 0 0 1 0
		(0,-229) (0,-19) (1,-2) (2,1) nop

	dequantization:

	quant = q_scale

	y[0] = x[0] * 16 / (iqtab[0] * 8);
	for (i = 1; i < 64; i++)
		y[i] = x[i] / (quant * Qtable[i]);

	reverse it:
	x[0] = y[0] / (16 / (iqtab[0] * 8));
	for (i = 1; i < 64; i++)
		x[i] = y[i] * (quant * Qtable[i]);

	idct:

	yuv2rgb:

	R = Y * 1.0 + Cb * 0       + Cr * 1.402
	G = Y * 1.0 + Cb * -0.3437 + Cr * -0.7143
	B = Y * 1.0 + Cb * 1.772   + Cr * 0
*/

unsigned short* rl2blk(int *blk,unsigned short *mdec_rl) {
//	int i,k,q_scale,rl;
//	int *iqtab;

//	memset (blk, 0, 6*DCTSIZE2*4);
//	iqtab = iq_uv;
//	for(i=0;i<6;i++) {	// decode blocks (Cr,Cb,Y1,Y2,Y3,Y4)
//		if (i>1) iqtab = iq_y;

		// zigzag transformation
//		rl = *mdec_rl++;
//		q_scale = RUNOF(rl);
//		blk[0] = iqtab[0]*VALOF(rl);
//		k = 0;
//		for(;;) {
//			rl = *mdec_rl++;
//			if (rl==MDEC_RLNOP) break;
//			k += RUNOF(rl)+1;	// skip level zero-coefficients
//			if (k > 63) break;
//			blk[zscan[k]] = (VALOF(rl) * iqtab[k] * q_scale) / 8; // / 16;
//		}
//		blk[0] = (blk[0] * iq_t[0] * 8) / 16;
//		for(int j=1;j<64;j++)
//			blk[j] = blk[j] * iq_t[j] * q_scale;
		// idct
//		idct(blk,k+1);
//		blk+=DCTSIZE2;
//	}
	return NULL;//mdec_rl;
}

#ifdef FIXED
#define	MULR(a)		((((int)0x0000059B) * (a)) >> 10)
#define	MULG(a)		((((int)0xFFFFFEA1) * (a)) >> 10)
#define	MULG2(a)	((((int)0xFFFFFD25) * (a)) >> 10)
#define	MULB(a)		((((int)0x00000716) * (a)) >> 10)
#else
#define	MULR(a)		((int)((float)1.40200 * (a)))
#define	MULG(a)		((int)((float)-0.3437 * (a)))
#define	MULG2(a)	((int)((float)-0.7143 * (a)))
#define	MULB(a)		((int)((float)1.77200 * (a)))
#endif

#define	MAKERGB15(r,g,b)	( (((r)>>3)<<10)|(((g)>>3)<<5)|((b)>>3) )
#define	ROUND(c)	RoundTable[((c)+128+256)]//&0x3ff]
/*#define ROUND(c)	round(c+128)
int round(int r) {
	if (r<0) return 0;
	if (r>255) return 255;
	return r;
}*/

#define RGB15(n) \
	image[n] = MAKERGB15(ROUND(Y + R),ROUND(Y + G),ROUND(Y + B));

#define RGB15BW(n) \
	image[n] = MAKERGB15(ROUND(Y),ROUND(Y),ROUND(Y));

#define RGB24(n) \
	image[n+2] = ROUND(Y + R); \
	image[n+1] = ROUND(Y + G); \
	image[n+0] = ROUND(Y + B);

#define RGB24BW(n) \
	image[n+2] = ROUND(Y); \
	image[n+1] = ROUND(Y); \
	image[n+0] = ROUND(Y);
//---------------------------------------------------------------------------
unsigned char RoundTable[ 256 * 3 ];
//---------------------------------------------------------------------------
void	__fastcall	RoundInit( void )
{	int	i;

	for ( i=0; i<256; i++ ) {
		RoundTable[ i       ] = 0;
		RoundTable[ i + 256 ] = i;
		RoundTable[ i + 512 ] = 255;
	}
}
//---------------------------------------------------------------------------
void yuv2rgb15(int *blk,unsigned short *image) {
	int x,y;
	int Y;
	int *Yblk = blk+DCTSIZE2*2;
	int Cb,Cr,R,G,B;
	int *Cbblk = blk;
	int *Crblk = blk+DCTSIZE2;

	if ( PSX_MDEC->ColourFlag )	//	Colour image ?
	for (y=0;y<16;y+=2,Crblk+=4,Cbblk+=4,Yblk+=8,image+=24) {
		if (y==8) Yblk+=DCTSIZE2;
		for (x=0;x<4;x++,image+=2,Crblk++,Cbblk++,Yblk+=2) {
			Cr = *Crblk;
			Cb = *Cbblk;
			R = MULR(Cr);
			G = MULG(Cb) + MULG2(Cr);
			B = MULB(Cb);

			Y = Yblk[0]; RGB15(0);
			Y = Yblk[1]; RGB15(1);
			Y = Yblk[8]; RGB15(16);
			Y = Yblk[9]; RGB15(17);

			Cr = *(Crblk+4);
			Cb = *(Cbblk+4);
			R = MULR(Cr);
			G = MULG(Cb) + MULG2(Cr);
			B = MULB(Cb);

			Y = Yblk[DCTSIZE2+0]; RGB15(8);
			Y = Yblk[DCTSIZE2+1]; RGB15(9);
			Y = Yblk[DCTSIZE2+8]; RGB15(24);
			Y = Yblk[DCTSIZE2+9]; RGB15(25);
		}
	} else  {	//	else Mono Image
        	for (y=0;y<16;y+=2,Yblk+=8,image+=24) {
                	if (y==8) Yblk+=DCTSIZE2;
                        for (x=0;x<4;x++,image+=2,Yblk+=2) {
                        	Y = Yblk[0]; RGB15BW(0);
                                Y = Yblk[1]; RGB15BW(1);
                                Y = Yblk[8]; RGB15BW(16);
                                Y = Yblk[9]; RGB15BW(17);
                                Y = Yblk[DCTSIZE2+0]; RGB15BW(8);
                                Y = Yblk[DCTSIZE2+1]; RGB15BW(9);
                                Y = Yblk[DCTSIZE2+8]; RGB15BW(24);
                                Y = Yblk[DCTSIZE2+9]; RGB15BW(25);
                        }
                }
        }

}

void yuv2rgb24(int *blk,unsigned char *image) {
	int x,y;
	int Y;
	int *Yblk = blk+DCTSIZE2*2;
	int Cb,Cr,R,G,B;
	int *Cbblk = blk;
	int *Crblk = blk+DCTSIZE2;

	if ( PSX_MDEC->ColourFlag )
	for (y=0;y<16;y+=2,Crblk+=4,Cbblk+=4,Yblk+=8,image+=24*3) {
		if (y==8) Yblk+=DCTSIZE2;
		for (x=0;x<4;x++,image+=6,Crblk++,Cbblk++,Yblk+=2) {
			Cr = *Crblk;
			Cb = *Cbblk;
			R = MULR(Cr);
			G = MULG(Cb) + MULG2(Cr);
			B = MULB(Cb);

			Y = Yblk[0]; RGB24(0);
			Y = Yblk[1]; RGB24(1*3);
			Y = Yblk[8]; RGB24(16*3);
			Y = Yblk[9]; RGB24(17*3);

			Cr = *(Crblk+4);
			Cb = *(Cbblk+4);
			R = MULR(Cr);
			G = MULG(Cb) + MULG2(Cr);
			B = MULB(Cb);

			Y = Yblk[DCTSIZE2+0]; RGB24(8*3);
			Y = Yblk[DCTSIZE2+1]; RGB24(9*3);
			Y = Yblk[DCTSIZE2+8]; RGB24(24*3);
			Y = Yblk[DCTSIZE2+9]; RGB24(25*3);
		}
	} else
	for (y=0;y<16;y+=2,Yblk+=8,image+=24*3) {
		if (y==8) Yblk+=DCTSIZE2;
		for (x=0;x<4;x++,image+=6,Yblk+=2) {
			Y = Yblk[0]; RGB24BW(0);
			Y = Yblk[1]; RGB24BW(1*3);
			Y = Yblk[8]; RGB24BW(16*3);
			Y = Yblk[9]; RGB24BW(17*3);

			Y = Yblk[DCTSIZE2+0]; RGB24BW(8*3);
			Y = Yblk[DCTSIZE2+1]; RGB24BW(9*3);
			Y = Yblk[DCTSIZE2+8]; RGB24BW(24*3);
			Y = Yblk[DCTSIZE2+9]; RGB24BW(25*3);
		}
	}
}
//---------------------------------------------------------------------------
__fastcall	CPSX_MDEC :: CPSX_MDEC( void ) : TObject()
{

	fMDECLog = fopen( "MDEC.LOG", "wt" );
        if ( fMDECLog == NULL ) {
        	fMDECLog = stderr;
                fprintf( stderr, "MDEC logfile creation failure.\n" );
        }

	fprintf( fMDECLog, "PlayStation MDEC Emulation Layer Construction\n" );

        //	Create the local memory streams, these hold the data, for transfer
        // from and to the MDEC class.

	pChan0 = new TMemoryStream;				//	MDEC IN
        pChan1 = new TMemoryStream;				//	MDEC OUT
        fColourFlag = false;					//	defaults to 16-bit colour processing
        lpIQTable  = new int[ DCTSIZE2 ];
        lpIQYTable = new int[ DCTSIZE2 ];
}
//---------------------------------------------------------------------------
__fastcall	CPSX_MDEC :: ~CPSX_MDEC( void )
{
	//if ( hMDECIn != NULL )
        //	CloseHandle( hMDECIn );

        //if ( hMDECOut != NULL )
        //	CloseHandle( hMDECOut );

        if ( lpIQTable != NULL )
        	delete []lpIQTable;

        if ( lpIQYTable != NULL )
        	delete []lpIQYTable;

	if ( pChan0 != NULL )
        	delete pChan0;

        if ( pChan1 != NULL )
        	delete pChan1;

        if ( fMDECLog != NULL )
        	fclose( fMDECLog );

        delete this;
}
//---------------------------------------------------------------------------
DWORD	__fastcall	CPSX_MDEC :: GAddress( int Index )
{
	switch ( Index ) {
        	case ( 0 ) : {
                	return( PsxMem->RAM32[ DMA0_ADDR ] );
                }
                case ( 1 ) : {
                	return( PsxMem->RAM32[ DMA1_ADDR ] );
                }
                default : {
                	return( NULL );
                }
        }
}
//---------------------------------------------------------------------------
DWORD	__fastcall	CPSX_MDEC :: GCount( int Index )
{
	switch ( Index ) {
        	case ( 0 ) : {
                	return( PsxMem->RAM32[ DMA0_SIZE ] );
                }
                case ( 1 ) : {
                	return( PsxMem->RAM32[ DMA1_SIZE ] );
                }
                default : {
                	return( NULL );
                }
        }
}
//---------------------------------------------------------------------------
DWORD	__fastcall	CPSX_MDEC :: GControl( int Index )
{
	switch ( Index ) {
        	case ( 0 ) : {
                	return( PsxMem->RAM32[ DMA0_CTRL ] );
                }
                case ( 1 ) : {
                	return( PsxMem->RAM32[ DMA0_CTRL ] );
                }
                default : {
                	return( NULL );
                }
        }
}
//---------------------------------------------------------------------------
void	__fastcall	CPSX_MDEC :: SAddress( int Index, DWORD Value )
{
	switch ( Index ) {
        	case ( 0 ) : {
                	lpHW->lpPsxHWM[ 0x1080 ] = Value;
                        break;
                }
                case ( 1 ) : {
                	lpHW->lpPsxHWM[ 0x1090 ] = Value;
                        break;
                }
        }
}
//---------------------------------------------------------------------------
void	__fastcall	CPSX_MDEC :: SCount( int Index, DWORD Value )
{
	switch ( Index ) {
        	case ( 0 ) : {
                	//	PsxMem->RAM32[ DMA0_SIZE ] = Value;
                        lpHW->lpPsxHWM[ 0x1084 ] = Value;
                        break;
                }
                case ( 1 ) : {
                	//	PsxMem->RAM32[ DMA1_SIZE ] = Value;
                        lpHW->lpPsxHWM[ 0x1094 ] = Value;
                        break;
                }
        }
}
//---------------------------------------------------------------------------
void	__fastcall	CPSX_MDEC :: SControl( int Index, DWORD Value )
{
	switch ( Index ) {
        
        	case ( 0 ) : {
                	//PsxMem->RAM32[ DMA0_CTRL ] = Value;
                        lpHW->lpPsxHWM[ 0x1088 ] = Value;
                        break;
                }

                case ( 1 ) :{
                	//PsxMem->RAM32[ DMA1_CTRL ] = Value;
                        lpHW->lpPsxHWM[ 0x1098 ] = Value;
                	break;
                }

        }
}
//---------------------------------------------------------------------------
int	__fastcall	CPSX_MDEC :: Initialise( void )
{
        ZeroMemory( lpIQTable,  sizeof( int ) * DCTSIZE2 );
        ZeroMemory( lpIQYTable, sizeof( int ) * DCTSIZE2 );

	pChan0->Clear();
        pChan1->Clear();

	pChan0->SetSize( 16384 );
        pChan1->SetSize( 16384 );

        //	MDEC IN DMA, turn off
        PsxMem->RAM32[ DMA0_ADDR ] = 0;
        PsxMem->RAM32[ DMA0_SIZE ] = 0;
        PsxMem->RAM32[ DMA0_CTRL ] = 0;

        //	MDEC OUT DMA, turn off
        PsxMem->RAM32[ DMA1_ADDR ] = 0;
        PsxMem->RAM32[ DMA1_SIZE ] = 0;
        PsxMem->RAM32[ DMA1_CTRL ] = 0;

        RoundInit();

        iqtab_init( lpIQTable, (BYTE*)&lpIQYTable );
        //iqtab_init( &lpIQTable[ DCTSIZE2 ], &lpIQYTable[ DCTSIZE2 ] );

        return( 0 );
}
//---------------------------------------------------------------------------
void	__fastcall	CPSX_MDEC :: Terminate( void )
{
	PsxMem->RAM32[ DMA0_CTRL ] = 0;
        PsxMem->RAM32[ DMA1_CTRL ] = 0;
}
//---------------------------------------------------------------------------
void	__fastcall	CPSX_MDEC :: Write( int Channel, DWORD dwData )
{
	switch ( Channel ) {

        	case ( MDEC_CHANNEL_0 ) : {

                	//	mdec.command = data;
                        //if ( ( dwData & 0xf5ff0000 ) == 0x30000000 ) {
                        //	mdec.rlsize = dwData & 0xffff;
                        //}

                	pChan0->Write( &dwData, sizeof( DWORD ) );
                        //	Write the value to the chan0 client pipe, ie ask the server
                        // to process it
                	break;
                }

                case ( MDEC_CHANNEL_1 ) : {

                //	if ( dwData & 0x80000000 ) { // mdec reset
                //        	Reset();
                //        }

                        pChan1->Write( &dwData, sizeof( DWORD ) );
                        // again write to the chan1 client pipe
                	break;
                }
        }
}
//---------------------------------------------------------------------------
DWORD	__fastcall	CPSX_MDEC :: Read( int Channel )
{	DWORD	dwValue = 0x00000000;

	switch ( Channel ) {
        	case ( MDEC_CHANNEL_0 ) : {
                	if ( PsxMem->RAM32[ DMA0_CTRL ] & MDEC_STATUS_BUSY )
                        	return( NULL );
                        if ( pChan0->Position < pChan0->Size )
                        	pChan0->Read( &dwValue, sizeof( DWORD ) );
                        break;
                }
                case ( MDEC_CHANNEL_1 ) : {
			if ( PsxMem->RAM32[ DMA1_CTRL ] & MDEC_STATUS_BUSY )
                        	return( NULL );
                        if ( pChan1->Position < pChan1->Size )
                        	pChan1->Read( &dwValue, sizeof( DWORD ) );
                        break;
                }
        }
        return( dwValue );
}
//---------------------------------------------------------------------------
void	__fastcall	CPSX_MDEC :: Process( void )
{	lpRLHeader	lpHeader;
	WORD		*lpRLBlock;
        WORD		*lpBlock;
        WORD		*piq_table;

        if ( ( PsxMem->RAM32[ DMA0_CTRL ] & MDEC_STATUS_BUSY ) || ( PsxMem->RAM32[ DMA1_CTRL ] & MDEC_STATUS_BUSY ) )
        	return;

	int k,q_scale,rl;

        lpBlock = new WORD[ ( 6 * DCTSIZE2 * 4 ) ];
        ZeroMemory( lpBlock, ( 6 * DCTSIZE2 * 4 ) );

	piq_table = (WORD*)&lpIQTable;

        lpRLBlock = (WORD*)pChan0->Memory;//&PsxMem->lpPsxRAM[ ( lpHW->dwHWM32[ DMA0_ADDR ] & 0x001FFFFF ) ];

	for ( int i=0; i<6; i++ ) {	// decode blocks (Cr,Cb,Y1,Y2,Y3,Y4)

		if ( i > 1 )
                	piq_table = (WORD*)&lpIQYTable;

                // 	zigzag transformation

		rl = *lpRLBlock++;
		q_scale = RUNOF( rl );
		lpBlock[ 0 ] = piq_table[ 0 ] * VALOF( rl );
		k = 0;
		for ( ;; ) {
			rl = *lpRLBlock++;
			if ( rl == MDEC_RLNOP )
                        	break;
			k += RUNOF( rl ) + 1;	// skip level zero-coefficients

			if ( k > 63 )
                        	break;
			lpBlock[ zscan[ k ] ] = ( VALOF( rl ) * piq_table[ k ] * q_scale ) / 8; // / 16;
		}
		lpBlock[ 0 ] = ( lpBlock[ 0 ] * lpIQTable[ 0 ] * 8 ) / 16;
		for ( int j=1; j<64; j++ )
			lpBlock[ j ] = lpBlock[ j ] * lpIQTable[ j ] * q_scale;
		// idct
		idct( (int*)&lpBlock, k + 1 );
                pChan1->Write( lpBlock, DCTSIZE2 );
		lpBlock += DCTSIZE2;
	}
}
//---------------------------------------------------------------------------
void	__fastcall	CPSX_MDEC :: Reset( int Channel )
{
	if ( Channel == -1 ) {
        	pChan0->Clear();
                pChan1->Clear();
                pChan0->SetSize( 16384 );
                pChan1->SetSize( 16384 );
                PsxMem->RAM32[ DMA0_CTRL ] = 0;
                PsxMem->RAM32[ DMA1_CTRL ] = 0;
        } else {
        	switch ( Channel ) {
                	case ( 0 ) : {
                        	pChan0->Clear();
                                pChan0->SetSize( 16384 );
                                PsxMem->RAM32[ DMA0_CTRL ] = 0;
                                break;
                        }
                        case ( 1 ) : {
                        	pChan1->Clear();
                                pChan1->SetSize( 16384 );
                                PsxMem->RAM32[ DMA1_CTRL ] = 0;
                                break;
                        }
                }
        }
}
//---------------------------------------------------------------------------
//	Read data for mdec conversion into the pChan0 memory stream
//---------------------------------------------------------------------------
void 	__fastcall	CPSX_MDEC :: hwDMA0( void )//DWORD dwAddr, DWORD dwBCR, DWORD dwCHCR )
{	int cmd  = lpHW->dwHWM32[ DMA0_CTRL ];   //mdec.command;
	int size = lpHW->dwHWM32[ DMA0_SIZE ];
        DWORD dwAddr = lpHW->dwHWM32[ DMA0_ADDR ];

        if ( cmd & 0x80000000 )	{	//	Reset requested
        	Reset( 0 );	//	Reset DMA Channel 0
                return;
        }

        if ( size <= 0 )	{
        	Reset( 0 );
                return;
        }

        PsxMem->RAM32[ DMA0_CTRL ] |= MDEC_STATUS_BUSY;

        if ( cmd & 0x400000000 ) {	//	Transfer request, so copy from
        // RAM[ DMA0_ADDR ] to pChan0
        	for ( int i=0; i<size; i+=4 ) {
                	DWORD	dwValue = PsxMem->RAM32[ dwAddr + i ];
                        pChan0->Write( &dwValue, sizeof( DWORD ) );
                }
        }

        PsxMem->RAM32[ DMA0_CTRL ] &= ~MDEC_STATUS_BUSY;

        //	Read from the DMA0_ADDR to ( DMA0_ADDR + DMA0_COUNT ) and write to
        // pChan0

	//if ( cmd == 0x60000000 )	{	//	What does this command do ?
        //        ;
	//} else if ( cmd == 0x40000001 ) {	//	Conversion read
	//	unsigned char *p = (unsigned char*)&PsxMem->lpPsxRAM[ ( dwAddr & 0x001FFFFF ) ];
	//	iqtab_init( iq_y,  p      );	//	translate x,y data
	//	iqtab_init( iq_uv, p + 64 );	//	translate uv data (color?)
	//} else
	//if ( ( cmd & 0xf5ff0000 ) == 0x30000000 ) {
	//	mdec.rl = (unsigned short*)&PsxMem->lpPsxRAM[ ( dwAddr & 0x001FFFFF ) ];
	//}
	//else {
        //
	//}
        //	do we need to read dwBCR bytes from dwAddr under dma control type dwCHCR ?
}
//---------------------------------------------------------------------------
//	write data from pChan1 memory stream to emulator ram
//---------------------------------------------------------------------------
void 	__fastcall	CPSX_MDEC :: hwDMA1( void )//DWORD dwAddr, DWORD dwBCR, DWORD dwCHCR )
{	int	blk[ DCTSIZE2 * 6 ];
	WORD	*lpImage;
	int 	blocksize;
	int 	size;

	if ( PsxMem->RAM32[ DMA1_CTRL ] != 0x01000200 )
        	return;

        PsxMem->RAM32[ DMA1_CTRL ] |= MDEC_STATUS_BUSY;

	size = ( PsxMem->RAM32[ DMA1_SIZE ] >> 16 ) * ( PsxMem->RAM32[ DMA1_SIZE ] & 0xffff );
    	lpImage = (WORD*)PsxMem->lpPsxRAM[ PsxMem->RAM32[ DMA1_ADDR ] ];
	if ( PsxMem->RAM32[ DMA1_CTRL ] & 0x08000000 )
        	blocksize = 16*16;
	else 	blocksize = 24*16;

	for (;size>0; size-=blocksize/2, lpImage+=blocksize ) {
		mdec.rl = rl2blk( blk, mdec. rl );
		if ( mdec.command & 0x08000000 )
			 yuv2rgb15( blk,lpImage );
		else yuv2rgb24( blk,(BYTE*)lpImage );
                pChan1->Write( lpImage, blocksize );
	}

        PsxMem->RAM32[ DMA1_CTRL ] &= ~MDEC_STATUS_BUSY;
}
//---------------------------------------------------------------------------
