//---------------------------------------------------------------------------
//
//	$FileName	::	MDec.h
//
//---------------------------------------------------------------------------
#ifndef MDECH
#define MDECH
//---------------------------------------------------------------------------
#ifndef EMULATOR_DLL_H
#include "EmulatorDLL.h"
#endif
//---------------------------------------------------------------------------
#define	RUNOF(a)			((a)>>10)
#define	VALOF(a)			(((int)(a)<<(32-10))>>(32-10))
#define CONST_BITS14 			14
#define	IFAST_SCALE_BITS		2
#define CONST_BITS  			8
#define PASS1_BITS  			2
//---------------------------------------------------------------------------
#define FIX_1_082392200  		(277)
#define FIX_1_414213562  		(362)
#define FIX_1_847759065  		(473)
#define FIX_2_613125930  		(669)
//---------------------------------------------------------------------------
#define MULTIPLY(var,const)  		(DESCALE((var) * (const), CONST_BITS))
//---------------------------------------------------------------------------
#define DEQUANTIZE(coef,quantval)  	(coef)
//---------------------------------------------------------------------------
#define DESCALE(x,n)  			((x)>>(n))
#define	RANGE(n)			(n)
//---------------------------------------------------------------------------
#define	DCTSIZE				8
#define	DCTSIZE2			64
//---------------------------------------------------------------------------
//	MDEC Command write to mdec in
//---------------------------------------------------------------------------
#define MDEC_CMD_RESET			0x80000000		//	Reset the MDEC system
#define MDEC_CMD_EXECUTE		0x40000000
#define MDEC_CMD_UNK0			0x60000000
#define MDEC_CMD_UNK1			0x20000000
#define MDEC_CMD_UNK2			0x10000000
#define MDEC_CMD_UNK3			0x30000000
//---------------------------------------------------------------------------
#define MDEC_CMD_DIR_FROM		0x00000001	//	CPU --> MDEC
#define MDEC_CMD_DIR_TO			~0x00000001	//	CPU <-- MDEC
//---------------------------------------------------------------------------
// 	MDEC	Status
//---------------------------------------------------------------------------
#define MDEC_STATUS_BUSY		0x20000000	//	Duh
#define MDEC_STATUS_DREQ		0x18000000	//	Data Requested
#define MDEC_STATUS_FIFO		0xc0000000	//	FIFO style, else LIFO
#define MDEC_STATUS_RGB24		0x02000000	//	RGB 24 / 16 ?
#define MDEC_STATUS_STP			0x00800000	//	Step ?
//---------------------------------------------------------------------------
#define MDEC_CHANNEL_0		0
#define MDEC_CHANNEL_1		1
//---------------------------------------------------------------------------
#define MDEC_SERVER_PIPE	"MDECIN"
#define MDEC_CLIENT_PIPE	"MDECOUT"
//---------------------------------------------------------------------------
#define	MDEC_RLNOP		0xfe00
//---------------------------------------------------------------------------
typedef	struct	_rl_header_def_	{
	WORD	magic;
        WORD	size;
        } RLHeader, *lpRLHeader;
//---------------------------------------------------------------------------
class	CPSX_MDEC : public TObject	//	PlayStation MDEC Emulator
	{
        	friend	class	CPSX_DMA;	//	DMA <--> MDEC interface
                friend	class	HW;
        	protected:
                	void	__fastcall	Write		( int Channel, DWORD dwData );
                        DWORD	__fastcall	Read		( int Channel );
                        void	__fastcall	Process		( void );
                private:
                        TMemoryStream		*pChan0;
                        TMemoryStream		*pChan1;

                        int	*lpIQTable;
                        int	*lpIQYTable;

                        bool			fColourFlag;

                        DWORD	__fastcall	GAddress( int Index );
                        DWORD	__fastcall	GCount( int Index );
                        DWORD	__fastcall	GControl( int Index );

                        void	__fastcall	SAddress( int Index, DWORD Value );
                        void	__fastcall	SCount( int Index, DWORD Value );
                        void	__fastcall	SControl( int Index, DWORD Value );

                        void	__fastcall	hwDMA0		( void );//DWORD dwAddr, DWORD dwBCR, DWORD dwCHCR );
                        void	__fastcall	hwDMA1		( void );//DWORD dwAddr, DWORD dwBCR, DWORD dwCHCR );
                public:
                		__fastcall	CPSX_MDEC	( void );
                        	__fastcall	~CPSX_MDEC	( void );
                        int	__fastcall	Initialise	( void );
                        void	__fastcall	Terminate	( void );
                        void	__fastcall	Reset		( int Channel = -1 );
                __published:
                	__property	bool	ColourFlag = { read=fColourFlag, write=fColourFlag };
                        __property	DWORD	Address	[ int Index ] = { read=GAddress, write=SAddress };
                        __property	DWORD	Count	[ int Index ] = { read=GCount,   write=SCount   };
                        __property	DWORD	Control	[ int Index ] = { read=GControl, write=SControl };
        };
//---------------------------------------------------------------------------
__declspec( dllimport ) CPSX_MDEC	*PSX_MDEC;
//---------------------------------------------------------------------------
#endif	//	MDECH
//---------------------------------------------------------------------------
