//---------------------------------------------------------------------------
//
//	$FileName	::	OSCore.cpp
//	$Purpose	::	Basic OS Core
//
//---------------------------------------------------------------------------
#include <vcl.h>
//---------------------------------------------------------------------------
#pragma hdrstop
//---------------------------------------------------------------------------
#include "OSCore.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
__declspec( dllexport )	PSX_OSCore	*lpOSCore = NULL;
//---------------------------------------------------------------------------
__fastcall	PSX_OSCore :: PSX_OSCore( void ) : TObject()
{
	//	Create global and local lists
        lpSystemThreads = new LPPTHREAD[ 3 ];
        ZeroMemory( lpSystemThreads, sizeof( LPPTHREAD ) * 3 );

        lpKernelThreads = new PTHREAD;
        lpSystemThreads[ 0 ] = lpKernelThreads;

        lpBIOSThreads = new PTHREAD;
        lpSystemThreads[ 1 ] = lpBIOSThreads;

        lpUserThreads = new PTHREAD;
        lpSystemThreads[ 2 ] = lpUserThreads;

        lpCurrThread = NULL;
        dwCurrThreadId = 0xFFFFFFFF;
}
//---------------------------------------------------------------------------
__fastcall	PSX_OSCore :: ~PSX_OSCore( void )
{
	delete this;
}
//---------------------------------------------------------------------------
int	__fastcall	PSX_OSCore :: Initialise( void )
{
        lpKernel->Initialise();
        return( 0 );
}
//---------------------------------------------------------------------------
void	__fastcall	PSX_OSCore :: Terminate( void )
{
	lpKernel->Terminate();
}
//---------------------------------------------------------------------------
void	__fastcall	PSX_OSCore :: Reset( void )
{
	lpKernel->Reset();
}
//---------------------------------------------------------------------------
//	RUNTIME CALL	::	InitHeap
//	PARAMETERS	::	a0 = heap virtual start address
//				a1 = heap size
//---------------------------------------------------------------------------
void	__fastcall	PSX_OSCore :: InitHeap( void )
{	DWORD	dwvAddr;

	if ( CPU->GenRegs[ 5 ] <= 0 )	{	//	Bad size
        	return;
        }

        lpOSHeapStart = (DWORD*)&PsxMem->lpPsxRAM[ ( CPU->GenRegs[ 4 ] & 0x001FFFFF ) ];
        lpOSHeapMalloc = (malloc_chunk*)&lpOSHeapStart;

        if ( CPU->GenRegs[ 5 ] >= RAM_SIZE ) {
        	lpOSHeapMalloc->size = 0x001FFFFC - ( CPU->GenRegs[ 4 ] & 0x001FFFFF );
        } else
        	lpOSHeapMalloc->size = CPU->GenRegs[ 5 ];

        lpOSHeapMalloc->stat = 0;
        lpOSHeapMalloc->fd = NULL;
        lpOSHeapMalloc->bk = NULL;
}
//---------------------------------------------------------------------------
