//---------------------------------------------------------------------------
//
//	$FileName	::	OSCore.h
//	$Purpose	::	OS Boot Loader
//
//---------------------------------------------------------------------------
#ifndef OSCoreH
#define OSCoreH
//---------------------------------------------------------------------------
#ifndef EMULATOR_DLL_H
#include "EmulatorDLL.h"
#endif
//---------------------------------------------------------------------------
//	PlayStation KERNEL/OSCORE Thread Definition. Note that some of these
// fields correspond to what the hardware expects and must be treated accordingly
//---------------------------------------------------------------------------
typedef	struct	_psx_thread_def_	{
	LPVOID    	lpTLBEntry;	//	Entry into the TLB Array for this thread
        LPVOID       	lpCPUState;	//	Processor state (CPU)
        LPVOID       	lpFPUState;	//	Processor state (FPU) note that CP2 is not saved/retrieved
        LPVOID		lpEvent;	//	event if any for this thread signalling
        WORD		State;		//	Current state of thread
        WORD		Flags;		//	Current thread flags
        int		Priority;	//	threads current priority
} PTHREAD, *LPPTHREAD;
//---------------------------------------------------------------------------
//	Thread priority levels
//---------------------------------------------------------------------------
#define THREAD_LEVEL_KERNEL	0
#define THREAD_LEVEL_OSCORE	1
#define THREAD_LEVEL_USER	8
//---------------------------------------------------------------------------
//	Thread creation flags
//---------------------------------------------------------------------------
#define THREAD_CREATE_SUSPENDED	0x8000	//	if set do not run this thread straight away
#define THREAD_CREATE_EVENT	0x4000	//	External event triggering
#define THREAD_CREATE_EVENT_IO	0x4100	//	External i/o event triggered
//---------------------------------------------------------------------------
/*
__declspec( dllimport )	int	open	( char *name, int mode );
__declspec( dllimport )	int 	lseek(int fd , int offset , int whence)
__declspec( dllimport )	int 	read(int fd , char *buf , int nbytes)
__declspec( dllimport )	int 	write(int fd , char *buf , int nbytes)
__declspec( dllimport )	void	close(int fd)
__declspec( dllimport )	int 	ioctl(int fd , int cmd , int arg)
__declspec( dllimport )	void	exit()
__declspec( dllimport )	void	sys_b0_39()
__declspec( dllimport )	char 	getc(int fd)
__declspec( dllimport )	void	putc(char c , int fd)
__declspec( dllimport )	char	*todigit
__declspec( dllimport )	double 	atof(char *s)
__declspec( dllimport )	long 	strtoul(char *s , char **ptr , int base)
__declspec( dllimport )	DWORD	strtol(char *s , char **ptr , int base)
__declspec( dllimport )	int 	abs(int val)
__declspec( dllimport )	long 	labs(long lval)
__declspec( dllimport )	long 	atoi(char *s)
__declspec( dllimport )	int 	atol(char *s)
__declspec( dllimport )	DWORD	atob(char *s)
__declspec( dllimport )	int 	setjmp(jmp_buf *ctx)
__declspec( dllimport )	void	longjmp(jmp_buf *ctx , int value)
__declspec( dllimport )	char 	*strcat(char *dst , char *src)
__declspec( dllimport )	char 	*strncat(char *dst , char *src , int n)
__declspec( dllimport )	int 	strcmp(char *dst , char *src)
__declspec( dllimport )	int 	strncmp(char *dst , char *src , int n)
__declspec( dllimport )	char 	*strcpy(char *dst , char *src)
__declspec( dllimport )	char 	*strncpy(char *dst , char *src , int n)
__declspec( dllimport )	int 	strlen(char *s)
__declspec( dllimport )	int 	index(char *s , int c)
__declspec( dllimport )	int 	rindex(char *s , int c)
__declspec( dllimport )	char 	*strchr(char *c , int c)
__declspec( dllimport )	char 	*strrchr(char *c , int c)
__declspec( dllimport )	char 	*strpbrk(char *dst , *src)
__declspec( dllimport )	int 	strspn(char *s , char *set)
__declspec( dllimport )	int 	strcspn(char *s , char *set)
__declspec( dllimport )	char 	*strtok(char *s , char *set)
__declspec( dllimport )	char	*strstr(char *s , char *set)
__declspec( dllimport )	int 	toupper(int c)
__declspec( dllimport )	int 	tolower(int c)
__declspec( dllimport )	void 	bcopy(void *src , void *dst , int len)
__declspec( dllimport )	void 	bzero(void *ptr , int len)
__declspec( dllimport )	int 	bcmp(void *ptr1 , void *ptr2 , int len)
__declspec( dllimport )	void	memcpy(void *dst , void *src , int n)
__declspec( dllimport )	void	memset(void *dst , char c , int n)
__declspec( dllimport )	void	memmove(void *dst , void *src , int n)
__declspec( dllimport )	int	memcmp(void *dst , void *src , int n)
__declspec( dllimport )	void	memchr(void *s , int c , int n)
__declspec( dllimport )	int 	rand()
__declspec( dllimport )	void 	srand(unsigned int seed)
__declspec( dllimport )	void 	qsort(void *base , int nel , int width , int (*cmp)*void *,void *))",
__declspec( dllimport )	double 	strtod(char *s , char *endptr)",
__declspec( dllimport )	void 	*malloc(int size)",
__declspec( dllimport )	void	free(void *buf)",
__declspec( dllimport )	void 	*lsearch(void *key , void *base , int belp , int width , int (*cmp)(void * , void *))",
__declspec( dllimport )	void 	*bsearch( void *key , void *base , int nel , int size , int (*cmp)(void * , void *))",
__declspec( dllimport )	void 	*calloc(int size , int n)",
__declspec( dllimport )	void 	*realloc(void *buf , int n)",
__declspec( dllimport )	void	InitHeap(void *block , int n)",
__declspec( dllimport )	void	_exit()",
__declspec( dllimport )	char 	getchar(int fd) ",
__declspec( dllimport )	void	putchar(char c , int fd)",
__declspec( dllimport )	char 	*gets(char *s)",
__declspec( dllimport )	void	puts(char *s)",
__declspec( dllimport )	void	printf(char *fmt , ...)",
__declspec( dllimport )	int	LoadTest(char *name , XF_HDR *header)",
__declspec( dllimport )	int	Load(char *name , XF_HDR *header)",
__declspec( dllimport )	int	Exec(struct EXEC *header , int argc , char **argc)",
__declspec( dllimport )	void	FlushCache()",
__declspec( dllimport )	void 	InstallInterruptHandler()",
__declspec( dllimport )	void	GPU_dw",
__declspec( dllimport )	int 	SetGPUStatus(int status)",
__declspec( dllimport )	void	GPU_cw",
__declspec( dllimport )	void	GPU_cwb (not sure)",
__declspec( dllimport )	int 	GetGPUStatus()",
__declspec( dllimport )	void	GPU_sync",
__declspec( dllimport )	int	LoadExec(char *name , int , int)",
__declspec( dllimport )	void	GetSysSp()",
__declspec( dllimport )	void	_96_init()",
__declspec( dllimport )	void	_bu_init()",
__declspec( dllimport )	void	_96_remove()",
__declspec( dllimport )	DWORD	return_0",
__declspec( dllimport )	DWORD	return_0",
__declspec( dllimport )	DWORD	return_0",
__declspec( dllimport )	DWORD	return_0",
		/0x005b / "dev_tty_init",
		/0x005c / "dev_tty_open",
		/0x005e / "dev_tty_ioctl",
		/0x005f / "dev_cd_open",
		/0x0060 / "dev_cd_read",
		/0x0061 / "dev_cd_close",
		/0x0062 / "dev_cd_firstfile",
		/0x0063 / "dev_cd_nextfile",
		/0x0064 / "dev_cd_chdir",
		/0x0065 / "dev_card_open",
		/0x0066 / "dev_card_read",
		/0x0067 / "dev_card_write",
		/0x0068 / "dev_card_close",
		/0x0069 / "dev_card_firstfile",
		/0x006a / "dev_card_nextfile",
		/0x006b / "dev_card_erase",
		/0x006c / "dev_card_undelete",
		/0x006d / "dev_card_format",
		/0x006e / "dev_card_rename",
		/0x0070 / "_bu_init",
		/0x0071 / "_96_init",
		/0x0072 / "_96_remove",
		/0x0078 / "_96_CdSeekL",
		/0x007c / "_96_CdGetStatus",
		/0x007e / "_96_CdRead",
		/0x0085 / "_96_CdStop",
		/0x0096 / "AddCDROMDevice()",
		/0x0097 / "AddMemCardDevice()",
		/0x0098 / "DisableKernelIORedirection()",
		/0x0099 / "EnableKernelIORedirection()",
		/0x009c / "GetConf(int Event , int TCB , int Stack)",
		/0x009d / "GetConf(int *Event , int *TCB , int *Stack)",
		/0x009f / "SetMem(int size)",
		/0x00a0 / "_boot",
		/0x00a1 / "SystemError",
		/0x00a2 / "EnqueueCdIntr",
		/0x00a3 / "DequeueCdIntr",
		/0x00a5 / "ReadSector(count,sector,buffer)",
		/0x00a6 / "get_cd_status ??",
		/0x00a7 / "bufs_cb_0",
		/0x00a8 / "bufs_cb_1",
		/0x00a9 / "bufs_cb_2",
		/0x00aa / "bufs_cb_3",
		/0x00ab / "_card_info",
		/0x00ac / "_card_load",
		/0x00ad / "_card_auto",
		/0x00ae / "bufs_cb_4",
		/0x00b2 / "do_a_long_jmp()", */
//---------------------------------------------------------------------------
class	PSX_OSCore : public TObject
	{
        	friend	class	PSX_CDROM;
        	friend	class	PSX_kernel;
                protected:
                	
                private:
                	LPPTHREAD	*lpSystemThreads;	//	Global list
                        LPPTHREAD	lpKernelThreads;	//	[KERNEL] Also OS
                        LPPTHREAD	lpBIOSThreads;		//	[BIOS]
                        LPPTHREAD	lpUserThreads;		//	[USER]

                        LPPTHREAD	lpCurrThread;
                        DWORD		dwCurrThreadId;

                        DWORD		*lpOSHeapStart;
                        malloc_chunk	*lpOSHeapMalloc;

                public:
                		__fastcall	PSX_OSCore	( void );
                        	__fastcall	~PSX_OSCore	( void );

                	int	__fastcall	Initialise	( void );
                        void	__fastcall	Terminate	( void );
                        void	__fastcall	Reset		( void );

                        void	__fastcall	InitHeap	( void );
        };
//---------------------------------------------------------------------------
__declspec( dllimport )	PSX_OSCore	*lpOSCore;
//---------------------------------------------------------------------------
#endif
//---------------------------------------------------------------------------
