//---------------------------------------------------------------------------
//
//	$FileName	::	Plugins.h
//	$Purpose	::	Header for plugins for emulator
//
//---------------------------------------------------------------------------
#ifndef PluginsH
#define PluginsH
//---------------------------------------------------------------------------
#if defined (__WIN32__)
//#include "Win32\plugin.h"
#elif defined(__LINUX__)
typedef void* HWND;
#include "Linux/Plugin.h"
#endif
//---------------------------------------------------------------------------
#ifndef EMULATOR_DLL_H
	#include "EmulatorDLL.h"
#endif
//---------------------------------------------------------------------------
__declspec( dllimport ) 	void LoadPlugins();
__declspec( dllimport ) 	void ReleasePlugins();
__declspec( dllimport ) 	void OpenPlugins();
__declspec( dllimport ) 	void ClosePlugins();
__declspec( dllimport ) 	void ResetPlugins();
//---------------------------------------------------------------------------
#ifdef __LINUX__ 
#define CALLBACK
#endif
//---------------------------------------------------------------------------
typedef unsigned long (CALLBACK* PSEgetLibType)(void);
typedef unsigned long (CALLBACK* PSEgetLibVersion)(void);
typedef char *(CALLBACK* PSEgetLibName)(void);
//---------------------------------------------------------------------------
///GPU PLUGIN STUFF
//---------------------------------------------------------------------------
typedef long (CALLBACK* GPUinit)(void);
typedef long (CALLBACK* GPUshutdown)(void);
typedef long (CALLBACK* GPUclose)(void);
typedef void (CALLBACK* GPUwriteStatus)(unsigned long);
typedef void (CALLBACK* GPUwriteData)(unsigned long);
typedef void (CALLBACK* GPUwriteDataMem)(unsigned long *, int);
typedef unsigned long (CALLBACK* GPUreadStatus)(void);
typedef unsigned long (CALLBACK* GPUreadData)(void);
typedef void (CALLBACK* GPUreadDataMem)(unsigned long *, int);
typedef long (CALLBACK* GPUdmaChain)(unsigned long *,unsigned long);
typedef void (CALLBACK* GPUupdateLace)(void);
typedef long (CALLBACK* GPUconfigure)(void);
typedef long (CALLBACK* GPUtest)(void);
typedef void (CALLBACK* GPUabout)(void);
typedef void (CALLBACK* GPUmakeSnapshot)(void);
typedef void (CALLBACK* GPUkeypressed)(int);
typedef void (CALLBACK* GPUdisplayText)(char *);
typedef struct {
	unsigned long ulFreezeVersion;		//	version
	unsigned long ulStatus;			//	status
	unsigned long ulControl[256];		//	Control registers
	unsigned char psxVRam[1024*512*2];	//	video ram, roughly 1MB
} GPUFreeze_t;
typedef long (CALLBACK* GPUfreeze)(unsigned long, GPUFreeze_t *);
typedef long (CALLBACK* GPUgetScreenPic)(unsigned char *);
typedef long (CALLBACK* GPUshowScreenPic)(unsigned char *);
//---------------------------------------------------------------------------
//plugin stuff From Shadow
// *** walking in the valley of your darking soul i realize that i was alone
//Gpu function pointers
//---------------------------------------------------------------------------
__declspec( dllimport ) 	GPUupdateLace    GPU_updateLace;
__declspec( dllimport ) 	GPUinit          GPU_init;
__declspec( dllimport ) 	GPUshutdown      GPU_shutdown;
__declspec( dllimport ) 	GPUconfigure     GPU_configure;
__declspec( dllimport ) 	GPUtest          GPU_test;
__declspec( dllimport ) 	GPUabout         GPU_about;
//__declspec( dllimport ) 	GPUopen          GPU_open;
__declspec( dllimport ) 	GPUclose         GPU_close;
__declspec( dllimport ) 	GPUreadStatus    GPU_readStatus;
//__declspec( dllimport ) 	GPUreadData      GPU_readData;
__declspec( dllimport ) 	GPUreadDataMem   GPU_readDataMem;
__declspec( dllimport ) 	GPUwriteStatus   GPU_writeStatus;
__declspec( dllimport ) 	GPUwriteData     GPU_writeData;
__declspec( dllimport ) 	GPUwriteDataMem  GPU_writeDataMem;
__declspec( dllimport ) 	GPUdmaChain      GPU_dmaChain;
__declspec( dllimport ) 	GPUkeypressed    GPU_keypressed;
__declspec( dllimport ) 	GPUdisplayText   GPU_displayText;
__declspec( dllimport ) 	GPUmakeSnapshot  GPU_makeSnapshot;
__declspec( dllimport ) 	GPUfreeze        GPU_freeze;
__declspec( dllimport ) 	GPUgetScreenPic  GPU_getScreenPic;
__declspec( dllimport ) 	GPUshowScreenPic GPU_showScreenPic;
//---------------------------------------------------------------------------
//cd rom plugin ;)
//---------------------------------------------------------------------------
typedef long (CALLBACK* CDRinit)(void);
typedef long (CALLBACK* CDRshutdown)(void);
typedef long (CALLBACK* CDRopen)(void);
typedef long (CALLBACK* CDRclose)(void);
typedef long (CALLBACK* CDRgetTN)(unsigned char *);
typedef long (CALLBACK* CDRgetTD)(unsigned char , unsigned char *);
typedef long (CALLBACK* CDRreadTrack)(unsigned char *);
typedef unsigned char * (CALLBACK* CDRgetBuffer)(void);
typedef long (CALLBACK* CDRconfigure)(void);
typedef long (CALLBACK* CDRtest)(void);
typedef void (CALLBACK* CDRabout)(void);
typedef long (CALLBACK* CDRplay)(unsigned char *);
typedef long (CALLBACK* CDRstop)(void);

#ifndef CDROM_STATUS_STRUCT
#define CDROM_STATUS_STRUCT
typedef struct CdrStat /*_cdrom_status_def_*/ {
	unsigned long Type;
	unsigned long Status;
	unsigned char Time[4];
} CDROM_Status;
#endif
typedef long (CALLBACK* CDRgetStatus)(struct CdrStat *);
typedef char* (CALLBACK* CDRgetDriveLetter)(void);
//---------------------------------------------------------------------------
//	CD-ROM function pointers
//---------------------------------------------------------------------------
__declspec( dllimport ) 	CDRinit               CDR_init;
__declspec( dllimport ) 	CDRshutdown           CDR_shutdown;
__declspec( dllimport ) 	CDRopen               CDR_open;
__declspec( dllimport ) 	CDRclose              CDR_close;
__declspec( dllimport ) 	CDRtest               CDR_test;
__declspec( dllimport ) 	CDRgetTN              CDR_getTN;
__declspec( dllimport ) 	CDRgetTD              CDR_getTD;
__declspec( dllimport ) 	CDRreadTrack          CDR_readTrack;
__declspec( dllimport ) 	CDRgetBuffer          CDR_getBuffer;
__declspec( dllimport ) 	CDRplay               CDR_play;
__declspec( dllimport ) 	CDRstop               CDR_stop;
__declspec( dllimport ) 	CDRgetStatus          CDR_getStatus;
__declspec( dllimport ) 	CDRgetDriveLetter     CDR_getDriveLetter;
__declspec( dllimport ) 	CDRconfigure          CDR_configure;
__declspec( dllimport ) 	CDRabout              CDR_about;
//---------------------------------------------------------------------------
// spu plugin
//---------------------------------------------------------------------------
typedef long (CALLBACK* SPUinit)(void);
typedef long (CALLBACK* SPUshutdown)(void);
typedef long (CALLBACK* SPUclose)(void);
typedef void (CALLBACK* SPUplaySample)(unsigned char);
typedef void (CALLBACK* SPUstartChannels1)(unsigned short);
typedef void (CALLBACK* SPUstartChannels2)(unsigned short);
typedef void (CALLBACK* SPUstopChannels1)(unsigned short);
typedef void (CALLBACK* SPUstopChannels2)(unsigned short);
typedef void (CALLBACK* SPUputOne)(unsigned long,unsigned short);
typedef unsigned short (CALLBACK* SPUgetOne)(unsigned long);
typedef void (CALLBACK* SPUsetAddr)(unsigned char, unsigned short);
typedef void (CALLBACK* SPUsetPitch)(unsigned char, unsigned short);
typedef void (CALLBACK* SPUsetVolumeL)(unsigned char, short );
typedef void (CALLBACK* SPUsetVolumeR)(unsigned char, short );
//psemu pro 2 functions from now..
typedef void (CALLBACK* SPUwriteRegister)(unsigned long, unsigned short);
typedef unsigned short (CALLBACK* SPUreadRegister)(unsigned long);
typedef void (CALLBACK* SPUwriteDMA)(unsigned short);
typedef unsigned short (CALLBACK* SPUreadDMA)(void);
typedef void (CALLBACK* SPUwriteDMAMem)(unsigned short *, int);
typedef void (CALLBACK* SPUreadDMAMem)(unsigned short *, int);
typedef void (CALLBACK* SPUplayADPCMchannel)(pxa_decode_t );
typedef void (CALLBACK* SPUregisterCallback)(void (CALLBACK *callback)(void));
typedef long (CALLBACK* SPUconfigure)(void);
typedef long (CALLBACK* SPUtest)(void);
typedef void (CALLBACK* SPUabout)(void);
typedef struct {
	unsigned char 	PluginName[ 8 ];	//	Name of plugin
	unsigned long 	PluginVersion;		//	Version
	unsigned long 	Size;			//	Size ?
	unsigned char 	SPUPorts[ 0x200 ];	//	Supported Ports
	unsigned char 	SPURam[ 0x80000 ];	//	Private Audio Buffer
//	xa_decode_t	*xa;			//	XA Decoding structure
	unsigned char 	*SPUInfo;		//	SPU Info pointer
} SPUFreeze_t;
typedef long (CALLBACK* SPUfreeze)(unsigned long, SPUFreeze_t *);
//---------------------------------------------------------------------------
//SPU POINTERS
//---------------------------------------------------------------------------
__declspec( dllimport ) 	SPUconfigure        SPU_configure;
__declspec( dllimport ) 	SPUabout            SPU_about;
__declspec( dllimport ) 	SPUinit             SPU_init;
__declspec( dllimport ) 	SPUshutdown         SPU_shutdown;
__declspec( dllimport ) 	SPUtest             SPU_test;
//__declspec( dllimport ) 	SPUopen             SPU_open;
__declspec( dllimport ) 	SPUclose            SPU_close;
__declspec( dllimport ) 	SPUplaySample       SPU_playSample;
__declspec( dllimport ) 	SPUstartChannels1   SPU_startChannels1;
__declspec( dllimport ) 	SPUstartChannels2   SPU_startChannels2;
__declspec( dllimport ) 	SPUstopChannels1    SPU_stopChannels1;
__declspec( dllimport ) 	SPUstopChannels2    SPU_stopChannels2;
__declspec( dllimport ) 	SPUputOne           SPU_putOne;
__declspec( dllimport ) 	SPUgetOne           SPU_getOne;
__declspec( dllimport ) 	SPUsetAddr          SPU_setAddr;
__declspec( dllimport ) 	SPUsetPitch         SPU_setPitch;
__declspec( dllimport ) 	SPUsetVolumeL       SPU_setVolumeL;
__declspec( dllimport ) 	SPUsetVolumeR       SPU_setVolumeR;
__declspec( dllimport ) 	SPUwriteRegister    SPU_writeRegister;
__declspec( dllimport ) 	SPUreadRegister     SPU_readRegister;
__declspec( dllimport ) 	SPUwriteDMA         SPU_writeDMA;
__declspec( dllimport ) 	SPUreadDMA          SPU_readDMA;
__declspec( dllimport ) 	SPUwriteDMAMem      SPU_writeDMAMem;
__declspec( dllimport ) 	SPUreadDMAMem       SPU_readDMAMem;
__declspec( dllimport ) 	SPUplayADPCMchannel SPU_playADPCMchannel;
__declspec( dllimport ) 	SPUfreeze           SPU_freeze;
__declspec( dllimport ) 	SPUregisterCallback SPU_registerCallback;
//---------------------------------------------------------------------------
// PAD Functions
//---------------------------------------------------------------------------
typedef long (CALLBACK* PADconfigure)(void);
typedef void (CALLBACK* PADabout)(void);
typedef long (CALLBACK* PADinit)(long);
typedef long (CALLBACK* PADshutdown)(void);
typedef long (CALLBACK* PADtest)(void);
typedef long (CALLBACK* PADclose)(void);
typedef long (CALLBACK* PADquery)(void);
typedef long (CALLBACK*	PADreadPort1)(PadDataS*);
typedef long (CALLBACK* PADreadPort2)(PadDataS*);
typedef long (CALLBACK* PADkeypressed)(void);
//typedef long (CALLBACK* PADreadBuffer)(void);
//---------------------------------------------------------------------------
//PAD POINTERS
//---------------------------------------------------------------------------
__declspec( dllimport ) 	PADconfigure        	PAD1_configure;
__declspec( dllimport ) 	PADabout            	PAD1_about;
__declspec( dllimport ) 	PADinit             	PAD1_init;
__declspec( dllimport ) 	PADshutdown         	PAD1_shutdown;
__declspec( dllimport ) 	PADtest             	PAD1_test;
//PADopen             	PAD1_open;
__declspec( dllimport ) 	PADclose            	PAD1_close;
__declspec( dllimport ) 	PADquery	    	PAD1_query;
__declspec( dllimport ) 	PADreadPort1		PAD1_readPort1;
__declspec( dllimport ) 	PADkeypressed		PAD1_keypressed;
//PADreadBuffer		PAD1_readBuffer;
//---------------------------------------------------------------------------
__declspec( dllimport ) 	PADconfigure        	PAD2_configure;
__declspec( dllimport ) 	PADabout            	PAD2_about;
__declspec( dllimport ) 	PADinit             	PAD2_init;
__declspec( dllimport ) 	PADshutdown         	PAD2_shutdown;
__declspec( dllimport ) 	PADtest             	PAD2_test;
//PADopen             	PAD2_open;
__declspec( dllimport ) 	PADclose            	PAD2_close;
__declspec( dllimport ) 	PADquery            	PAD2_query;
__declspec( dllimport ) 	PADreadPort2		PAD2_readPort2;
__declspec( dllimport ) 	PADkeypressed		PAD2_keypressed;
//PADreadBuffer		PAD2_readBuffer;
//---------------------------------------------------------------------------
__declspec( dllimport ) 	void LoadCDplugin(char *CDdll);
__declspec( dllimport ) 	void LoadGPUplugin(char *GPUdll);
__declspec( dllimport ) 	void LoadSPUplugin(char *SPUdll);
__declspec( dllimport ) 	void LoadPAD1plugin(char *PAD1dll);
__declspec( dllimport ) 	void LoadPAD2plugin(char *PAD2dll);
//---------------------------------------------------------------------------
#endif	//	PluginsH
//---------------------------------------------------------------------------
