//---------------------------------------------------------------------------
//
//	$FileName	::	SIO.CPP
//	$Purpose	::	PlayStation Serial I/O Emulation Layer
//
//---------------------------------------------------------------------------
#include <vcl.h>
//---------------------------------------------------------------------------
#pragma hdrstop
//---------------------------------------------------------------------------
#include "SIO.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
#ifdef __WIN32__
#pragma warning(disable:4244)
#endif
//---------------------------------------------------------------------------
__declspec( dllexport ) PSX_SIO	*PsxSIO;
//---------------------------------------------------------------------------
// *** FOR WORKS ON PADS AND MEMORY CARDS *****
//---------------------------------------------------------------------------
static	unsigned char buf[256];
	unsigned char stdpar[10] = { 0x00, 0x41, 0x5a, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff };
	unsigned char mousepar[8] = { 0x00, 0x12, 0x5a, 0xff, 0xff, 0xff, 0xff };
	unsigned char analogpar[6] = { 0x00, 0xff, 0x5a, 0xff, 0xff };
	unsigned char cardh[4] = { 0x00, 0x00, 0x5a, 0x5d };
//---------------------------------------------------------------------------
//static unsigned short StatReg = 0x002b;
// Transfer(?) Ready and the Buffer is Empty
//---------------------------------------------------------------------------
	unsigned short StatReg = TX_RDY | TX_EMPTY;
	unsigned short ModeReg;
	unsigned short CtrlReg;
	unsigned short BaudReg;
//---------------------------------------------------------------------------
static	unsigned long bufcount;
static	unsigned long parp;
static	unsigned long mcdst,rdwr;
static	unsigned char adrH,adrL;
static	unsigned long padst;
//---------------------------------------------------------------------------
PadDataS pad;
//---------------------------------------------------------------------------
char Mcd1Data[MCD_SIZE], Mcd2Data[MCD_SIZE];
//---------------------------------------------------------------------------
__fastcall	PSX_SIO :: PSX_SIO( void ) : TObject()
{
	SystemMessage( "CPSX_SIO::CPSX_SIO\n" );
}
//---------------------------------------------------------------------------
__fastcall	PSX_SIO :: ~PSX_SIO( void )
{
	delete this;
}
//---------------------------------------------------------------------------
int	__fastcall	PSX_SIO :: Initialise( void )
{
	return( 0 );
}
//---------------------------------------------------------------------------
void	__fastcall	PSX_SIO :: Terminate( void )
{
}
//---------------------------------------------------------------------------
void	__fastcall	PSX_SIO :: Reset( void )
{
}
//---------------------------------------------------------------------------
// clk cycle byte
// 4us * 8bits = ((PSXCLK / 1000000) * 32) / BIAS; (linuzappz)
//---------------------------------------------------------------------------
#define SIO_INT		\
	if (!(Config.Sio&0x1)) { \
		cpuIrq.interrupt |= 0x80; \
		cpuIrq.intCycle[7] = cpuIrq.cycle + 200; /*270;*/ \
	}
//---------------------------------------------------------------------------
unsigned char sioRead8() {
	unsigned char ret = 0;

	if ((StatReg & RX_RDY)/* & (CtrlReg & RX_PERM)*/) {
//		StatReg &= ~RX_OVERRUN;
		ret = buf[parp];
		if (parp == bufcount) {
			StatReg &= ~RX_RDY;	// Receive is not Ready now?
			StatReg |= TX_EMPTY;	// Buffer is Empty
			if (mcdst == 5) {
				mcdst = 0;
				if (rdwr == 2) {
					switch (CtrlReg&0x2002) {
						case 0x0002:
							memcpy(Mcd1Data + (adrL | (adrH << 8)) * 128, &buf[1], 128);
							//SaveMcd(Config.Mcd1, Mcd1Data, (adrL | (adrH << 8)) * 128);
							break;
						case 0x2002:
							memcpy(Mcd2Data + (adrL | (adrH << 8)) * 128, &buf[1], 128);
							//SaveMcd(Config.Mcd2, Mcd2Data, (adrL | (adrH << 8)) * 128);
							break;
					}
				}
			}
			if (mcdst == 1) mcdst = 2;
			if (padst == 2) padst = 0;
		}
	}

	return ret;
}
//---------------------------------------------------------------------------
unsigned short sioRead16(unsigned long add) {
	unsigned short ret;

	switch (add) {
		case 0x1f801040:
			ret = sioRead8();
			ret |= sioRead8() << 8;
		case 0x1f801044:
			ret = StatReg;
			break;
		case 0x1f801048:
			ret = ModeReg;
			break;
		case 0x1f80104a:
			ret = CtrlReg;
			break;
		case 0x1f80104e:
			ret = BaudReg;
			break;
	 //	default:
			//ret = uHWM16(add & 0xffff);
	}

	return ret;
}
//---------------------------------------------------------------------------
unsigned long sioRead32() {
	unsigned long ret;

	ret = sioRead8();
	ret |= sioRead8() << 8;
	ret |= sioRead8() << 16;
	ret |= sioRead8() << 24;

	return ret;
}
//---------------------------------------------------------------------------
void sioWrite8(unsigned char value) {
	switch (padst) {
		case 1: //SIO_INT
			if ((value&0x40) == 0x40) {
				padst = 2; parp = 1;
				switch (value) {
					case 0x42:
						buf[parp] = 0x41;
						break;
					case 0x43:
						buf[parp] = 0x43;
						break;
					case 0x45:
						buf[parp] = 0xf3;
						buf[3] = 0x00;
						buf[4] = 0x00;
						break;
				}
			}
			else padst = 0;
			return;
		case 2: //if (value != 0) break;
			if (++parp == bufcount) { padst = 0; return; }
			//SIO_INT
			return;
	}

	switch (mcdst) {
		case 1:
			//SIO_INT
			if (rdwr) { parp++; return; }
			parp = 1;
			switch (value) {
				case 0x52: rdwr = 1; break;
				case 0x57: rdwr = 2; break;
				default: mcdst = 0;
			}
			return;
		case 2: // address H
			//SIO_INT
			adrH = value;
			StatReg &= ~TX_EMPTY;
			StatReg |= RX_RDY;
			*buf = 0;
			parp = 0;
			bufcount = 1;
			mcdst = 3;
			return;
		case 3: // address L
			//SIO_INT
			adrL = value;
			StatReg &= ~TX_EMPTY;
			StatReg |= RX_RDY;
			*buf = adrH;
			parp = 0;
			bufcount = 1;
			mcdst = 4;
			return;
		case 4:
			//SIO_INT
			StatReg &= ~TX_EMPTY;
			StatReg |= RX_RDY;
			parp = 0;
			switch (rdwr) {
				case 1:
					buf[0] = 0x5c;
					buf[1] = 0x5d;
					buf[2] = adrH;
					buf[3] = adrL;
					switch (CtrlReg&0x2002) {
						case 0x0002:
							memcpy(&buf[4], Mcd1Data + (adrL | (adrH << 8)) * 128, 128);
							break;
						case 0x2002:
							memcpy(&buf[4], Mcd2Data + (adrL | (adrH << 8)) * 128, 128);
							break;
					}
					{
					char xor = 0;
					int i;
					for (i=2;i<128+4;i++)
						xor^=buf[i];
					buf[132] = xor;
					}
					buf[133] = 0x47;
					bufcount = 133;
					break;
				case 2:
					buf[0] = adrL;
					buf[1] = value;
					buf[129] = 0x5c;
					buf[130] = 0x5d;
					buf[131] = 0x47;
					bufcount = 131;
					break;
			}
			mcdst = 5;
			return;
		case 5:
			//SIO_INT
			parp++;
			if (rdwr == 2) {
				if (parp < 128) buf[parp+1] = value;
			}
			return;
	}

	switch (value) {
		case 0x01: // start pad
			StatReg &= ~TX_EMPTY;	// Now the Buffer is not empty
			StatReg |= RX_RDY;	// Transfer is Ready

			switch (CtrlReg&0x2002) {
				//case 0x0002: PAD1_readPort1(&pad); break;
				//case 0x2002: PAD2_readPort2(&pad); break;
			}
			switch (pad.controllerType) {
				case PSE_PAD_TYPE_MOUSE:
					mousepar[3] = pad.buttonStatus & 0xff;
					mousepar[4] = pad.buttonStatus >> 8;
					mousepar[5] = pad.moveY;
					mousepar[6] = pad.moveX;

					memcpy(buf, mousepar, 7);
					bufcount = 6;
					break;
				case PSE_PAD_TYPE_ANALOGPAD: // scph1150
					analogpar[1] = 0x53;
					analogpar[3] = pad.buttonStatus & 0xff;
					analogpar[4] = pad.buttonStatus >> 8;
					analogpar[5] = pad.rightJoyX;
					analogpar[6] = pad.rightJoyY;
					analogpar[7] = pad.leftJoyX;
					analogpar[8] = pad.leftJoyY;

					memcpy(buf, analogpar, 9);
					bufcount = 8;
					break;
				case PSE_PAD_TYPE_ANALOGJOY: // scph1110
					analogpar[1] = 0x73;
					analogpar[3] = pad.buttonStatus & 0xff;
					analogpar[4] = pad.buttonStatus >> 8;
					analogpar[5] = pad.rightJoyX;
					analogpar[6] = pad.rightJoyY;
					analogpar[7] = pad.leftJoyX;
					analogpar[8] = pad.leftJoyY;

					memcpy(buf, analogpar, 9);
					bufcount = 8;
					break;
				case PSE_PAD_TYPE_STANDARD:
				default:
					stdpar[3] = pad.buttonStatus & 0xff;
					stdpar[4] = pad.buttonStatus >> 8;

					memcpy(buf, stdpar, 5);
					bufcount = 4;
			}

			parp = 0;
			padst = 1;
			//SIO_INT
			return;
		case 0x81: // start memcard
			StatReg &= ~TX_EMPTY;
			StatReg |= RX_RDY;
			memcpy(buf, cardh, 4);
			parp = 0;
			bufcount = 3;
			mcdst = 1;
			rdwr = 0;
			//SIO_INT
			return;
	}
}
//---------------------------------------------------------------------------
void sioWrite16(unsigned long add, unsigned short value) {
	switch (add) {
		case 0x1f801040:
			sioWrite8((unsigned char)value);
			sioWrite8((unsigned char)(value>>8));
			break;
		case 0x1f801044:
			break;
		case 0x1f801048:
			ModeReg = value;
			break;
		case 0x1f80104a: // control register
			CtrlReg = value & ~RESET_ERR;
			if (value & RESET_ERR) StatReg &= ~IRQ;
			if ((CtrlReg & SIO_RESET) || (!CtrlReg)) {
				padst = 0; mcdst = 0; parp = 0;
				StatReg = TX_RDY | TX_EMPTY;
				memset(buf, 0, sizeof(buf));
			}
			break;
		case 0x1f80104e: // baudrate register
			BaudReg = value;
			break;
	}

}
//---------------------------------------------------------------------------
void sioWrite32(unsigned long value) {
	sioWrite8((unsigned char)value);
	sioWrite8((unsigned char)((value&0xff) >>  8));
	sioWrite8((unsigned char)((value&0xff) >> 16));
	sioWrite8((unsigned char)((value&0xff) >> 24));
}
//---------------------------------------------------------------------------
void LoadMcds(char *mcd1, char *mcd2) {
	FILE *f;

	if ( *mcd1 == 0 )
        	strcpy( mcd1, "Mcd001.mcr" );

	f = fopen( mcd1, "r" );

	if ( f == NULL ) {
		CreateMcd( mcd1 );
		f = fopen( mcd1, "r" );
		if ( f != NULL ) {
			fread( Mcd1Data, 1, MCD_SIZE, f );
			fclose( f );
		} else  {
                	char *ptmp = new char[ MAX_PATH ];
                        ZeroMemory( ptmp, MAX_PATH );
                        sprintf( ptmp, "Failed loading MemCard %s\n", mcd1 );
                        SystemMessage( AnsiString( ptmp ) );
                        delete ptmp;
                }
	} else {
		fread( Mcd1Data, 1, MCD_SIZE, f );
		fclose( f );
	}

	if ( *mcd2 == 0 )
        	strcpy( mcd2, "Mcd002.mcr" );

	f = fopen( mcd2, "r" );
	if ( f == NULL ) {
		CreateMcd( mcd2 );
		f = fopen( mcd2, "r" );
		if ( f != NULL ) {
			fread( Mcd2Data, 1, MCD_SIZE, f );
			fclose( f );
		} else {
                	char *ptmp = new char[ MAX_PATH ];
                        ZeroMemory( ptmp, MAX_PATH );
                        sprintf( "Failed loading MemCard %s\n", mcd2 );
                        SystemMessage( AnsiString( ptmp ) );
                }
	} else {
		fread( Mcd2Data, 1, MCD_SIZE, f );
		fclose( f );
	}
}
//---------------------------------------------------------------------------
void SaveMcd(char *mcd, char *data, unsigned long adr) {
	FILE *f;

	f = fopen(mcd, "ab");
	if (f != NULL) {
		fseek(f, adr, SEEK_SET);
		fwrite(data + adr, 1, 128, f);
		fclose(f);
	}

	// try to create it again if we can't open it
	f = fopen(mcd, "wb");
	if (f != NULL) {
		fwrite(data, 1, MCD_SIZE, f);
		fclose(f);
	}
}
//---------------------------------------------------------------------------
void CreateMcd(char *mcd) {
	FILE *f;
	int s = MCD_SIZE;

	f = fopen(mcd, "w");
	if (f == NULL) return;
	fputc('M', f); s--;
	fputc('C', f); s--;
	while (s-- > (MCD_SIZE-127)) fputc(0, f);
	fputc(0xe, f); s--;
	while ((s--)>=0)
		fputc(0, f);
	fclose(f);
}
//---------------------------------------------------------------------------
