//---------------------------------------------------------------------------
#ifndef SIOH
#define SIOH
//---------------------------------------------------------------------------
#ifndef EMULATOR_DLL_H
#include "EmulatorDLL.h"
#endif
//---------------------------------------------------------------------------
#define MCD_SIZE	(1024 * 8 * 16)	//	Memory card size
//---------------------------------------------------------------------------
// 	Status Flags
//---------------------------------------------------------------------------
#define TX_RDY		0x0001
#define RX_RDY		0x0002
#define TX_EMPTY	0x0004
#define PARITY_ERR	0x0008
#define RX_OVERRUN	0x0010
#define FRAMING_ERR	0x0020
#define SYNC_DETECT	0x0040
#define DSR		0x0080
#define CTS		0x0100
#define IRQ		0x0200
//---------------------------------------------------------------------------
// 	Control Flags
//---------------------------------------------------------------------------
#define TX_PERM		0x0001
#define DTR		0x0002
#define RX_PERM		0x0004
#define BREAK		0x0008
#define RESET_ERR	0x0010
#define RTS		0x0020
#define SIO_RESET	0x0040
//---------------------------------------------------------------------------
unsigned char sioRead8();
unsigned short sioRead16(unsigned long add);
unsigned long sioRead32();
void sioWrite8(unsigned char value);
void sioWrite16(unsigned long add, unsigned short value);
void sioWrite32(unsigned long value);
//int sioFreeze(gzFile f, int Mode);
//---------------------------------------------------------------------------
void LoadMcds(char *mcd1, char *mcd2);
void SaveMcd(char *mcd, char *data, unsigned long adr);
void CreateMcd(char *mcd);
//---------------------------------------------------------------------------
class	PSX_SIO : public TObject
	{
        	protected:
                private:
                public:
                		__fastcall	PSX_SIO		( void );
                                __fastcall	~PSX_SIO	( void );

                	int	__fastcall	Initialise	( void );
                        void	__fastcall	Terminate	( void );

                        void	__fastcall	Reset		( void );
        };
//---------------------------------------------------------------------------
__declspec( dllimport )	PSX_SIO	*PsxSIO;
//---------------------------------------------------------------------------
#endif
//---------------------------------------------------------------------------
