//---------------------------------------------------------------------------
#include <vcl.h>
//---------------------------------------------------------------------------
#pragma hdrstop
//---------------------------------------------------------------------------
#include "TimUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
__fastcall	TimImage :: TimImage( void ) : TBitmap()
{
	pHeader = new TIMHEADER;
        pCLUT = new TIMCLUT;
        pImage = new TIMIMAGE;

        memset( pHeader, 0, sizeof( TIMHEADER ) );
        memset( pCLUT, 0, sizeof( TIMCLUT ) );
        memset( pImage, 0, sizeof( TIMIMAGE ) );
}
//---------------------------------------------------------------------------
__fastcall	TimImage :: ~TimImage( void )
{
	if ( pImage ) {
        	if ( pImage->Data )	delete []pImage->Data;

                delete pImage;
        }

        if ( pCLUT ) {
        	if ( pCLUT->Data )	delete []pCLUT->Data;

                delete pCLUT;
        }

        if ( pHeader ) {
        	delete pHeader;
        }

        delete this;
}
//---------------------------------------------------------------------------
void	__fastcall	TimImage :: LoadFromStream( Classes::TStream* Stream )
{
	if ( !Stream )	return;

        if ( !pHeader )	pHeader = new TIMHEADER;

        memset( pHeader, 0, sizeof( TIMHEADER ) );

        Stream->Read( pHeader, sizeof( TIMHEADER ) );

        if ( pHeader->id != TIMHDR_MAGIC )	return;	//	Bad file

        if ( pHeader->flags && TIMHDR_CLUT_PRESENT ) {	//	CLUT Present ?
        	pCLUT = new TIMCLUT;

                memset( pCLUT, 0, sizeof( TIMCLUT ) );

                Stream->Read( pCLUT, sizeof( TIMCLUT ) );

                pCLUT->Data = new WORD[ pCLUT->dataLen ];

                memset( pCLUT->Data, 0, pCLUT->dataLen );

                Stream->Read( pCLUT->Data, pCLUT->dataLen - sizeof( TIMCLUT ) );
        }

        if ( !pImage )	pImage = new TIMIMAGE;

        memset( pImage, 0, sizeof( TIMIMAGE ) );

        Stream->Read( pImage, sizeof( TIMIMAGE ) );

        pImage->Data = new WORD[ pImage->dataLen ];

        memset( pImage->Data, 0, pImage->dataLen );

        Stream->Read( pImage->Data, pImage->dataLen - sizeof( TIMIMAGE ) );

        Modified = false;
}
//---------------------------------------------------------------------------
void	__fastcall	TimImage :: SaveToStream( Classes::TStream* Stream )
{
	if ( !Stream )	return;

        if ( ( !pHeader ) || ( !pImage ) )	return;	//	No image

	Stream->Write( pHeader, sizeof( TIMHEADER ) );

        if ( pHeader->flags && TIMHDR_CLUT_PRESENT ) {
        	Stream->Write( pCLUT, sizeof( TIMCLUT ) );
                Stream->Write( pCLUT->Data, pCLUT->dataLen - sizeof( TIMCLUT ) );
        }

        Stream->Write( pImage, sizeof( TIMIMAGE ) );

        Stream->Write( pImage->Data, pImage->dataLen - sizeof( TIMIMAGE ) );

        Modified = false;
}
//---------------------------------------------------------------------------
