//---------------------------------------------------------------------------
#ifndef TimUnitH
#define TimUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <System.hpp>
#include <SysUtils.hpp>
//---------------------------------------------------------------------------
#include <windows.h>
#include <windowsx.h>
//---------------------------------------------------------------------------
#define TIMHDR_MAGIC		0x00000010
//---------------------------------------------------------------------------
#define TIMHDR_4BIT		0
#define TIMHDR_8BIT             1
#define TIMHDR_15BIT            2
#define TIMHDR_24BIT            3
#define TIMHDR_MIXED            4
#define TIMHDR_CLUT_PRESENT     8
//---------------------------------------------------------------------------
#define BMP_TYPE_TIM		0
#define BMP_TYPE_GIF            1
#define BMP_TYPE_TIFF           2
#define BMP_TYPE_PCX            3
#define BMP_TYPE_BMP            4
#define BMP_TYPE_WMF            5
#define BMP_TYPE_ICO            6
#define BMP_TYPE_JPG            7
#define BMP_TYPE_JPEG           7
#define BMP_TYPE_TGA            8
//---------------------------------------------------------------------------
typedef struct _tim_header_ {
	DWORD	id;		//	TIMHDR_MAGIC
        DWORD	flags;		//	TIMHDR_xxxxx
        } TIMHEADER, *LPTIMHEADER;
//---------------------------------------------------------------------------
typedef struct _tim_clut_ {
	DWORD		dataLen;	//	inc this word
        SMALL_RECT	vRamPos;
        WORD		*Data;		//	16 or 256 entries
        } TIMCLUT, *LPTIMCLUT;
//---------------------------------------------------------------------------
typedef struct _tim_image_ {
	DWORD		dataLen;
        SMALL_RECT	vRamPos;
        WORD		*Data;
        } TIMIMAGE, *LPTIMIMAGE;
//---------------------------------------------------------------------------
class	TimImage : public TBitmap
	{
        	protected:
                	void	__fastcall	LoadFromStream	( Classes::TStream* Stream );
                        void	__fastcall	SaveToStream	( Classes::TStream* Stream );

                        //void	__fastcall	Draw		( void );
                private:
                	LPTIMHEADER	pHeader;
                        LPTIMCLUT	pCLUT;
                        LPTIMIMAGE	pImage;

                        bool		bModified;
                public:
                	__fastcall	TimImage		( void );
                        __fastcall	~TimImage		( void );

                __published:
                	__property	bool	Modified	= { read=bModified, write=bModified, stored=true, default=false };
        };
//---------------------------------------------------------------------------
#endif
//---------------------------------------------------------------------------
