//----------------------------------------------------------------------------
#ifndef ChildWinH
#define ChildWinH
//----------------------------------------------------------------------------
#include <Classes.hpp>
#include <Windows.hpp>
#include <System.hpp>
#include <StdCtrls.hpp>
#include <Dialogs.hpp>
#include <Menus.hpp>
#include <ComCtrls.hpp>
#include <ActnList.hpp>
#include <ImgList.hpp>
#include <Registry.hpp>
#include <ExtCtrls.hpp>
#include <Controls.hpp>
#include "SynEdit.hpp"
#include "SynEditHighlighter.hpp"
#include "SynHighlighterCpp.hpp"
#include "SynHighlighterDfm.hpp"
#include "SynEditPrint.hpp"
#include "SynAutoCorrect.hpp"
#include "SynCompletionProposal.hpp"
#include "SynHighlighterAsm.hpp"
#include "SynHighlighterBat.hpp"
#include "SynHighlighterPas.hpp"
//----------------------------------------------------------------------------
class 	TMDIChild	:	public	TForm
	{	friend  class	TMainForm;
        	friend	class	TProjectManagerForm;
                protected:
	__published:
	        TPopupMenu *PopupMenu1;
	        TMenuItem *OpenHeader1;
	        TMenuItem *ClosePage1;
	        TMenuItem *N1;
	        TMenuItem *Properties1;
	        TFontDialog *FontDialog1;
	        TMenuItem *ShowMessagesView1;
	        TMenuItem *ReadOnly1;
	        TMenuItem *N2;
	        TMenuItem *DebugWindows1;
	        TMenuItem *N3;
	        TMenuItem *ToggleBookmark1;
	        TMenuItem *GotoBookmark1;
	        TMenuItem *N4;
	        TMenuItem *TopicSearch1;
	        TMenuItem *OpenFileAtCursor1;
		TSynEdit *SynEdit1;
		TSynCppSyn *SynCppSyn1;
	TSynEditPrint *SynEditPrint1;
	TSynAutoComplete *SynAutoComplete1;
	TSynCompletionProposal *SynCompletionProposal1;
	TSynAutoCorrect *SynAutoCorrect1;
	TSynDfmSyn *SynDfmSyn1;
	TSynBatSyn *SynBatSyn1;
	TSynPasSyn *SynPasSyn1;
	TSynAsmSyn *SynAsmSyn1;

	        void __fastcall Properties1Click(TObject *Sender);
	void __fastcall ReadOnly1Click(TObject *Sender);
	void __fastcall FontDialog1Apply(TObject *Sender, HWND Wnd);
	void __fastcall FormKeyPress(TObject *Sender, char &Key);
	void __fastcall SynEdit1Paint(TObject *Sender, TCanvas *ACanvas);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall OpenFileAtCursor1Click(TObject *Sender);
	void __fastcall FormCreate(TObject *Sender);
	private:
		AnsiString	asFileName;
                int		Index;		//	This refers to the project manager form listview only
                // it should match the CurrModule if part of a project else -1

	        void		__fastcall	IDEClose ( TObject *Sender );	//	Called from MainForm
                void		__fastcall	IDESave  ( TObject *Sender );	//	Called from MainForm

		//	PROPERTY READ METHODS
	        AnsiString	__fastcall	GFileName( void );
	        bool		__fastcall	GModified( void );
	        //	PROPERTY WRITE METHODS
	        void		__fastcall	SFileName( AnsiString Value );
	        void		__fastcall	SModified( bool Value );

	        //	ALLOWS THE MAIN OR PROJECT MANAGER FORMS TO WRITE TO THE CHILD
                void		__fastcall	ChildWrite( AnsiString Value );

	public:
		virtual __fastcall TMDIChild(TComponent *Owner);
	__published:
		// 	PROPERTIES DEFINITIONS
		__property AnsiString   FileName = { read=GFileName, write=SFileName, stored=true  			};
	        __property bool		Modified = { read=GModified, write=SModified, stored=true, default=false 	};
	};
//----------------------------------------------------------------------------
#endif
//----------------------------------------------------------------------------
