//---------------------------------------------------------------------------
#ifndef DebuggingUnitH
#define DebuggingUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>
#include <Registry.hpp>
//---------------------------------------------------------------------------
#include "Defines.h"
#include "RegEntries.h"
//---------------------------------------------------------------------------
class TDebugOptionsForm : public TForm
{	friend	class	TMainForm;
	protected:	//	User methods
        	void	__fastcall	Execute	( void );	//	Executes the emulator in debug mode

                void	__fastcall	WriteToRegistry		( TObject *Sender );
                void	__fastcall	ReadFromRegistry	( TObject *Sender );

__published:	// IDE-managed Components
        TPanel *Panel1;
        TPageControl *PageControl1;
        TTabSheet *TabSheet1;
        TTabSheet *TabSheet2;
        TTabSheet *TabSheet3;
        TBitBtn *BitBtn1;
        TBitBtn *BitBtn2;
        TBitBtn *BitBtn3;
        TLabel *Label3;
        TLabel *Label4;
        TEdit *Edit1;
        TSpeedButton *SpeedButton1;
        TOpenDialog *OpenDialog1;
        TRadioGroup *RadioGroup1;
        TRadioGroup *RadioGroup2;
        TPanel *Panel2;
        TLabel *Label1;
        TLabel *Label2;
        TComboBox *ComboBox1;
        TComboBox *ComboBox2;
	TListView *ListView1;
	TLabel *Label5;
        void __fastcall BitBtn1Click(TObject *Sender);
        void __fastcall BitBtn2Click(TObject *Sender);
        void __fastcall SpeedButton1Click(TObject *Sender);
	void __fastcall ComboBox1Change(TObject *Sender);
	void __fastcall ComboBox2Change(TObject *Sender);
	void __fastcall RadioGroup2Click(TObject *Sender);
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall BitBtn3Click(TObject *Sender);
private:	// User declarations
	TRegistry	*Registry;
        bool            bModified;

	//	PROPERTY	READ METHODS
        AnsiString      __fastcall      GDebugPath      ( void );
        AnsiString      __fastcall      GDebugFlags     ( int Index );
        int             __fastcall      GPort           ( void );
        int             __fastcall      GSpeed          ( void );
        int		__fastcall	GDebuggerMode	( void );
        int		__fastcall	GDebuggerType	( void );
        //	PROPERTY	WRITE METHODS
        void            __fastcall      SDebugPath      ( AnsiString Value );
        void            __fastcall      SDebugFlags     ( int Index, AnsiString Value );
        void            __fastcall      SPort           ( int Value );
        void            __fastcall      SSpeed          ( int Value );
        void		__fastcall	SDebuggerMode	( int Value );
        void		__fastcall	SDebuggerType	( int Value );
public:		// User declarations
        __fastcall TDebugOptionsForm(TComponent* Owner);
__published:
        __property bool         Modified     		= { read=bModified,   	write=bModified,   	stored=true, default=false };
        __property AnsiString   DebugPath    		= { read=GDebugPath,  	write=SDebugPath,  	stored=true, nodefault 	   };
        __property AnsiString   DebugFlags[ int Index ] = { read=GDebugFlags, 	write=SDebugFlags };
        __property int          DebugPort    		= { read=GPort, 	write=SPort, 		stored=true, default=-1    };
        __property int          DebugSpeed   		= { read=GSpeed, 	write=SSpeed, 		stored=true, default=-1    };
        __property int		DebuggerMode 		= { read=GDebuggerMode, write=SDebuggerMode, 	stored=true, default=0     };
        __property int		DebuggerType 		= { read=GDebuggerType, write=SDebuggerType, 	stored=true, default=0     };
};
//---------------------------------------------------------------------------
extern PACKAGE TDebugOptionsForm *DebugOptionsForm;
//---------------------------------------------------------------------------
#endif
//---------------------------------------------------------------------------
