//---------------------------------------------------------------------------
//
//      $FileName       ::      Defines.h
//      $Author         ::      Chris Brooklyn
//      $Description    ::      Provides a common location for defines
//                              Note this file does not include the registry entry
//                              location definitions, I want to keep them seperate
//      $Author         ::      0.1.0.0
//
//---------------------------------------------------------------------------
#ifndef DefinesH
#define DefinesH
//---------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
//---------------------------------------------------------------------------
#ifndef RegEntriesH
#include "RegEntries.h"
#endif
//---------------------------------------------------------------------------
#define	METHOD_CALLER( method, caller )	SystemMessage( AnsiString( method ) + " called from " + AnsiString( dynamic_cast<TComponent*>(caller)->Name ) )
//---------------------------------------------------------------------------
//      Standard Program Installation Paths
//---------------------------------------------------------------------------
//		DOXYGEN
//---------------------------------------------------------------------------
#define DOXYGEN_INSTALL_DIR	AnsiString( "C:\\Program Files\\doxygen" )
//---------------------------------------------------------------------------
//	PSXIDE
//---------------------------------------------------------------------------
#define PSXIDE_INSTALL_DIR      AnsiString( "C:\\Program Files\\Liquid Silicon Developments\\PSX IDE For Windows" )
//---------------------------------------------------------------------------
//	Subdirectories off the PSXIDE_INSTALL_DIR
//---------------------------------------------------------------------------
#define TEMPLATES_DIR           AnsiString( PSXIDE_INSTALL_DIR + "\\Templates" )
#define CONFIG_DIR              AnsiString( PSXIDE_INSTALL_DIR + "\\Config"    )
#define PROJECTS_DIR            AnsiString( PSXIDE_INSTALL_DIR + "\\Projects"  )
#define PLATFORM_DIR            AnsiString( PSXIDE_INSTALL_DIR + "\\Platform"  )
#define PLUGINS_DIR		AnsiString( PSXIDE_INSTALL_DIR + "\\Plugins" )
//---------------------------------------------------------------------------
//	Base directory for the GNU Compiler Set
//---------------------------------------------------------------------------
#define GCC_INSTALL_BASE_DIR	AnsiString( "C:\\GCC" )
//---------------------------------------------------------------------------
//	sub-directories off the base directory GCC_INSTALL_DIR
//---------------------------------------------------------------------------
#define CC_PATH                 AnsiString( GCC_INSTALL_BASE_DIR + "\\bin" )
#define AS_PATH                 AnsiString( GCC_INSTALL_BASE_DIR + "\\bin" )
#define LD_PATH                 AnsiString( GCC_INSTALL_BASE_DIR + "\\bin" )
#define GDB_PATH                AnsiString( GCC_INSTALL_BASE_DIR + "\\bin" )
#define MAKE_PATH               AnsiString( GCC_INSTALL_BASE_DIR + "\\bin" )
//---------------------------------------------------------------------------
//      Standard Programs and Flags
//---------------------------------------------------------------------------
#define CC_BIN          	AnsiString( "gcc.exe" )
#define AS_BIN          	AnsiString( "as.exe" )
#define LD_BIN          	AnsiString( "ld.exe" )
#define GDB_BIN         	AnsiString( "gdb.exe" )
#define MAKE_BIN        	AnsiString( "make.exe" )
//---------------------------------------------------------------------------
//      Code Optimisation Levels
//---------------------------------------------------------------------------
#define CODE_OPTIMISE_UNKNOWN   -1
#define CODE_OPTIMISE_NONE      0
#define CODE_OPTIMISE_SPEED     1
#define CODE_OPTIMISE_SELECTED	2
//---------------------------------------------------------------------------
//      Warning Levels
//---------------------------------------------------------------------------
#define WARNINGS_UNKNOWN        -1
#define WARNINGS_NONE           0
#define WARNINGS_ALL            1
#define WARNINGS_SELECTED       2
//---------------------------------------------------------------------------
//	Data Alignment
//---------------------------------------------------------------------------
#define DATA_ALIGNMENT_UNKNOWN	-1
#define DATA_ALIGNMENT_BYTE	0
#define DATA_ALIGNMENT_WORD     1
#define DATA_ALIGNMENT_DWORD    2
#define DATA_ALIGNMENT_LWORD    3
#define DATA_ALIGNMENT_DEFAULT	DATA_ALIGNMENT_WORD		// 16-bit default data-alignment
//---------------------------------------------------------------------------
//	REGISTER VARIABLES
//---------------------------------------------------------------------------
#define REGISTER_VARIABLES_UNKNOWN 	-1
#define REGISTER_VARIABLES_NONE		0
#define REGISTER_VARIABLES_AUTOMATIC	1
#define REGISTER_VARIABLES_KEYWORD	2
#define REGISTER_VARIABLES_DEFAULT	REGISTER_VARIABLES_NONE
//---------------------------------------------------------------------------
// Instruction Sets
//---------------------------------------------------------------------------
#define PSX_INSTRUCTION_SET     AnsiString( "R&3000 ( PSX )" )
#define PS2_INSTRUCTION_SET     AnsiString( "R&3000 ( IOP )\nR&5900 ( EE )" )
#define N64_INSTRUCTION_SET     AnsiString( "R&4000 ( N64 )" )
#define PS2L_INSTRUCTION_SET    AnsiString( "R&3000 ( IOP )\nR&5900 ( EE )" )
#define PCL_INSTRUCTION_SET     AnsiString( "i&486\n&Pentium\nP&entium Pro\nPentium &II\nPe&ntium III" )
#define PCW_INSTRUCTION_SET     AnsiString( "i&486\n&Pentium\nP&entium Pro\nPentium &II\nPe&ntium III" )
//---------------------------------------------------------------------------
// 	Supported Platforms Identifiers, only the following 5 are defined at
// present, but more can be added if the relevant code where to be introduced
// into the source tree
//---------------------------------------------------------------------------
#define PLATFORM_PSX            0x0000
#define PLATFORM_PS2            0x0001
#define PLATFORM_N64            0x0002
#define PLATFORM_PS2L           0x0003
#define PLATFORM_PCL            0x0004
#define PLATFORM_PCW            0x0005
//---------------------------------------------------------------------------
//	Specifies whether the project's executable is to be run under the emulator
// or dumped to a target console if possible
//---------------------------------------------------------------------------
#define PLATFORM_EMULATED       0x8000
#define PLATFORM_DEBUGGED	0xF000	//	Similar to the above but for execution via debugger control
//---------------------------------------------------------------------------
//	Specifies whether the project's executable is to be downloaded to the target machine prior to execution
//---------------------------------------------------------------------------
#define PLATFORM_NATIVE         0x0800
//---------------------------------------------------------------------------
#define PLATFORM_DEFAULT        PLATFORM_EMULATED + PLATFORM_PSX			//	Defaults to an emulated PlayStation
//---------------------------------------------------------------------------
#define PLATFORM_STR_PSX        AnsiString( "PlayStation")
#define PLATFORM_STR_PS2        AnsiString( "PlayStation 2")
#define PLATFORM_STR_N64        AnsiString( "Nintendo 64")
#define PLATFORM_STR_PS2L       AnsiString( "PlayStation 2 Linux")
#define PLATFORM_STR_PCL        AnsiString( "PC Linux")
#define PLATFORM_STR_PCW        AnsiString( "PC Windows")
//---------------------------------------------------------------------------
#define PROJECT_TYPE_UNSELECTED		0x0000
#define PROJECT_TYPE_APPLICATION	0x0001
#define PROJECT_TYPE_BATCH_FILE		0x0002
#define PROJECT_TYPE_COMPONENT		0x0003
#define PROJECT_TYPE_CONSOLE		0x0004
#define PROJECT_TYPE_DATA_MODULE	0x0005
#define PROJECT_TYPE_WINDLL		0x0006
#define PROJECT_TYPE_FORM		0x0007
#define PROJECT_TYPE_LIBRARY		0x0008
#define PROJECT_TYPE_PACKAGE		0x0009
#define PROJECT_TYPE_PROJECT_GROUP	0x000A
#define PROJECT_TYPE_TEXT		0x000B
#define PROJECT_TYPE_THREAD		0x000C
#define PROJECT_TYPE_UNIT		0x000D
#define PROJECT_TYPE_FORM_ABOUT_BOX	0x000E
#define PROJECT_TYPE_MDI_APPLICATION	0x000F
#define PROJECT_TYPE_SDI_APPLICATION	0x0010
#define PROJECT_TYPE_LOGO_APPLICATION	0x0011
#define PROJECT_TYPE_SPLASH_APPLICATION	0x0012
#define PROJECT_TYPE_DEFAULT		PROJECT_TYPE_APPLICATION
//---------------------------------------------------------------------------
#define MODULE_TEXT			0
#define MODULE_MAIN			1
#define MODULE_UNIT			2
#define MODULE_CLASS			3
#define MODULE_THREAD			4
//---------------------------------------------------------------------------
//	Language interfaces
//---------------------------------------------------------------------------
#define LANGUAGE_NULL			-1	//	Unknown language
#define LANGUAGE_C			0	//	Standard C
#define LANGUAGE_CPP			1	//	Standard C++
#define LANGUAGE_PASCAL			2	//	Note the rest of these are ignored in the ide
#define LANGUAGE_PHP                    3	//	and will be implemented in future releases
#define LANGUAGE_JAVA                   4	//	Feel free to add/modify at your pleasure :)
#define LANGUAGE_SQL                    5
#define LANGUAGE_PERL                   6
#define LANGUAGE_PYTHON                 7
//---------------------------------------------------------------------------
//	These are used to determine the interface that is wanted
//---------------------------------------------------------------------------
#define	INTERFACE_NULL			-1	//	No interface defined
#define INTERFACE_CLI			0	//	Console interface
#define INTERFACE_GUI			1	//	GUI Interface, Linux or Windows
#define INTERFACE_OPENGL		2	//	GUI Interface, with Open GL support, Linux or Windows
#define INTERFACE_DIRECTX		3       //	GUI Interface, with Direct X support, Windows only
#define INTERFACE_DLL			4       //	DLL Interface Windows Only
//---------------------------------------------------------------------------
// Be carefull with these as they determine the source directory for the
// platform specific binary paths, library paths, include paths
// The reason for a lot of text string concatenation is that we can work
// out filenames quicker if we known that the strings have specific parts
// of specific lengths at specific positions, easier later for VCL shit
//---------------------------------------------------------------------------
#define PLATFORM_PSX_DIR        AnsiString( AnsiString( PLATFORM_DIR + "\\" ) + PLATFORM_STR_PSX  )
#define PLATFORM_PS2_DIR        AnsiString( AnsiString( PLATFORM_DIR + "\\" ) + PLATFORM_STR_PS2  )
#define PLATFORM_N64_DIR        AnsiString( AnsiString( PLATFORM_DIR + "\\" ) + PLATFORM_STR_N64  )
#define PLATFORM_PS2L_DIR       AnsiString( AnsiString( PLATFORM_DIR + "\\" ) + PLATFORM_STR_PS2L )
#define PLATFORM_PCL_DIR        AnsiString( AnsiString( PLATFORM_DIR + "\\" ) + PLATFORM_STR_PCL  )
#define PLATFORM_PCW_DIR        AnsiString( AnsiString( PLATFORM_DIR + "\\" ) + PLATFORM_STR_PCW  )
//---------------------------------------------------------------------------
#define PSX_CC_PATH             AnsiString( PLATFORM_PSX_DIR  + "\\bin" )
#define PS2_CC_PATH             AnsiString( PLATFORM_PS2_DIR  + "\\bin" )
#define N64_CC_PATH             AnsiString( PLATFORM_N64_DIR  + "\\bin" )
#define PS2L_CC_PATH            AnsiString( PLATFORM_PS2L_DIR + "\\bin" )
#define PCL_CC_PATH             AnsiString( PLATFORM_PCL_DIR  + "\\bin" )
#define PCW_CC_PATH             AnsiString( PLATFORM_PCW_DIR  + "\\bin" )
//---------------------------------------------------------------------------
#define PSX_LIB_PATH            AnsiString( PLATFORM_PSX_DIR  + "\\lib" )
#define PS2_LIB_PATH            AnsiString( PLATFORM_PS2_DIR  + "\\lib" )
#define N64_LIB_PATH            AnsiString( PLATFORM_N64_DIR  + "\\lib" )
#define PS2L_LIB_PATH           AnsiString( PLATFORM_PS2L_DIR + "\\lib" )
#define PCL_LIB_PATH            AnsiString( PLATFORM_PCL_DIR  + "\\lib" )
#define PCW_LIB_PATH            AnsiString( PLATFORM_PCW_DIR  + "\\lib" )
//---------------------------------------------------------------------------
#define PSX_INC_PATH            AnsiString( PLATFORM_PSX_DIR  + "\\include" )
#define PS2_INC_PATH            AnsiString( PLATFORM_PS2_DIR  + "\\include" )
#define N64_INC_PATH            AnsiString( PLATFORM_N64_DIR  + "\\include" )
#define PS2L_INC_PATH           AnsiString( PLATFORM_PS2L_DIR + "\\include" )
#define PCL_INC_PATH            AnsiString( PLATFORM_PCL_DIR  + "\\include" )
#define PCW_INC_PATH            AnsiString( PLATFORM_PCW_DIR  + "\\include" )
//---------------------------------------------------------------------------
#define PSX_CC                  CC_BIN
#define PSX_AS                  AS_BIN
#define PSX_LD                  LD_BIN
#define PSX_GDB                 GDB_BIN
//---------------------------------------------------------------------------
#define PS2_CC                  CC_BIN
#define PS2_AS                  AS_BIN
#define PS2_LD                  LD_BIN
#define PS2_GDB                 GDB_BIN
//---------------------------------------------------------------------------
#define N64_CC                  CC_BIN
#define N64_AS                  AS_BIN
#define N64_LD                  LD_BIN
#define N64_GDB                 GDB_BIN
//---------------------------------------------------------------------------
#define PS2L_CC                 CC_BIN
#define PS2L_AS                 AS_BIN
#define PS2L_LD                 LD_BIN
#define PS2L_GDB                GDB_BIN
//---------------------------------------------------------------------------
#define PCL_CC                  CC_BIN
#define PCL_AS                  AS_BIN
#define PCL_LD                  LD_BIN
#define PCL_GDB                 GDB_BIN
//---------------------------------------------------------------------------
#define PCW_CC                  CC_BIN
#define PCW_AS                  AS_BIN
#define PCW_LD                  LD_BIN
#define PCW_GDB                 GDB_BIN
//---------------------------------------------------------------------------
#define NUM_PLATFORMS           6
//---------------------------------------------------------------------------
// These, in combination with the above, determine which platform is being
// compiled for. ie PlatFormStrings[ ProjectOptionsForm->PlatformId ] will
// give the string for the desired platform, for compiler paths, binaries,
// etc, etc. See documentation for more info. These are stored as part of the
// project options, and form part of the default ide configurations
// HELP IDENTIFIER $_:DOC_INFO:Platform Specific:Paths:_$
//---------------------------------------------------------------------------
static AnsiString PlatFormStrings[ NUM_PLATFORMS ] = { PLATFORM_STR_PSX,  PLATFORM_STR_PS2, PLATFORM_STR_N64, PLATFORM_STR_PS2L, PLATFORM_STR_PCL, PLATFORM_STR_PCW };
//---------------------------------------------------------------------------
//	DO NOT RE-ENABLE THESE CAUSES THE RTL TO FUBAR. OOPS! :(
//	Needs to be changed from strcat's to AnsiString( str1 + str<n> ) ;)
//---------------------------------------------------------------------------
//static AnsiString	*CompilerPaths  [ NUM_PLATFORMS ] = { &PSX_CC_PATH, &PS2_CC_PATH, &N64_CC_PATH, &PS2L_CC_PATH, &PCL_CC_PATH, &PCW_CC_PATH };
//static AnsiString	*AssemblerPaths [ NUM_PLATFORMS ] = { &PSX_CC_PATH, &PS2_CC_PATH, &N64_CC_PATH, &PS2L_CC_PATH, &PCL_CC_PATH, &PCW_CC_PATH };
//static AnsiString	*LinkerPaths    [ NUM_PLATFORMS ] = { &PSX_CC_PATH, &PS2_CC_PATH, &N64_CC_PATH, &PS2L_CC_PATH, &PCL_CC_PATH, &PCW_CC_PATH };
//static AnsiString	*DebuggerPaths  [ NUM_PLATFORMS ] = { &PSX_CC_PATH, &PS2_CC_PATH, &N64_CC_PATH, &PS2L_CC_PATH, &PCL_CC_PATH, &PCW_CC_PATH };
//---------------------------------------------------------------------------
//static AnsiString	*Compilers      [ NUM_PLATFORMS ] = { &PSX_CC, &PS2_CC, &N64_CC, &PS2L_CC, &PCL_CC, &PCW_CC };
//static AnsiString	*Assemblers     [ NUM_PLATFORMS ] = { &PSX_AS, &PS2_AS, &N64_AS, &PS2L_AS, &PCL_AS, &PCW_AS };
//static AnsiString	*Linkers        [ NUM_PLATFORMS ] = { &PSX_LD, &PS2_LD, &N64_LD, &PS2L_LD, &PCL_LD, &PCW_LD };
//static AnsiString	*Debuggers      [ NUM_PLATFORMS ] = { &PSX_LD, &PS2_LD, &N64_LD, &PS2L_LD, &PCL_LD, &PCW_LD };
//---------------------------------------------------------------------------
#define	MAX_IDE_TOOLS	16
//---------------------------------------------------------------------------
//	COMMUNICATIONS SETUP SECTION
//---------------------------------------------------------------------------
#define COMMS_PORT_UNDEFINED		-1
#define COMMS_PORT_SERIAL_AUTO		0
#define COMMS_PORT_SERIAL_1 		1
#define COMMS_PORT_SERIAL_2		2
#define COMMS_PORT_SERIAL_3		3
#define COMMS_PORT_SERIAL_4		4
//---------------------------------------------------------------------------
#define COMMS_PORT_PARALLEL_AUTO	5
#define COMMS_PORT_PARALLEL_1		6
#define COMMS_PORT_PARALLEL_2		7
//---------------------------------------------------------------------------
#define COMMS_PORT_USB_AUTO		8
#define COMMS_PORT_USB_1		9
#define COMMS_PORT_USB_2		10
#define COMMS_PORT_USB_3		11
#define COMMS_PORT_USB_4		12
//---------------------------------------------------------------------------
#define COMMS_PORT_NETWORK		13
//---------------------------------------------------------------------------
//	FILE FILTERS Used by open/save dialogs
//---------------------------------------------------------------------------
#define FILTER_PROJECT_GROUP_FILES	AnsiString( "Project Group files (*.psxgrp)|*.psxgrp" )
#define FILTER_PROJECT_FILES		AnsiString( "Project Files (*.psxprj)|*.psxprj" )
#define	FILTER_C_FILES			AnsiString( "C Source Files ( *.c )|*.c" )
#define FILTER_CPP_FILES		AnsiString( "C++ Source Files ( *.cpp; *.cc )|*.cpp; *.cc" )
#define FILTER_CCPP_FILES		AnsiString( "C/C++ Source files (*.c;*.cc;*.cpp)|*.c;*.cc;*.cpp" )
#define FILTER_CHEADER_FILES		AnsiString( "C Header files (*.h)|*.h" )
#define FILTER_CPPHEADER_FILES		AnsiString( "C++ Header files (*.hpp)|*.hpp" )
#define FILTER_HEADER_FILES		AnsiString( "C/C++ Header files (*.h;*.hpp)|*.h;*.hpp" )
#define FILTER_ASSEMBLER_FILES		AnsiString( "Assembler source files (*.s;*.asm)|*.s;*.asm" )
#define FILTER_TEXT_FILES		AnsiString( "Text Files (*.txt)|*.txt" )
#define FILTER_RICHTEXT_FILES		AnsiString( "Rich Text files (*.rtf)|*.rtf" )
#define FILTER_ALL_FILES		AnsiString( "All Files (*.*)|*.*" )
//---------------------------------------------------------------------------
//#define FILTER_DEFAULT                  "Project Group files (*.kondev)|*.kondev|Project Files (*.psxide)|*.psxide|C/C++ Source and header files (*.h;*.hpp;*.c;*.cc;*.cpp)|*.h;*.hpp;*.c;*.cc;*.cpp|Assembler source files (*.s;*.asm)|*.s;*.asm|Text Files (*.txt)|*.txt|All Files (*.*)|*.*"
//---------------------------------------------------------------------------
#define FILTER_DEFAULT			AnsiString( 	FILTER_PROJECT_GROUP_FILES  + "|" + \
							FILTER_PROJECT_FILES + "|" + FILTER_C_FILES + "|" \
                                                        + FILTER_CPP_FILES + "|" + FILTER_CCPP_FILES + "|" \
                                                        + FILTER_CHEADER_FILES + "|" + FILTER_CPPHEADER_FILES + "|" \
                                                        + FILTER_HEADER_FILES + "|" + FILTER_ASSEMBLER_FILES + "|" \
                                                        + FILTER_TEXT_FILES + "|" + FILTER_RICHTEXT_FILES + "|" \
                                                        + FILTER_ALL_FILES )
//---------------------------------------------------------------------------
#define DEFAULT_MAKE_PLATFORM	( PlatformStrings[ PLATFORM_DEFAULT ] )
#define DEFAULT_MAKE_FILENAME	"Makefile"	//	Default make file name Conforms to GNU standards
#define DEFAULT_MAKE_TARGET	"Clean"		//	Default Target for make operations
//---------------------------------------------------------------------------
//	DEBUG SECTION DEFINES
//---------------------------------------------------------------------------
#define DEBUGGER_INTEGRATED	0
#define DEBUGGER_STANDALONE	1
//---------------------------------------------------------------------------
#define DEBUGGER_LOCAL		0
#define DEBUGGER_REMOTE		1
//---------------------------------------------------------------------------
//	Error codes
//---------------------------------------------------------------------------
#define	E_NOERROR		0
#define E_BAD_SENDER		-1
#define E_BAD_PARAMS		-2
#define E_BAD_FILE		-3
#define E_BAD_HEADER		-4
#define E_BAD_NAME		-5
#define E_BAD_HOME		-6
#define E_BAD_COUNT		-7
#define E_BAD_TYPE		-8
#define E_NOPROJECT		-9
#define E_BAD_PROJECT		E_NOPROJECT
#define E_BAD_REGISTRY		-10
#define E_ABORTED		-11
//---------------------------------------------------------------------------
#endif
//---------------------------------------------------------------------------

