//---------------------------------------------------------------------------
//
//      $FileName       ::      EnviromentOptions.h
//      $Author         ::      Chris Brooklyn
//      $Version        ::      0.1.0.0
//      $TimeStamp      ::      28/05/02 12:39
//      $Description    ::      IDE Enviroment Options Configuration Form Header File
//
//---------------------------------------------------------------------------
#ifndef EnviromentOptionsUnitH
#define EnviromentOptionsUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>                  // Standard Base Classes
#include <Controls.hpp>                 // Control Classes
#include <StdCtrls.hpp>                 // Standard Control Classes
#include <Forms.hpp>                    // Form Classes
#include <Buttons.hpp>                  // Button Classes
#include <ComCtrls.hpp>                 // Component Control Classes
#include <ExtCtrls.hpp>                 // Extended Control Classes
#include <Dialogs.hpp>                  // Dialog Form Classes
#include <Registry.hpp>                 // Windows Registrary Classes
#include <Grids.hpp>
#include "CGRID.h"
//---------------------------------------------------------------------------
typedef struct _element_ {
	AnsiString	Name;
        int		ForeGround;
        int		BackGround;
        bool		Bold;
        bool		Italic;
        bool		UnderLine;
        bool		DefaultFore;
        bool		DefaultBack;
        } Element, *LPElement;
//---------------------------------------------------------------------------
class TEnviromentOptionsForm : public TForm
        {       // Allows the IDE to control the look and feel of the application
                friend  class   TMainForm;
                protected:
                __published:	// IDE-managed Components
        TPanel *Panel1;
        TPageControl *PageControl1;
        TBitBtn *BitBtn3;
        TTabSheet *Preferences;
        TTabSheet *Library;
        TTabSheet *Editor;
        TTabSheet *Display;
        TTabSheet *Colours;
        TTabSheet *Palette;
        TTabSheet *CodeInsight;
        TGroupBox *GroupBox1;
        TCheckBox *CheckBox1;
        TCheckBox *CheckBox2;
        TCheckBox *CheckBox3;
        TCheckBox *CheckBox4;
        TGroupBox *GroupBox2;
        TCheckBox *CheckBox5;
        TCheckBox *CheckBox6;
        TGroupBox *GroupBox3;
        TCheckBox *CheckBox7;
        TCheckBox *CheckBox8;
        TGroupBox *GroupBox4;
        TLabel *Label1;
        TEdit *Edit1;
        TSpeedButton *SpeedButton1;
        TGroupBox *GroupBox5;
        TLabel *Label2;
        TLabel *Label3;
        TLabel *Label4;
        TLabel *Label5;
        TSpeedButton *SpeedButton2;
        TSpeedButton *SpeedButton3;
        TSpeedButton *SpeedButton4;
        TSpeedButton *SpeedButton5;
        TEdit *Edit2;
        TEdit *Edit3;
        TEdit *Edit4;
        TEdit *Edit5;
        TGroupBox *GroupBox6;
        TCheckBox *CheckBox9;
        TCheckBox *CheckBox10;
        TCheckBox *CheckBox11;
        TCheckBox *CheckBox12;
        TCheckBox *CheckBox13;
        TCheckBox *CheckBox14;
        TCheckBox *CheckBox15;
        TCheckBox *CheckBox16;
        TCheckBox *CheckBox17;
        TCheckBox *CheckBox18;
        TCheckBox *CheckBox19;
        TCheckBox *CheckBox20;
        TCheckBox *CheckBox21;
        TCheckBox *CheckBox22;
        TCheckBox *CheckBox23;
        TCheckBox *CheckBox24;
        TCheckBox *CheckBox25;
        TGroupBox *GroupBox7;
        TGroupBox *GroupBox8;
        TCheckBox *CheckBox26;
        TCheckBox *CheckBox27;
        TCheckBox *CheckBox28;
        TCheckBox *CheckBox29;
        TGroupBox *GroupBox9;
        TComboBox *ComboBox1;
        TGroupBox *GroupBox10;
        TPanel *Panel2;
        TLabel *Label6;
        TEdit *Edit6;
        TUpDown *UpDown1;
        TLabel *Label7;
        TLabel *Label8;
        TFontDialog *FontDialog1;
        TEdit *Edit7;
        TGroupBox *GroupBox11;
        TCheckBox *CheckBox31;
        TCheckBox *CheckBox32;
        TCheckBox *CheckBox33;
        TLabel *Label9;
        TTrackBar *TrackBar1;
        TLabel *Label10;
        TLabel *Label11;
        TGroupBox *GroupBox12;
        TComboBox *ComboBox2;
        TLabel *Label12;
        TPanel *Panel3;
        TBitBtn *BitBtn4;
        TBitBtn *BitBtn5;
        TBitBtn *BitBtn6;
        TListView *ListView1;
        TLabel *Label13;
        TLabel *Label14;
        TRichEdit *RichEdit1;
        TBitBtn *BitBtn7;
        TBitBtn *BitBtn8;
        TBitBtn *BitBtn9;
        TBitBtn *BitBtn10;
        TBitBtn *BitBtn11;
        TLabel *Label17;
        TComboBox *ComboBox3;
        TGroupBox *GroupBox13;
        TGroupBox *GroupBox14;
        TColorDialog *ColorDialog1;
        TListView *ListView4;
        TLabel *Label18;
        TRichEdit *RichEdit2;
        TGroupBox *GroupBox15;
        TCheckBox *CheckBox34;
        TCheckBox *CheckBox35;
        TLabel *Label19;
        TLabel *Label20;
        TEdit *Edit8;
        TEdit *Edit9;
        TUpDown *UpDown2;
        TUpDown *UpDown3;
        TCheckBox *CheckBox30;
        TCheckBox *CheckBox36;
        TCheckBox *CheckBox37;
        TCheckBox *CheckBox38;
        TCheckBox *CheckBox39;
        TPanel *Panel5;
        TLabel *Label16;
        TListView *ListView3;
        TLabel *Label21;
        TBitBtn *BitBtn1;
        TBitBtn *BitBtn2;
	TCColorGrid *CColorGrid1;
	TSpeedButton *SpeedButton6;
	TOpenDialog *OpenDialog;
	TGroupBox *GroupBox16;
	TLabel *Label15;
	TEdit *Edit10;
	TSpeedButton *SpeedButton7;
	TGroupBox *GroupBox17;
	TLabel *Label22;
	TLabel *Label23;
	TLabel *Label24;
	TLabel *Label25;
	TLabel *Label26;
	TLabel *Label27;
	TEdit *Edit11;
	TEdit *Edit12;
	TEdit *Edit13;
	TEdit *Edit14;
	TEdit *Edit15;
	TEdit *Edit16;
	TSpeedButton *SpeedButton8;
	TSpeedButton *SpeedButton9;
	TSpeedButton *SpeedButton10;
	TSpeedButton *SpeedButton11;
	TSpeedButton *SpeedButton12;
	TSpeedButton *SpeedButton13;

        // IDE Component Methods
        void __fastcall DisplayShow(TObject *Sender);
        void __fastcall UpDown1Click(TObject *Sender, TUDBtnType Button);
        void __fastcall SpeedButton2Click(TObject *Sender);
        void __fastcall SpeedButton3Click(TObject *Sender);
        void __fastcall SpeedButton4Click(TObject *Sender);
        void __fastcall SpeedButton5Click(TObject *Sender);
        void __fastcall SpeedButton1Click(TObject *Sender);
        void __fastcall BitBtn1Click(TObject *Sender);
        void __fastcall BitBtn2Click(TObject *Sender);
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall SpeedButton6Click(TObject *Sender);
	void __fastcall BitBtn7Click(TObject *Sender);
	void __fastcall BitBtn8Click(TObject *Sender);
	void __fastcall ListView4Click(TObject *Sender);
	void __fastcall SpeedButton7Click(TObject *Sender);
	void __fastcall SpeedButton8Click(TObject *Sender);
	void __fastcall SpeedButton9Click(TObject *Sender);
	void __fastcall SpeedButton10Click(TObject *Sender);
	void __fastcall SpeedButton11Click(TObject *Sender);
	void __fastcall SpeedButton12Click(TObject *Sender);
	void __fastcall SpeedButton13Click(TObject *Sender);
        void __fastcall CColorGrid1Change(TObject *Sender);
        void __fastcall ColoursShow(TObject *Sender);
	void __fastcall ComboBox3Change(TObject *Sender);
private:	// User declarations
	TRegistry	*Registry;
        bool            bModified;
        int		NumElements;
        Element		*pElements;

        // Private Custom Methods
	int	__fastcall	WriteToRegistry		( TObject *Sender );
        int	__fastcall	ReadFromRegistry	( TObject *Sender );

        // Property Methods
        //	PREFERENCES TABSHEET	WRITE METHODS

        void    	__fastcall      SModified          	( bool Value );
        void		__fastcall	SShowCompilerProgress	( bool Value );
        void		__fastcall	SBeepOnCompletion	( bool Value );
        void		__fastcall	SCacheHeadersOnStartup	( bool Value );
        void		__fastcall	SWarnOnPackageRebuild	( bool Value );
        void		__fastcall	SAutoSaveEditorFiles	( bool Value );
        void		__fastcall	SAutoSaveDesktopFiles	( bool Value );
        void		__fastcall	SHideOnRun		( bool Value );
        void		__fastcall	SMinimiseOnRun		( bool Value );
        void		__fastcall	SSharedRepository	( AnsiString Value );
        void		__fastcall	SToolsRepository	( AnsiString Value );
        
	//				READ METHODS
        bool    	__fastcall      GModified          	( void );
        bool		__fastcall	GShowCompilerProgress	( void );
        bool		__fastcall	GBeepOnCompletion	( void );
        bool		__fastcall	GCacheHeadersOnStartup	( void );
        bool		__fastcall	GWarnOnPackageRebuild	( void );
        bool		__fastcall	GAutoSaveEditorFiles	( void );
        bool		__fastcall	GAutoSaveDesktopFiles	( void );
        bool		__fastcall	GHideOnRun		( void );
        bool		__fastcall	GMinimiseOnRun		( void );
        AnsiString	__fastcall	GSharedRepository	( void );
        AnsiString	__fastcall	GToolsRepository	( void );

        //	LIBRARY TABSHEET	READ METHODS
        AnsiString	__fastcall	GSystemLibraryPath	( void );
        AnsiString	__fastcall	GSystemPackageOutputPath( void );
        AnsiString	__fastcall	GSystemLibraryOutputPath( void );
        AnsiString	__fastcall	GSystemBrowsingPath	( void );

        AnsiString	__fastcall	GAudioEditor		( void );
        AnsiString	__fastcall	GGfx2DEditor		( void );
        AnsiString	__fastcall	GGfx3DEditor		( void );
        AnsiString	__fastcall	GGfxMovieEditor		( void );
        AnsiString	__fastcall	GCDBurner		( void );
        AnsiString	__fastcall	GEmulator		( void );

        //				WRITE METHODS
        void		__fastcall	SSystemLibraryPath	( AnsiString Value );
        void		__fastcall	SSystemPackageOutputPath( AnsiString Value );
        void		__fastcall	SSystemLibraryOutputPath( AnsiString Value );
        void		__fastcall	SSystemBrowsingPath	( AnsiString Value );

        void		__fastcall	SAudioEditor		( AnsiString Value );
        void		__fastcall	SGfx2DEditor		( AnsiString Value );
        void		__fastcall	SGfx3DEditor		( AnsiString Value );
        void		__fastcall	SGfxMovieEditor		( AnsiString Value );
        void		__fastcall	SCDBurner		( AnsiString Value );
        void		__fastcall	SEmulator		( AnsiString Value );

        //	EDITOR TABSHEET		READ METHODS
        bool		__fastcall	GAutoIndentMode		( void );
        bool		__fastcall	GInsertMode		( void );
        bool		__fastcall	GUseTabChar		( void );
        bool		__fastcall	GSmartTab		( void );
        bool		__fastcall	GOptimalFill		( void );
        bool		__fastcall      GBackspaceUnindents	( void );
        bool		__fastcall	GCursorThroughTabs	( void );
        bool		__fastcall	GGroupUndo		( void );
        bool		__fastcall	GCursorBeyondEOF	( void );
        bool		__fastcall	GUndoAfterSave		( void );
        bool		__fastcall	GKeepTrailingBlanks	( void );
        bool		__fastcall	GPersistentBlocks	( void );
        bool		__fastcall	GOverwriteBlocks	( void );
        bool		__fastcall	GDoubleClickLine	( void );
        bool		__fastcall	GFindTextAtCursor	( void );
        bool		__fastcall	GForceCutCopyEnabled	( void );
        bool		__fastcall	GUseSyntaxHighlighting	( void );
        //				WRITE METHODS
        void		__fastcall	SAutoIndentMode		( bool Value );
        void		__fastcall	SInsertMode             ( bool Value );
        void		__fastcall	SUseTabChar             ( bool Value );
        void		__fastcall	SSmartTab		( bool Value );
        void		__fastcall	SOptimalFill		( bool Value );
        void		__fastcall	SBackspaceUnindents	( bool Value );
        void		__fastcall	SCursorThroughTabs	( bool Value );
        void		__fastcall	SGroupUndo		( bool Value );
        void		__fastcall	SCursorBeyondEOF	( bool Value );
        void		__fastcall	SUndoAfterSave		( bool Value );
        void		__fastcall	SKeepTrailingBlanks	( bool Value );
        void		__fastcall	SPersistentBlocks	( bool Value );
        void		__fastcall	SOverwriteBlocks	( bool Value );
        void		__fastcall	SDoubleClickLine	( bool Value );
        void		__fastcall	SFindTextAtCursor	( bool Value );
        void		__fastcall	SForceCutCopyEnabled	( bool Value );
        void		__fastcall	SUseSyntaxHighlighting	( bool Value );
        //	DISPLAY TABSHEET	READ METHODS
        bool		__fastcall	GBRIEFCursorShapes	( void );
        bool		__fastcall	GCreateBackupFiles	( void );
        bool		__fastcall	GPreserveLineEnds	( void );
        bool		__fastcall	GZoomToFullScreen	( void );
        bool		__fastcall	GVisibleRightMargin	( void );
        bool		__fastcall	GVisibleGutter		( void );
        int		__fastcall	GRightMargin		( void );
        int		__fastcall	GGutterWidth		( void );
        int		__fastcall	GFontSize		( void );
        AnsiString	__fastcall	GFontFace		( void );
        AnsiString	__fastcall	GKeystrokeMapping	( void );
        //				WRITE METHODS
        void		__fastcall	SBRIEFCursorShapes	( bool Value );
        void		__fastcall	SCreateBackupFiles	( bool Value );
        void		__fastcall	SPreserveLineEnds	( bool Value );
        void		__fastcall	SZoomToFullScreen	( bool Value );
        void		__fastcall	SVisibleRightMargin	( bool Value );
        void		__fastcall	SVisibleGutter		( bool Value );
        void		__fastcall	SRightMargin		( int Value );
        void		__fastcall	SGutterWidth		( int Value );
        void		__fastcall	SFontSize		( int Value );
        void		__fastcall	SFontFace		( AnsiString Value );
        void		__fastcall	SKeystrokeMapping	( AnsiString Value );

        //	Colours tabsheet read methods
        bool		__fastcall	GBold			( int Index );
        bool		__fastcall	GItalic			( int Index );
        bool		__fastcall	GUnderline		( int Index );
        bool		__fastcall	GForeDefault		( int Index );
        bool		__fastcall	GBackDefault		( int Index );

        int		__fastcall	GForeColour		( int Index );
        int		__fastcall	GBackColour		( int Index );

        // 	colours tabsheet write methods
        void		__fastcall	SBold			( int Index, bool Value );
        void		__fastcall	SItalic			( int Index, bool Value );
        void		__fastcall	SUnderline		( int Index, bool Value );
        void		__fastcall	SForeDefault		( int Index, bool Value );
        void		__fastcall	SBackDefault		( int Index, bool Value );

        void		__fastcall	SForeColour		( int Index, int Value );
        void		__fastcall	SBackColour		( int Index, int Value );

        //	Code completion tabsheet
        bool		__fastcall	GCodeCompletion		( void );
        bool		__fastcall	GCodeParameters		( void );
        bool		__fastcall	GTooltipExpressions	( void );

        WORD		__fastcall	GAutoCodeDelay		( void );
        int		__fastcall	GNumTemplates		( void );

        AnsiString	__fastcall	GTemplate		( int Index );

        void		__fastcall	SCodeCompletion		( bool Value );
        void		__fastcall	SCodeParameters		( bool Value );
        void		__fastcall	STooltipExpressions	( bool Value );

        void		__fastcall	SAutoCodeDelay		( WORD Value );

        AnsiString	__fastcall	GStyleName		( void );
        void		__fastcall	SStyleName		( AnsiString Value );

public:		// User declarations
	// Public Constructor
        __fastcall TEnviromentOptionsForm(TComponent* Owner);

        // Public Methods
__published:
	//	PREFERENCES TABSHEET PROPERTIES
        __property bool 	Modified 		= { read=GModified, 		write=SModified, 		stored=true, 	default=false };
        __property bool 	ShowCompilerProgress 	= { read=GShowCompilerProgress, write=SShowCompilerProgress, 	stored=true, 	default=true  };
        __property bool 	BeepOnCompletion	= { read=GBeepOnCompletion,	write=SBeepOnCompletion,	stored=true,	default=false };
        __property bool 	CacheHeadersOnStartup	= { read=GCacheHeadersOnStartup, write=SCacheHeadersOnStartup,  stored=true,	default=true  };
        __property bool 	WarnOnPackageRebuild	= { read=GWarnOnPackageRebuild, write=SWarnOnPackageRebuild,	stored=true,	default=true  };
        __property bool 	AutoSaveEditorFiles	= { read=GAutoSaveEditorFiles,  write=SAutoSaveEditorFiles,	stored=true,	default=true  };
        __property bool 	AutoSaveDesktopFiles	= { read=GAutoSaveDesktopFiles, write=SAutoSaveDesktopFiles,	stored=true,	default=false };
        __property bool 	HideOnRun		= { read=GHideOnRun,		write=SHideOnRun,		stored=true,	default=true  };
        __property bool		MinimiseOnRun		= { read=GMinimiseOnRun,	write=SMinimiseOnRun,		stored=true,	default=false };
        __property AnsiString   SharedRepository	= { read=GSharedRepository,	write=SSharedRepository,	stored=true 	};
        __property AnsiString	ToolsRepository		= { read=GToolsRepository,	write=SToolsRepository,		stored=true 	};

	// 	LIBRARY TABSHEET PROPERTIES
        __property AnsiString	LibraryPath		= { read=GSystemLibraryPath, 	write=SSystemLibraryPath,	stored=true	};
        __property AnsiString	PackageOutput		= { read=GSystemPackageOutputPath,	write=SSystemPackageOutputPath,	stored=true	};
        __property AnsiString	LibraryOutput		= { read=GSystemLibraryOutputPath,	write=SSystemLibraryOutputPath,	stored=true	};
        __property AnsiString	BrowsingPath		= { read=GSystemBrowsingPath,	write=SSystemBrowsingPath,	stored=true	};

        __property AnsiString	Emulator		= { read=GEmulator, write=SEmulator, stored=true };
        __property AnsiString	AudioEditor		= { read=GAudioEditor, write=SAudioEditor, stored=true };
        __property AnsiString	Gfx2DEditor		= { read=GGfx2DEditor, write=SGfx2DEditor, stored=true };
        __property AnsiString	Gfx3DEditor		= { read=GGfx3DEditor, write=SGfx3DEditor, stored=true };
        __property AnsiString	MovieEditor		= { read=GGfxMovieEditor, write=SGfxMovieEditor, stored=true };
        __property AnsiString	CDBurner		= { read=GCDBurner, write=SCDBurner, stored=true };

        //	EDITOR TABSHEET PROPERTIES
        __property bool		AutoIndentMode		= { read=GAutoIndentMode,	write=SAutoIndentMode,		stored=true,	default=false };
        __property bool		InsertMode		= { read=GInsertMode,		write=SInsertMode,		stored=true,	default=true  };
        __property bool		UseTabCharacter		= { read=GUseTabChar,		write=SUseTabChar,		stored=true,	default=false };
        __property bool		SmartTab		= { read=GSmartTab,		write=SSmartTab,		stored=true,	default=true  };
        __property bool		OptimalFill		= { read=GOptimalFill,		write=SOptimalFill,		stored=true,	default=false };
        __property bool		BackspaceUnindents	= { read=GBackspaceUnindents,	write=SBackspaceUnindents,	stored=true,	default=false };
        __property bool		CursorThroughTabs	= { read=GCursorThroughTabs,	write=SCursorThroughTabs,	stored=true,	default=true  };
        __property bool		GroupUndo		= { read=GGroupUndo,		write=SGroupUndo,		stored=true,	default=false };
        __property bool		CursorBeyondEOF		= { read=GCursorBeyondEOF,	write=SCursorBeyondEOF,		stored=true,	default=true  };
        __property bool		UndoAfterSave		= { read=GUndoAfterSave,	write=SUndoAfterSave,		stored=true,	default=true  };
        __property bool		KeepTrailingBlanks	= { read=GKeepTrailingBlanks,	write=SKeepTrailingBlanks,	stored=true,	default=false };
        __property bool		PersistentBlocks	= { read=GPersistentBlocks,	write=SPersistentBlocks,	stored=true,	default=true  };
        __property bool		OverwriteBlocks		= { read=GOverwriteBlocks,	write=SOverwriteBlocks,		stored=true,	default=true  };
        __property bool		DoubleClickLine		= { read=GDoubleClickLine,	write=SDoubleClickLine,		stored=true,	default=false };
        __property bool		FindTextAtCursor	= { read=GFindTextAtCursor,	write=SFindTextAtCursor,	stored=true,	default=true  };
        __property bool		ForceCutCopyEnabled	= { read=GForceCutCopyEnabled,	write=SForceCutCopyEnabled,	stored=true,	default=false };
        __property bool		UseSyntaxHighlighting   = { read=GUseSyntaxHighlighting,write=SUseSyntaxHighlighting,	stored=true,	default=true  };

        //	DISPLAY TABSHEET PROPERTIES
        __property bool		BRIEFCursorShapes	= { read=GBRIEFCursorShapes,	write=SBRIEFCursorShapes,	stored=true,	default=true  };
        __property bool		CreateBackupFiles	= { read=GCreateBackupFiles,	write=SCreateBackupFiles,	stored=true,	default=false };
        __property bool		PreserveLineEnds	= { read=GPreserveLineEnds,	write=SPreserveLineEnds,	stored=true,	default=true  };
        __property bool		ZoomToFullScreen	= { read=GZoomToFullScreen,	write=SZoomToFullScreen,	stored=true,	default=false };
        __property bool		VisibleRightMargin	= { read=GVisibleRightMargin,	write=SVisibleRightMargin,	stored=true,	default=true  };
        __property bool		VisibleGutter		= { read=GVisibleGutter,	write=SVisibleGutter,		stored=true,	default=true  };
        __property int		RightMargin		= { read=GRightMargin,		write=SRightMargin,		stored=true,	default=78    };
        __property int		GutterWidth		= { read=GGutterWidth,		write=SGutterWidth,		stored=true,	default=30    };
        __property int		FontSize		= { read=GFontSize,		write=SFontSize,		stored=true,	default=10    };
        __property AnsiString	FontFace		= { read=GFontFace,		write=SFontFace,		stored=true	};

        //	COLOURS TABSHEET PROPERTIES
        __property bool		Bold[ int Index ]	= { read=GBold, write=SBold };
        __property bool		Italic[ int Index ]	= { read=GItalic, write=SItalic };
        __property bool		UnderLine[ int Index ]	= { read=GUnderline, write=SUnderline };
        __property bool         DefaultFore[ int Index ]= { read=GForeDefault, write=SForeDefault };
        __property bool		DefaultBack[ int Inded ]= { read=GBackDefault, write=SBackDefault };

        __property int		ForeGround[ int Index ]	= { read=GForeColour, write=SForeColour };
        __property int		BackGround[ int Index ] = { read=GBackColour, write=SBackColour };

        __property AnsiString	StyleName		= { read=GStyleName, write=SStyleName };

        //	PALETTE, packages see the package manager

        //	CODE INSIGHT
        __property	bool		CodeCompletion		= { read=GCodeCompletion, write=SCodeCompletion, stored=true, default=true };
        __property	bool		CodeParameters		= { read=GCodeParameters, write=SCodeParameters, stored=true, default=true };
        __property	bool		TooltipExpressions	= { read=GTooltipExpressions, write=STooltipExpressions, stored=true, default=true };
        __property	WORD		NumCodeTemplates	= { read=GNumTemplates, stored=true };
        __property	WORD		AutoCodeDelay		= { read=GAutoCodeDelay, write=SAutoCodeDelay, stored=true, default=2 };
        __property	AnsiString	Template[ int Index ]	= { read=GTemplate };

};
//---------------------------------------------------------------------------
extern PACKAGE TEnviromentOptionsForm *EnviromentOptionsForm;
//---------------------------------------------------------------------------
#endif
//---------------------------------------------------------------------------

