//---------------------------------------------------------------------------
#include <vcl.h>
//---------------------------------------------------------------------------
#pragma hdrstop
//---------------------------------------------------------------------------
#include "ListDialog.h"
#include "TDirSelectDialog.h"
#include "shellapi.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
//---------------------------------------------------------------------------
TListEditDialog *ListEditDialog;
//---------------------------------------------------------------------------
__fastcall 	TListEditDialog :: TListEditDialog( TComponent* Owner ) : TForm( Owner )
{
	if ( Owner == NULL )
        	ListView1->Items->Clear();
}
//---------------------------------------------------------------------------
AnsiString	__fastcall	TListEditDialog :: GItems( void )
{       AnsiString	as = "";

	for ( int i=0; i<=ListView1->Items->Count-1; i++ ) {
        	as += ListView1->Items->Item[ i ]->Caption + ";";
        }

        if ( as.Length() <= 0 ) return( NULL );
        else return( as );
}
//---------------------------------------------------------------------------
void	__fastcall	TListEditDialog :: SItems( AnsiString Value )
{	char		*pText;

	if ( Value.Length() <= 0 ) return;

        pText = strtok( Value.c_str(), ";\n" );
        while ( pText ) {
        	TListItem *pItem = ListView1->Items->Add();
                pItem->Caption = AnsiString( pText );
                pText = strtok( NULL, ";\n" );
        }
}
//---------------------------------------------------------------------------
void 	__fastcall 	TListEditDialog :: BitBtn2Click( TObject *Sender )
{
	ListView1->Items->Clear();
	ModalResult = mrCancel;
}
//---------------------------------------------------------------------------
void 	__fastcall 	TListEditDialog :: BitBtn1Click( TObject *Sender )
{
	ModalResult = mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TListEditDialog::BitBtn5Click(TObject *Sender)
{	TListItem	*pItem;

	if ( !Sender ) return;

        if ( Edit1->Text.Length() <= 0 ) return;

        pItem = ListView1->Items->Add();
        pItem->Caption = Edit1->Text;
}
//---------------------------------------------------------------------------
void __fastcall TListEditDialog::BitBtn6Click(TObject *Sender)
{
	if ( !Sender ) return;

        if ( !ListView1->Selected ) return;

        int mrCode = MessageBox( Application->Handle, "Do you wish to delete this item?",
        	Application->Title.c_str(), MB_YESNO );

        if ( mrCode == ID_YES ) {
        	ListView1->Items->Delete( ListView1->Selected->Index );
        }
}
//---------------------------------------------------------------------------
void __fastcall TListEditDialog::BitBtn4Click(TObject *Sender)
{
	if ( !Sender ) return;

        if ( !ListView1->Selected ) return;

        ListView1->Selected->Caption = Edit1->Text;
}
//---------------------------------------------------------------------------
void __fastcall TListEditDialog::SpeedButton3Click(TObject *Sender)
{
	if ( !Sender ) return;

        if ( !ListView1->Selected ) return;

        if ( ListView1->Selected->Index == 0 ) return;

	AnsiString as = ListView1->Items->Item[ ListView1->Selected->Index - 1 ]->Caption;
        ListView1->Items->Item[ ListView1->Selected->Index - 1 ]->Caption = ListView1->Selected->Caption;
        ListView1->Selected->Caption = as;
}
//---------------------------------------------------------------------------
void __fastcall TListEditDialog::SpeedButton2Click(TObject *Sender)
{
	if ( !Sender ) return;

        if ( !ListView1->Selected ) return;

        if ( ListView1->Selected->Index == ListView1->Items->Count ) return;

        int i = ListView1->Selected->Index;
        AnsiString as = ListView1->Selected->Caption;

        ListView1->Selected->Caption = ListView1->Items->Item[ i + 1 ]->Caption;
        ListView1->Items->Item[ i + 1 ]->Caption = as;
}
//---------------------------------------------------------------------------
void __fastcall TListEditDialog::SpeedButton1Click(TObject *Sender)
{	TListItem	*pItem;

	SelectDirectoryDialog->Caption = "Select directory path to add to list";
        SelectDirectoryDialog->ShowModal();
        if ( SelectDirectoryDialog->ModalResult != mrOk ) return;

        pItem = ListView1->Items->Add();
        pItem->Caption = SelectDirectoryDialog->DirectoryPath;
}
//---------------------------------------------------------------------------
void __fastcall TListEditDialog::BitBtn3Click(TObject *Sender)
{
	//	Help
        ShellExecute( Handle, "open", "iexplore.exe",
        	"http://localhost/ide/help/HELP_ListDialog.html",
                NULL, SW_SHOWNORMAL );
}
//---------------------------------------------------------------------------
