//----------------------------------------------------------------------------
//
//	$FileName	::	Main.cpp
//	$Author		::	Chris Brooklyn
//	$Description	::	Main Code File For PSX IDE MainForm
//	$Version	::	0.2.0.240
//
//---------------------------------------------------------------------------
#include <vcl.h>
//---------------------------------------------------------------------------
#undef EMULATOR_DLL_C		//	Make sure this is undefined in everything that uses the Emulator DLL BEFORE including the header for the dll
//---------------------------------------------------------------------------
#include "..\lib\emulator\EmulatorDLL.h"	//	Add internal emulator support
//#include "..\lib\debugger\DebuggerFLL.h"	//	and debugger
#include "Main.h"				// 	Main Form Header Include
#include "About.h"				// 	About Form Header Include
#include "EnviromentOptionsUnit.h"              // 	Enviroment Options Form Header Include
#include "shellapi.h"                           // 	access to WIN API HINSTANCE ShellExecute( HWND, LPSTR, LPSTR, LPSTR, LPSTR, int )
#include "ToolsAPI.h"				// 	Tools API Header Include
#include "Tools.h"				// 	Tools Form Header Include
#include "DebuggingUnit.h"			// 	Debugging Form Header Include
#include "TDirSelectDialog.h"			// 	Directory Selection Dialog Header Include
#include "NewProjectUnit.h"			// 	New ProjectManagerForm->ActiveProject Form Header Include
#include "Utilities.h"				// 	Custom Utilities
#include "ValueDialogUnit.h"			//	Ask for a specific value string or integer
#include "ProgInfoForm.h"			//	ProjectManagerForm->ActiveProject Information Dialog
#include "ProjectManager.h"			//	ProjectManagerForm->ActiveProject Manager
#include "ProjectOptionsFormUnit.h"		//	ProjectManagerForm->ActiveProject Options
#include "WindowList.h"				//	ide sub function form
#include "PackageManager.h"			//	ide package manager
#include "SearchReplaceUnit.h"			//	search replace dialog
#include "ClassExplorer.h"			//	'Class Explorer' technology VERY EXPERIMENTAL !!! Mainly an idea at mo
//---------------------------------------------------------------------------
#pragma hdrstop					//	stop pre-compiling headers from here
//---------------------------------------------------------------------------
#pragma package(smart_init)			// BCB SHIT
#pragma resource "*.dfm"			// LOAD THE FORM FROM THE .DFM FILE
//---------------------------------------------------------------------------
__declspec( dllimport ) void	__fastcall	EmulatorExecute( void );
//---------------------------------------------------------------------------
//void	(*lpfnEmulatorExecute)(void);
//void	(*lpfnEmulatorTransfer)( LPSTR lpszFileName );
//---------------------------------------------------------------------------
__declspec( dllimport ) void __fastcall EmulatorTransfer( LPSTR lpszFileName );
//---------------------------------------------------------------------------
TMainForm 	*MainForm;			// Pointer to PSXIDE MainForm
//---------------------------------------------------------------------------
//__declspec( dllimport ) void __fastcall	EmulatorDebug( void );
//---------------------------------------------------------------------------
bool	__fastcall	DoxygenInstalled( void )	//	returns true/false if doxygen can be found
{
	if ( ( FileExists( AnsiString( DOXYGEN_INSTALL_DIR + "\\bin\\doxywizard.exe" ) ) ) ||
        	( FileExists( AnsiString( DOXYGEN_INSTALL_DIR + "\\bin\\doxygen.exe" ) ) ) )
        	return( true );
        else
        	return( false );
}
//---------------------------------------------------------------------------
//	This has to be here cos if it is in another file the compiler barfs
//	about the fact that the TRichEdit can not start a parameter decleration
//	thats nice of it eh? stupid bloody compiler
//---------------------------------------------------------------------------
//	This function is used by ALL applications apart from the WINDOWS GUI
//	and the Windows DLLS
//---------------------------------------------------------------------------
void	__fastcall	GenerateMain( TSynEdit *RichEdit )
{
	if ( !RichEdit ) return;

        SystemMessage( "Auto-Generating generic c/c++ main method for " + ProjectManagerForm->ProjectName );

        RichEdit->Lines->Add( "//---------------------------------------------------------------------------" );

        if ( ProjectOptionsForm->Language == LANGUAGE_C )	{
        	RichEdit->Lines->Add( "#include <stdio.h>" );
                SystemMessage( "Generating for C Language." );
        } else if ( ProjectOptionsForm->Language == LANGUAGE_CPP ) {
        	RichEdit->Lines->Add( "#include <iostream>" );
                SystemMessage( "Generating for C++ Language." );
        } else {
        	RichEdit->Lines->Add( "\t//\tUnable to determine the source language type, C or C++?" );
                SystemMessage( "Unable to determine the language." );
        }

        RichEdit->Lines->Add( "//---------------------------------------------------------------------------" );
        RichEdit->Lines->Add( "int main( int argc, char *argv[] )" );
        RichEdit->Lines->Add( "{" );

        if ( ProjectOptionsForm->Language == LANGUAGE_C )
        	RichEdit->Lines->Add( "\tprintf( \"PSX IDE Auto-Generated Application\\n\" );" );
        else if ( ProjectOptionsForm->Language == LANGUAGE_CPP )
        	RichEdit->Lines->Add( "\tcout << \"PSX IDE Auto-Generated Application\" << endl;" );
        else RichEdit->Lines->Add( "//\tUnable to determine the language" );

        RichEdit->Lines->Add( "	return( 0 );" );
        RichEdit->Lines->Add( "}" );
        RichEdit->Lines->Add( "//---------------------------------------------------------------------------" );
}
//---------------------------------------------------------------------------
//	Generates a main program file for WINDOWS GUI ONLY
//---------------------------------------------------------------------------
void	__fastcall	GenerateWinMain( TSynEdit *RichEdit )
{
	if ( !RichEdit ) return;

        SystemMessage( "Auto-Generating generic main method for Windows GUI executable." );

        RichEdit->Lines->Add( "//---------------------------------------------------------------------------" );
	RichEdit->Lines->Add( "#include <windows.h>" );
	RichEdit->Lines->Add( "//---------------------------------------------------------------------------" );
	RichEdit->Lines->Add( "int WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)" );
	RichEdit->Lines->Add( "{" );
	RichEdit->Lines->Add( "\treturn( 0 );" );
	RichEdit->Lines->Add( "}" );
        RichEdit->Lines->Add( "//---------------------------------------------------------------------------" );
}
//---------------------------------------------------------------------------
//	Generates a WINDOWS DLL main file	WINDOWS ONLY
//---------------------------------------------------------------------------
void	__fastcall	GenerateWinDLL( TSynEdit *RichEdit )
{
	if ( !RichEdit ) return;

        SystemMessage( "Auto-Generating main method for Windows DLL." );

	RichEdit->Lines->Add( "//---------------------------------------------------------------------------" );
	RichEdit->Lines->Add( "int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)" );
	RichEdit->Lines->Add( "{" );
	RichEdit->Lines->Add( "\treturn( 1 );" );
	RichEdit->Lines->Add( "}" );
	RichEdit->Lines->Add( "//---------------------------------------------------------------------------" );
}
//---------------------------------------------------------------------------
//	Generates a teplate for Windows and Open GL
//---------------------------------------------------------------------------
void	__fastcall	GenerateWinGL( TSynEdit *RichEdit )
{
	if ( !RichEdit )	return;

        SystemMessage( "Auto-Generating main method for Windows GUI WITH Open GL." );

        RichEdit->Lines->Add( "//---------------------------------------------------------------------------" );
        RichEdit->Lines->Add( "#include <windows.h>" );
        RichEdit->Lines->Add( "#include <gl/gl.h>" );
        RichEdit->Lines->Add( "#include <gl/glu.h>" );
        RichEdit->Lines->Add( "#include <gl/glaux.h>" );
        RichEdit->Lines->Add( "//---------------------------------------------------------------------------" );
        RichEdit->Lines->Add( "int WINAPI WinMain( HINSTANCE, HINSTANCE, LPSTR, int );" );
        RichEdit->Lines->Add( "{" );
        RichEdit->Lines->Add( "\treturn( 0 );" );
        RichEdit->Lines->Add( "}" );
        RichEdit->Lines->Add( "//---------------------------------------------------------------------------" );
}
//---------------------------------------------------------------------------
//	Generates a template for Windows and Direct X 8.1
//---------------------------------------------------------------------------
void	__fastcall	GenerateWinDX( TSynEdit *RichEdit )
{
	if ( !RichEdit ) 	return;

        SystemMessage( "Auto-Generating main method for Windows GUI WITH Direct X." );

        RichEdit->Lines->Add( "//---------------------------------------------------------------------------" );
        RichEdit->Lines->Add( "#include <windows.h>" );
        RichEdit->Lines->Add( "#include <dx8.h>" );
        RichEdit->Lines->Add( "//---------------------------------------------------------------------------" );
        RichEdit->Lines->Add( "int WINAPI WinMain( HINSTANCE, HINSTANCE, LPSTR, int )" );
        RichEdit->Lines->Add( "{" );
        RichEdit->Lines->Add( "\t// Place code for Windows initialisation" );
        RichEdit->Lines->Add( "\t// Place code for Direct X initialisation" );
        RichEdit->Lines->Add( "\treturn( 0 );" );
        RichEdit->Lines->Add( "}" );
        RichEdit->Lines->Add( "//---------------------------------------------------------------------------" );
}
//---------------------------------------------------------------------------
//	PSX IDE MainForm Constructor
//---------------------------------------------------------------------------
__fastcall 	TMainForm :: TMainForm( TComponent *Owner ) : TForm( Owner )
{
        memset( vKeyStates, 0, sizeof( BYTE ) * 256 );				//	Clear the array

	hDebuggerHandle = LoadLibrary( "LIB\\DEBUGGER.DLL" );			//	Attempt to load the debugger dll

	if ( !hDebuggerHandle )	{
        	SystemMessage( "Unable to load debugger dll." );
        } else {
		SystemMessage( "Debugger Loaded." );
		if ( ProjectOptionsForm ) {
			TListItem *pItem = ProjectOptionsForm->ListView8->Items->Add();
			pItem->Caption = "Debugger";
		}
	}

        //	Attempt to load the emulator dll and resolve procedure addresses
	hEmulatorHandle = LoadLibrary( "LIB\\EMULATOR.DLL" );

	if ( !hEmulatorHandle ) {
        	SystemMessage( "Unable to load emulator dll." );
                //lpfnEmulatorExecute = NULL;
                //lpfnEmulatorTransfer = NULL;
        } else {
		SystemMessage( "Emulator Loaded." );
		if ( ProjectOptionsForm ) {
			TListItem *pItem = ProjectOptionsForm->ListView8->Items->Add();
			pItem->Caption = "Emulator";
		}

                // ....	resolve proc addresses
                //lpfnEmulatorExecute  = GetProcAddress( hEmulatorHandle, "EmulatorExecute"  );
                //lpfnEmulatorTransfer = GetProcAddress( hEmulatorHandle, "EmulatorTransfer" );
	}

        // .... have not defined, the compiler class as yet, so just leave this blank
        // for the mo
	hCompilerHandle = NULL;

        //
        //	This next section is for the delorie djgpp compiler only, as this
        // is used as the primary test compiler, note though that it is NOT 100%
        // GNU complient but supports most of the available flags
        //
        //	The other compilers used are Watcom, BCB, and cygwin, mingw
        //
        // Please take into account that this is for my system, not yours, so you
        // would probably need to change this
        //

        if ( !SetEnvironmentVariable( "PATH", "F:\\DELORIE\\BIN;%PATH%" ) )
        	SystemMessage( "Unable to modify binary search path" );

        if ( !SetEnvironmentVariable( "DJGPP", "F:\\DELORIE\\DJGPP.ENV" ) )		//	Set DJGPP=C:\DJGPP\DJGPP.ENV
        	SystemMessage( "Unable to set DJGPP enviroment variable." );

        if ( DoxygenInstalled() ) {
        	SystemMessage( "DOXYGEN found." );
                ToolsDoxygen->Enabled = true;
        } else {
        	SystemMessage( "DOXYGEN not found." );
                ToolsDoxygen->Enabled = false;
        }

}
//---------------------------------------------------------------------------
//	Creates a new MDI form with a given title
//	if the name is equal to the filename then opens the file as well
//---------------------------------------------------------------------------
void 	__fastcall 	TMainForm :: CreateMDIChild( String Name )
{	TMDIChild *Child;
	//--- create a new MDI child window ----
	Child = new TMDIChild( this );
	Child->Caption = Name;
        Child->FileName = Name;
	if ( FileExists ( Name ) ) {
		Child->SynEdit1->Lines->LoadFromFile( Name );
                Child->FileName = Name;
                Child->Index = -1;
        }
        Child->Modified = false;
}
//---------------------------------------------------------------------------
//	IDE SPECIFIC.	Creates a new blank mdi form
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileNewFileExecute(TObject *Sender)
{	TMDIChild	*pForm;
	CreateMDIChild("Untitled" + IntToStr(MDIChildCount + 1));
        pForm = (TMDIChild*)MDIChildren[ 0 ];

        if ( pForm == NULL )
        	return;

        pForm->Index = -1;
}
//---------------------------------------------------------------------------
//	IDE SPECIFIC.	Opens a file, of any type
//---------------------------------------------------------------------------
void 	__fastcall 	TMainForm :: FileOpen1Execute( TObject *Sender )
{       TComponent	*Originator = dynamic_cast< TComponent* >(Sender);
	AnsiString	FileName = NULL;

	if ( Originator == NULL )
        	return;

        ClearSysMessages();

        SystemMessage( "IDE File Open from : " + Originator->Name );

        //
        //	Where was the call orignated from ...
        //

        //		... the mainform ?
        if ( Originator->Name == "MainForm" ) {	//	Yes
        	if ( !OpenDialog->Execute() )
                	return;

        	FileName = OpenDialog->FileName;
        }

        //		... or the project manager ?
        if ( Originator->Name == "ProjectManager" ) {	//	Yes
        	if ( !ProjectManagerForm->OpenDialog->Execute() )
                	return;

                FileName = ProjectManagerForm->OpenDialog->FileName;
        }

        if ( FileName.Length() <= 0 )
        	return;


        //	Create and open the file if present

        CreateMDIChild( FileName );

        //	Do we have access to the file text ?
        TMDIChild *pForm = (TMDIChild*)MDIChildren[ 0 ];


        if ( pForm == NULL )	//	Nope, poo! Bye then.
        	return;

        //
        //	Yes we do so who called us again
        //

        //		... Project Manager

        if ( Originator->Name == "ProjectManager" ) {
        	if ( ( !ProjectManagerForm->InProject( FileName ) ) || ( !ProjectManagerForm->ActiveProject ) )
                	return;

                pForm->Caption = ProjectManagerForm->lpGroup->lpProjects[ ProjectManagerForm->CurrProject ].lpModules[ ProjectManagerForm->CurrModule ].Name;
                pForm->Index = ProjectManagerForm->CurrModule;
        } else {
        	//	... Mainform, or other
        	pForm->Index = -1;
        }
}
//---------------------------------------------------------------------------
void 	__fastcall 	TMainForm :: HelpAbout1Execute( TObject *Sender )
{
	if ( AboutBox != NULL )
        	AboutBox->ShowModal();
}
//---------------------------------------------------------------------------
void 	__fastcall 	TMainForm :: ProjectOptionsExecute( TObject *Sender )
{	TComponent	*Originator = dynamic_cast< TComponent* >(Sender);	//	This is for tracking who called this method
	//	It can also be used to apply security to the method,
        //
        //	ie if ( Originator->Name != "ThisOrThat" ) SystemMessage( "Eeek!" );
        //	else SystemMessage( "Ook!" );
        //

	if ( Originator == NULL )	{	//	Bad originator (caller)
        	return;
        }

        ClearSysMessages();

	if ( !ProjectManagerForm->ActiveGroup )	{							//	No active ProjectManagerForm->ActiveProject
        	SystemMessage( "No active group in Project Manager. Please open or create a new group." );
                return;
        }

        if ( !ProjectManagerForm->ActiveProject ) {
        	SystemMessage( "No active project Project Manager. Please open or create a new ProjectManagerForm->ActiveProject." );
                return;
        }

        SystemMessage( "Displaying current Project Options." );

        ProjectOptionsForm->ShowModal();					//	Display the current ProjectManagerForm->ActiveProject options

        if ( ProjectOptionsForm->ModalResult == mrCancel )	{		//	cancelled ?
        	SystemMessage( "Project Options Modification Cancelled. Returning to IDE." );
                return;
        }

        if ( !ProjectOptionsForm->Modified ) 	{
        	SystemMessage( "Options NOT Project Options Modified, returning to IDE." );
                return;
        }

        SystemMessage( "Project Options Modified, regenerating application support files." );

        ProjectManagerForm->PRJMAN_SaveProject( Sender );

        ProjectManagerForm->Modified = false;

        ProjectOptionsForm->Modified = false;

        SystemMessage( "Regeneration completed. Returning to IDE." );
}
//---------------------------------------------------------------------------
//	Display the ProjectManagerForm->ActiveProject manager form
//---------------------------------------------------------------------------
void 	__fastcall 	TMainForm :: ViewProjectManagerExecute(	TObject *Sender )
{	TComponent	*Originator = dynamic_cast< TComponent* >(Sender);

	if ( Originator == NULL )
        	return;

        ProjectManagerForm->Show();
}
//---------------------------------------------------------------------------
//	Display the IDE Enviroment Options for modification
//---------------------------------------------------------------------------
void 	__fastcall 	TMainForm :: ToolsEnviromentOptionsExecute( TObject *Sender )
{	TComponent	*Originator = dynamic_cast< TComponent* >(Sender );

	if ( !Originator )	return;

        EnviromentOptionsForm->ModalResult = mrOk;
        EnviromentOptionsForm->ShowModal();

        if ( EnviromentOptionsForm->ModalResult == mrCancel ) {
        	SystemMessage( "Enviroment Options Modification Cancelled. Return to IDE." );
                return;
        }

        if ( !EnviromentOptionsForm->Modified ) {
        	SystemMessage( "Enviroment Options NOT Modified, returning to the IDE." );
                return;
        }

        SystemMessage( "Enviroment Options Modified." );

        if ( EnviromentOptionsForm->AutoSaveDesktopFiles ) {
        	SystemMessage( "Auto-Saving ENABLED." );
                if ( EnviromentOptionsForm->WriteToRegistry( MainForm ) )
                	SystemMessage( "Enviroment Options saved successfully." );
                else	SystemMessage( "Enviroment Options save failed." );
        } else	SystemMessage( "Auto-Saving DISABLED." );

        SystemMessage( "Returning to IDE." );
}
//---------------------------------------------------------------------------
void 	__fastcall 	TMainForm :: ToolsConfigureExecute( TObject *Sender )
{
        ToolDialog->ShowModal();
}
//---------------------------------------------------------------------------
void 	__fastcall 	TMainForm :: ToolsDebuggerOptionsExecute( TObject *Sender )
{
        if ( ProjectManagerForm->ActiveProject )
        	DebugOptionsForm->ShowModal();
        else
        	SystemMessage( "Unable to display debugging options for a non-existent project" );
}
//---------------------------------------------------------------------------
//	TMainForm :: File Close Execute
//		Closes the current open mdi child editor form
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileClose1Execute(TObject *Sender)
{	TMDIChild	*pForm = (TMDIChild*)MDIChildren[ 0 ];
        if ( pForm ) pForm->IDEClose( Sender );
}
//---------------------------------------------------------------------------
//	TMainForm :: File Close All Execute
//		Closes all open mdi child editor forms, WRONG should ask ProjectManagerForm->ActiveProject manager to close it
//---------------------------------------------------------------------------
void 	__fastcall 	TMainForm :: FileCloseAllExecute( TObject *Sender )
{       TComponent	*Originator = dynamic_cast< TComponent* >(Sender);

	if ( Originator == NULL )
        	return;

        if ( ProjectManagerForm->ActiveGroup )
        	ProjectManagerForm->IDECloseProjectGroup( Sender );

        if ( ProjectManagerForm->Visible )
        	ProjectManagerForm->Visible = false;

        if ( MDIChildCount > 0 ) {
        	for ( int i=MDIChildCount; i>0; i++ ) {
                	TMDIChild *pForm = (TMDIChild*)MDIChildren[ i ];
                        if ( pForm != NULL ) {
                        	pForm->IDEClose( Sender );
                        }
                }
        }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EditUndoExecute(TObject *Sender)
{       TMDIChild	*pForm = (TMDIChild*)MDIChildren[ 0 ];
	if ( ( !Sender ) || ( !pForm ) ) return;

        pForm->SynEdit1->Undo();
}
//---------------------------------------------------------------------------
//	TMainForm :: Edit Select All Execution Method
//		Performs a 'Select All' on the current open MDI Child Form if
//	any are open else does nothing
//---------------------------------------------------------------------------
void __fastcall TMainForm::EditSelectAllExecute(TObject *Sender)
{	TMDIChild	*pForm = (TMDIChild*)MDIChildren[ 0 ];
	if ( ( !Sender ) || ( !pForm ) ) return;	// Bad Sender or no open forms
        pForm->SynEdit1->SelectAll();
}
//---------------------------------------------------------------------------
//	This is called 5 times every second, so do not do too much here
//---------------------------------------------------------------------------
void __fastcall TMainForm::Timer1Timer(TObject *Sender)
{
        //	First, update the positional information about the currently
        // open edit form, if any

        if ( MDIChildCount > 0 ) {
        	TMDIChild *pForm = (TMDIChild*)MDIChildren[ 0 ];
                if ( pForm ) {
                	TPoint Pos = pForm->SynEdit1->CaretXY;
                        AnsiString a;
                        if ( Pos.x < 10 ) a = "0" + IntToStr( (int)Pos.x );
                        else a = IntToStr( (int)Pos.x );
                        a += " : ";
                        if ( Pos.y <10 ) a += "0" + IntToStr( (int)Pos.y );
                        else a += IntToStr( (int)Pos.y );
                        StatusBar1->Panels->Items[ 0 ]->Text = a;
                } else StatusBar1->Panels->Items[ 0 ]->Text = "";
        } else 	{
        	//StatusBar1->Panels->Items[ 0 ]->Text = Application->Hint;
        	if ( ProjectManagerForm->ActiveProject )
                	StatusBar1->Panels->Items[ 0 ]->Text = ProjectManagerForm->ProjectName;
                else if ( ProjectManagerForm->ActiveGroup )
                	StatusBar1->Panels->Items[ 0 ]->Text = ProjectManagerForm->GroupName;
                else
                	StatusBar1->Panels->Items[ 0 ]->Text = "Closed";
        }


        //	Next the ProjectManagerForm->Modified flag, easy

        if ( ( ProjectManagerForm->ActiveGroup ) || ( ProjectManagerForm->ActiveProject ) ) {
        	if ( ProjectManagerForm->Modified ) StatusBar1->Panels->Items[ 1 ]->Text = "ProjectManagerForm->Modified";
        }	else StatusBar1->Panels->Items[ 1 ]->Text = "";

        //	Next comes the insert / overwrite mode, it only relates to the option selection in the enviroment options form
        //	where as the keypress event in the mdi form changes the actual insert / overwrite mode

        if ( EnviromentOptionsForm->InsertMode ) {
        	TMDIChild	*pForm = (TMDIChild*)MDIChildren[ 0 ];

                if ( pForm ) {
                	if ( pForm->SynEdit1->InsertMode ) StatusBar1->Panels->Items[ 2 ]->Text = "Insert";
                        else StatusBar1->Panels->Items[ 2 ]->Text = "Overwrite";
                } else StatusBar1->Panels->Items[ 2 ]->Text = "Insert";
        } else StatusBar1->Panels->Items[ 2 ]->Text = "Overwrite";

        //	Next, numlock status

        if ( bNumLock ) StatusBar1->Panels->Items[ 3 ]->Text = "NUM";
        else StatusBar1->Panels->Items[ 3 ]->Text = "";

        //	Next current system time / date
	StatusBar1->Panels->Items[ 4 ]->Text = SystemDate() + " @ " + SystemTime();

        //	Set the caption if possible

        if ( ProjectManagerForm->ActiveGroup ) {
        	Caption = "PSX IDE For Windows [ " + ProjectManagerForm->GroupName;
                if ( ProjectManagerForm->ActiveProject )
                	Caption += " : " + ProjectManagerForm->ProjectName;
                if ( ProjectManagerForm->Modified )
                	Caption += " *";
                Caption += " ]";
        } else {
        	Caption = "PSX IDE For Windows";
        }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileExit1Execute(TObject *Sender)
{
	if ( ( ProjectManagerForm->ActiveGroup ) || ( ProjectManagerForm->ActiveProject ) ) {
        	ProjectManagerForm->IDECloseProjectGroup( MainForm );
                SystemMessage( "PSXIDE --> PRJMAN Close Group/Project" );
                ProjectManagerForm->bActiveProject = false;
                ProjectManagerForm->bActiveGroup = false;
        }

        SystemMessage( "Application Terminating @ " + SystemTimeDate() );

	Close();
}
//---------------------------------------------------------------------------
//
//	$METHOD		::	FileNewExecute
//	$PARAMETERS	::	TObject*
//	$PURPOSE	::	Executed whenever the user wants to generate a new
//				something or other. See NewProjectForm for further
//				details on what can be created at present
//---------------------------------------------------------------------------
void 	__fastcall 	TMainForm :: FileNewExecute( TObject *Sender )
{	TComponent	*Originator = dynamic_cast< TComponent* >(Sender);

	if ( Originator == NULL )
        	return;

        SystemMessage( "APG Starting ..." );

	//	Open New ProjectManagerForm->ActiveProject Form Dialog
        NewProjectForm->ShowModal();

        if ( NewProjectForm->ModalResult != mrOk ) {	//	Cancel pressed ?
        	SystemMessage( "Auto Project Generation cancelled by user." );
        	return;
        } 	//	No so lets work out what type of ProjectManagerForm->ActiveProject the user wanted

        SystemMessage( "APG continuing, decoding project type ... " );

        switch ( NewProjectForm->ProjectType ) {
        	case ( PROJECT_TYPE_APPLICATION ) : {		//	User wants a standard application
                	SystemMessage( "Standard Application" );
                	FileNewApplicationExecute( NewProjectForm );
                        break;;
                }

                case ( PROJECT_TYPE_BATCH_FILE ) : {		//	User wants a batch file ( dos ), or shell script ( linux )
                	if ( ProjectOptionsForm->PlatformId == PLATFORM_PCW ) {
                        	SystemMessage( "Batch file PCW" );
                        	CreateMDIChild( "Untitled.bat" );
                        } else if ( ( ProjectOptionsForm->PlatformId == PLATFORM_PS2L ) ||
                        	( ProjectOptionsForm->PlatformId == PLATFORM_PCL ) ) {
                                	SystemMessage( "PS2L or PCL shell script" );
                                        CreateMDIChild( "ShellScript" );
                                }
                        break;
                }

                case ( PROJECT_TYPE_COMPONENT ) : {		//	A Component, only available for linux and/or windows
                	//	No code generation template for this at present, gnu does not support "components"
                        SystemMessage( "Component, not implemented at present." );
                        break;
                }

                case ( PROJECT_TYPE_CONSOLE ) : {		//	User wants a standard console application
                	SystemMessage( "Generic Console Executable" );
                	IDEGenerateConsoleExecute( Sender );
                        break;
                }

                case ( PROJECT_TYPE_DATA_MODULE ) : {		//	Data Module, note uses MySQL only at present but could use any
                	//	C++ class for interface to selectable database
                        SystemMessage( "MySQL Data Module class not defined yet." );
                        break;
                }

                case ( PROJECT_TYPE_WINDLL ) : {		//	Windows DLL, or dynamic library
                	SystemMessage( "PCW DLL" );
                	FileNewApplicationExecute( Sender );
                        break;
                }

                case ( PROJECT_TYPE_FORM ) : {			//	GUI Form, suitable for PS2L, PCL, PCW ONLY AT PRESENT
                	switch ( ProjectOptionsForm->PlatformId ) {
                        	case ( PLATFORM_PS2L ) : {
                                	SystemMessage( "New form for PlayStation 2 (LINUX), not implemented yet." );
                                        break;
                                }
                                case ( PLATFORM_PCL ) : {
                                	SystemMessage( "New form for PC LINUX, not implemented yet." );
                                        break;
                                }
                                case ( PLATFORM_PCW ) : {
                                	SystemMessage( "New form for PC WINDOWS, not implemented yet." );
                                        break;
                                }
                        }
                        break;
                }

                case ( PROJECT_TYPE_LIBRARY            ) : {	//	Static Library
                	TMDIChild	*pForm;

                        SystemMessage( "Library" );

                        CreateMDIChild( "Library.cpp" );

                        pForm = (TMDIChild*)MDIChildren[ 0 ];

                        if ( pForm ) {
                        	pForm->SynEdit1->Lines->Add( "//---------------------------------------------------------------------------" );
                                pForm->SynEdit1->Lines->Add( "#ifdef WIN32" );
                                pForm->SynEdit1->Lines->Add( "#include <windows.h>" );
                                pForm->SynEdit1->Lines->Add( "#elif LINUX" );
                                pForm->SynEdit1->Lines->Add( "#include <linux.h>" );
                                pForm->SynEdit1->Lines->Add( "#endif" );
                                pForm->SynEdit1->Lines->Add( "//---------------------------------------------------------------------------" );
                        }

                        break;

                }

		case ( PROJECT_TYPE_PACKAGE            ) : {	//	Package for PSXIDE, at the mo just a standard dll
                	SystemMessage( "Package" );
                        break;
                }

		case ( PROJECT_TYPE_PROJECT_GROUP      ) : {	//	ProjectManagerForm->ActiveProject group, more than one application
                	// ProjectManagerForm->PRJMAN_NewGroup( Sender );
                        SystemMessage( "Group" );
                        break;
                }

		case ( PROJECT_TYPE_TEXT               ) : {	//	Standard text file
                	SystemMessage( "Text File" );
                	CreateMDIChild( "Text" );
                        break;
                }

		case ( PROJECT_TYPE_THREAD             ) : {	//	Multi-threaded class
                	SystemMessage( "Thread" );
                        break;
                }

		case ( PROJECT_TYPE_UNIT               ) : {	//	Adds a new unit to the ProjectManagerForm->ActiveProject or just creates a new blank one
                	SystemMessage( "New Unit" );
                	FileNewUnitExecute( Sender );
                        break;
                }

		case ( PROJECT_TYPE_FORM_ABOUT_BOX     ) : {	//	Standard About Box Dialog
                	SystemMessage( "About Box" );
                        break;
                }

		case ( PROJECT_TYPE_MDI_APPLICATION    ) : {	//	Multiple Document Interface Application
                	SystemMessage( "MDI Application" );
                        break;
                }

		case ( PROJECT_TYPE_SDI_APPLICATION    ) : {	//	Single Document Interface Application
                	SystemMessage( "SDI Application ( same as Standard Application )" );
                	FileNewApplicationExecute( NewProjectForm );
                        break;
                }

		case ( PROJECT_TYPE_LOGO_APPLICATION   ) : {	//	Certified OS Core OK application
                	SystemMessage( "Logo Application" );
                        break;
                }

		case ( PROJECT_TYPE_SPLASH_APPLICATION	) : {	//	Standard Application with a 'Splash' screen
                	SystemMessage( "Splash Application ( same as SDI and Standard Application but has a splash form presented before the mainform )" );
                        break;
                }

        }
}
//---------------------------------------------------------------------------
//
//	Method		::	File New Application Execute ( Action )
//	Parameters	::	TObject *Sender, originator of call
//	Purpose		::	Is execute when either the menu item --> File->New Application <--
//				has been selected or --> File->New <-- and
//				'Application' is selected as the ProjectManagerForm->ActiveProject type
//				It generates the ProjectManagerForm->ActiveProject contents, dependant on
//				the information requested and given to/from the
//				user
//
//	Extra 		::	NOTE ONLY CALLABLE FROM THE MAINFORM IDE ONLY
//
//	THIS NEEDS TO BE RE-WRITTEN TO TAKE INTO ACCOUNT THE UPGRADE FOR THE
// ProjectManagerForm->ActiveProject MANAGER 0.2 -> 0.3
//
//---------------------------------------------------------------------------
void 	__fastcall 	TMainForm :: FileNewApplicationExecute(	TObject *Sender )
{	TMDIChild	*pForm;
	AnsiString	HomeDir;
        TComponent	*Originator = dynamic_cast< TComponent* >(Sender);

        if ( Originator == NULL )
        	return;

        ClearSysMessages();

        if ( ProjectManagerForm->ActiveProject ) {
        	//ProjectManagerForm->PRJMAN_CloseProject( Sender );
                //ProjectManagerForm->PRJMAN_CloseGroup( Sender );
                SystemMessage( "Closing previous ProjectManagerForm->ActiveProject/group." );
        }

        SystemMessage( "New Application Auto-Generator" );

        SystemMessage( "Enter a name for ProjectManagerForm->ActiveProject, note this is NOT the title of the ProjectManagerForm->ActiveProject" );

ProjectName:
        ValueDialog->Caption = "Select a ProjectManagerForm->ActiveProject name";
        ValueDialog->ShowModal();

        if ( ValueDialog->ModalResult != mrOk ) {
           int mrCode;

           mrCode = MessageBox( Application->Handle, "Do you wish to terminate auto-ProjectManagerForm->ActiveProject generation?", Application->Title.c_str(), MB_YESNO );

           if ( mrCode == mrYes ) return;

           goto ProjectName;
        }

        ProjectManagerForm->ProjectName = ValueDialog->Value;					//	Valid ProjectManagerForm->ActiveProject name

        if ( ProjectManagerForm->ProjectName.Length() <= 0 ) {
        	MessageBox( Handle, "Bad value given, try again.", "User Error", MB_OK );
                SystemMessage( "Please give this application a name" );
                goto ProjectName;
        }

        //	Need to request a home for this ProjectManagerForm->ActiveProject now

        SystemMessage( "Enter a home directory for " + ProjectManagerForm->ProjectName );

        SelectDirectoryDialog->ShowModal();
        if ( SelectDirectoryDialog->ModalResult != mrOk ) {
        	SystemMessage( "Unable to create home directory for ProjectManagerForm->ActiveProject, aborting auto-generation" );
        	return;	//	Users clicked on cancel
        }

	//	We need to check to see if the user wants to create the ProjectManagerForm->ActiveProject
        // on the root of the selected drive, ie C:\, D:\, etc, etc

        //	This bit does not work right, sort of. it detects root directories
        //	but fails on using a sub-directory ie ok on C:\ but fails on C:\projects

        char *pText = SelectDirectoryDialog->DirectoryPath.c_str();

        if ( pText[ strlen( pText ) ] == '\\' ) HomeDir = SelectDirectoryDialog->DirectoryPath + "\\" + ProjectManagerForm->ProjectName;
        else HomeDir = SelectDirectoryDialog->DirectoryPath + ProjectManagerForm->ProjectName;

        SystemMessage( "Home directory for " + ProjectManagerForm->ProjectName + " " + HomeDir );

        if ( !DirExists( HomeDir ) ) {
        	int mrCode;
                mrCode = MessageBox( Application->Handle, AnsiString( HomeDir + " does not exist, Create ?" ).c_str(),
                	Application->Title.c_str(), MB_YESNO );
                if ( mrCode == ID_NO ) {
                	ProjectManagerForm->bActiveProject = false;
                        SystemMessage( "Unable to continue with auto-generatiion of the ProjectManagerForm->ActiveProject, orphaned :-(" );
                        ProjectManagerForm->ProjectName = "";
                        return;
                }
                CreateDir( HomeDir );
        }

        ProjectManagerForm->bActiveProject = true;

        SetCurrentDir( HomeDir );

        SystemMessage( "Creating Directory tree for ProjectManagerForm->ActiveProject " + ProjectManagerForm->ProjectName );

        CreateDir( "bin" );
        CreateDir( "lib" );
        CreateDir( "docs" );
        CreateDir( "src" );
        CreateDir( "include" );

        // Directory structure has been created generate default ProjectManagerForm->ActiveProject options
        // and then show to allow the user to accept or change the options

        SystemMessage( "Set ProjectManagerForm->ActiveProject options" );

        ProjectOptionsForm->ConfigureForPlatform( ProjectOptionsForm->PlatformId );
        ProjectOptionsForm->ProjectHomeDir = HomeDir;
        ProjectOptionsForm->IncludePath = HomeDir + "\\include";
        ProjectOptionsForm->LibraryPath = HomeDir + "\\lib";
        ProjectOptionsForm->DebugSourcePath = HomeDir + "\\src";
        ProjectOptionsForm->Modified = false;
        ProjectOptionsForm->ShowModal();

        if ( ProjectOptionsForm->ModalResult != mrOk )	{

        	int mrCode = MessageBox( Application->Handle,
                			"Are you sure you wish to exit automatic ProjectManagerForm->ActiveProject generation?",
                                        Application->Title.c_str(), MB_YESNO );

                if ( mrCode == ID_YES )	{
                	ClearSysMessages();
                        SystemMessage( "Auto ProjectManagerForm->ActiveProject Generation aborted." );
                        ProjectManagerForm->ProjectName = "";
                        ProjectManagerForm->bActiveProject = false;
                        return;
                }

        }

        // We do not need to check for ProjectManagerForm->ActiveProject options modification as we generate
        // the ProjectManagerForm->ActiveProject file soon

        // Generate the main code file based on the platform type, does not take
        // into account the type of ProjectManagerForm->ActiveProject just the target platform
        //	Ie it doe not create correct files for things like components,
        //	forms etc, as the under lying library needs to be writtent :)

        SystemMessage( "Creating source file(s)" );

        CreateMDIChild( ProjectManagerForm->ProjectName );	//	Create Main module window, but not code yet
	pForm = (TMDIChild*)MDIChildren[ 0 ];	//	Point to newly created form

        switch ( ProjectOptionsForm->PlatformId ) {
        	case ( PLATFORM_PSX  ) : 	//	Playstation target, this is also the default
                case ( PLATFORM_PS2  ) : 	//	Playstation 2 target
                case ( PLATFORM_N64  ) : 	//	Nintendo 64 target
                case ( PLATFORM_PS2L ) :	//	Playstation 2 target with development kit
                case ( PLATFORM_PCL  ) : {	//	PC running Linux ( Intel )
                	GenerateMain( pForm->SynEdit1 );
                        break;
                }
                case ( PLATFORM_PCW ) : {	//	PC running MS Windows
                	switch ( ProjectOptionsForm->Interface ) {	//	which interface does the user want
                        	case ( 0 ) : {	//	CONSOLE
                                	GenerateMain( pForm->SynEdit1 );
                                        break;
                                }

                                case ( 1 ) : {	//	GUI
                                	GenerateWinMain( pForm->SynEdit1 );
                                        break;
                                }

                                case ( 2 ) : {	//	OPEN GL
                                	GenerateWinGL( pForm->SynEdit1 );
                                        break;
                                }

                                case ( 3 ) : {	//	DIRECT X
                                	GenerateWinDX( pForm->SynEdit1 );
                                        break;
                                }

                                case ( 4 ) : {	//	DLL
                                	GenerateWinDLL( pForm->SynEdit1 );
                                        break;
                                }
                        }
                        break;
                }
                default : {
                	GenerateMain( pForm->SynEdit1 );
                        break;
                }

        }

	pForm->FileName = HomeDir + "\\" + ProjectManagerForm->ProjectName + ".cpp";
        pForm->SynEdit1->Lines->SaveToFile( pForm->FileName );

        pForm->IDESave( MainForm );	//	IDE Save file, auto save ;-)
        pForm->Modified = false;

        SystemMessage( "Generating ProjectManagerForm->ActiveProject manager view" );

        TListItem *pItem;

        ProjectManagerForm->ListView1->Items->Clear();

        pItem = ProjectManagerForm->ListView1->Items->Add();

        if ( pItem ) {
        	pItem->Caption = pForm->Caption;
                pItem->SubItems->Add( pForm->FileName );
        }

        delete pForm;

        // 	before we can generate the ProjectManagerForm->ActiveProject file and makefile for the ProjectManagerForm->ActiveProject
        //	we need to fill the listview in ProjectManagerForm->ActiveProject manager form with the correct
        // 	details, then, and only then can we generate the ProjectManagerForm->ActiveProject and
        //	make files for this ProjectManagerForm->ActiveProject

        SystemMessage( "Generating makefile" );
        ProjectManagerForm->IDEGenerateMakeFile( Sender );			//	Generate Makefile

        ProjectManagerForm->Visible = true;

        OpenDialog->FileName = ProjectManagerForm->ProjectName + ".psxide";

        SystemMessage( "Generating ProjectManagerForm->ActiveProject contents file" );
	ProjectManagerForm->PRJMAN_SaveProject( Sender );				//	Generate ProjectManagerForm->ActiveProject File

        //SystemMessage( "Generating ProjectManagerForm->ActiveProject configuration file" );
        //ProjectOptionsForm->IDESaveOptions( Sender );                           //	Generate ProjectManagerForm->ActiveProject options form

}
//---------------------------------------------------------------------------
//	Generate a console based application
//---------------------------------------------------------------------------
void 	__fastcall 	TMainForm :: IDEGenerateConsoleExecute( TObject *Sender )
{	TMDIChild	*pForm;
	AnsiString	HomeDir;

        if ( Sender == NULL )
        	return;

        ClearSysMessages();

        SystemMessage( "Auto-Generator 'Console' starting run @ " + SystemTimeDate() );

	//	Generates a new console application
        ValueDialog->Caption = "Please specify a project name";
        ValueDialog->ShowModal();

        if ( ValueDialog->ModalResult != mrOk ) {
                return;
        }

        ProjectManagerForm->ProjectName = ValueDialog->Value;	//	Set ProjectManagerForm->ActiveProject Name, note this is NOT the same as the ProjectManagerForm->ActiveProject title

	SelectDirectoryDialog->Caption = "Select base location for ProjectManagerForm->ActiveProject " + ProjectManagerForm->ProjectName + " contents";
        SelectDirectoryDialog->ShowModal();

        if ( SelectDirectoryDialog->ModalResult != mrOk ) {
        	ProjectManagerForm->bActiveProject = false;
                SystemMessage( "Unable to continue with the auto-generation of the console application, orphanded :-(" );
                ProjectManagerForm->ProjectName = "";
                return;
        }

        char *pText = SelectDirectoryDialog->DirectoryPath.c_str();

        if ( pText[ strlen( pText ) ] == '\\' ) HomeDir = SelectDirectoryDialog->DirectoryPath + "\\" + ProjectManagerForm->ProjectName;
        else HomeDir = SelectDirectoryDialog->DirectoryPath + ProjectManagerForm->ProjectName;

        if ( !DirExists( HomeDir ) ) {
        	int mrCode;
                mrCode = MessageBox( Application->Handle, AnsiString( ).c_str(),
                		Application->Title.c_str(), MB_YESNO );
                if ( mrCode == ID_NO ) {
                	ProjectManagerForm->bActiveProject = false;
                        ProjectManagerForm->ProjectName = "";
                        return;
                }
                CreateDir( HomeDir );
        }

        SetCurrentDir( HomeDir );

        CreateDir( "bin" );
        CreateDir( "lib" );
        CreateDir( "docs" );
        CreateDir( "src" );
        CreateDir( "include" );

        ProjectOptionsForm->ConfigureForDefault( Sender );
        ProjectOptionsForm->ProjectHomeDir = HomeDir;
        ProjectOptionsForm->ShowModal();

        if ( ProjectOptionsForm->ModalResult != mrOk ) {
        	ProjectManagerForm->bActiveProject = false;
                ProjectManagerForm->ProjectName = "";
                return;
        }

        CreateMDIChild( "Main" );
        pForm = (TMDIChild*)MDIChildren[ 0 ];
        pForm->FileName = "src\\main.cpp";

        GenerateMain( pForm->SynEdit1 );

        TListItem *pItem;

        pItem = ProjectManagerForm->ListView1->Items->Add();
        pItem->Caption = pForm->Caption;
        pItem->SubItems->Strings[ 0 ] = HomeDir + "\\" + pForm->FileName;

        pForm->IDESave( Sender );
        pForm->Modified = false;
        pForm->IDEClose( Sender );

        ProjectManagerForm->IDEGenerateMakeFile( Sender );
        ProjectManagerForm->PRJMAN_SaveProject( Sender );
        ProjectManagerForm->Visible = true;

        //ProjectOptionsForm->IDESaveOptions( Sender );

        ProjectManagerForm->bActiveProject = true;

}
//---------------------------------------------------------------------------
void 	__fastcall 	TMainForm :: ProjectCompileUnitExecute(TObject *Sender)
{       TComponent 	*Originator = dynamic_cast< TComponent* >(Sender);
	TMDIChild	*pForm = (TMDIChild*)MDIChildren[ 0 ];

	if ( Originator == NULL )
        	return;

        ClearSysMessages();

        SystemMessage( "Compiling unit" );

        if ( !ProjectManagerForm->ActiveProject ) {
        	SystemMessage( "Project Manager, no active project." );
                return;
        }

        if ( ProjectManagerForm->CurrModule == -1 ) {
        	SystemMessage( "Project Manager, no active modules." );
                return;
        }

}
//---------------------------------------------------------------------------
//	Makes the ProjectManagerForm->ActiveProject files that have been changed since last compilation
//---------------------------------------------------------------------------
void __fastcall TMainForm::ProjectMakeProjectExecute(TObject *Sender)
{	TComponent	*Originator = dynamic_cast< TComponent* >(Sender);
	AnsiString	CmdLine;

	if ( !Originator )	return;

        ClearSysMessages();

        if ( !ProjectManagerForm->ActiveProject ) {
                SystemMessage( "No active ProjectManagerForm->ActiveProject." );
                return;
        }

        if ( GetCurrentDir() != ProjectOptionsForm->ProjectHomeDir )	{
        	SystemMessage( "Relocating to ProjectManagerForm->ActiveProject directory" );
                SetCurrentDir( ProjectOptionsForm->ProjectHomeDir );
        }

        if ( ProjectOptionsForm->MakeApplication.Length() <= 0 )
        	SystemMessage( "MAKE not detected." );
        else SystemMessage( "MAKE detected --> " + ProjectOptionsForm->MakeApplication );

        if ( ProjectManagerForm->Modified ) {
        	SystemMessage( "ProjectManagerForm->ActiveProject ProjectManagerForm->Modified, re-creating ProjectManagerForm->ActiveProject dependent files." );

                ProjectManagerForm->IDEGenerateMakeFile( this );

                ProjectManagerForm->Modified = false;
        }

        SystemMessage ("Executing make on ProjectManagerForm->ActiveProject's " + Name + " makefile." );

        //	Decide on what parameters to give, this is dependent on the
        //	MakeTarget in the ProjectManagerForm->ActiveProject options form

        if ( ProjectOptionsForm->MakeTarget == -1 )
        	CmdLine = Name;

        else	{
        	switch ( ProjectOptionsForm->MakeTarget ) {
                	case ( 0 ) : {	//	Clean ?
                        	CmdLine = "clean";
                                break;
                        }
                        case ( 1 ) : {	//	Config
                        	CmdLine = "config";
                                break;
                        }
                        case ( 2 ) : {	//	Install
                        	CmdLine = "install";
                                break;
                        }
                        case ( 3 ) : {	//	UnInstall
                        	CmdLine = "uninstall";
                                break;
                        }
                        case ( 4 ) : {	//	make
                        	CmdLine = "make";
                                break;
                        }
                        case ( 5 ) : {	//	build
                        	CmdLine = "build";
                                break;
                        }
                        default	   : {	//	Defaults to ProjectManagerForm->ActiveProject name
                        	CmdLine = Name;
                                break;
                        }
                }
        }

        SystemMessage( "Executing " + ProjectOptionsForm->MakeApplication + " " + CmdLine );

        if ( !ShellExecute( Application->Handle, "open", ProjectOptionsForm->MakeApplication.c_str(),
        	CmdLine.c_str(), ProjectOptionsForm->ProjectHomeDir.c_str(), SW_SHOWNORMAL ) )
		SystemMessage( "Unable to execute make for this ProjectManagerForm->ActiveProject." );
        else SystemMessage( "Make in progress." );

        SystemMessage( "Returning to IDE." );
}
//---------------------------------------------------------------------------
void 	__fastcall 	TMainForm :: ProjectBuildProjectExecute( TObject *Sender )
{	TComponent	*Originator = dynamic_cast< TComponent* >(Sender);
	AnsiString	asCmdLine;

	if ( !Originator )	return;

        SystemMessage( "Building ProjectManagerForm->ActiveProject [ " + Name + " ]" );

        if ( !ProjectManagerForm->ActiveProject )	{
        	SystemMessage( "No active ProjectManagerForm->ActiveProject, for build." );
                return;
        }

        if ( GetCurrentDir() != ProjectOptionsForm->ProjectHomeDir )
        	SetCurrentDir( ProjectOptionsForm->ProjectHomeDir );

        if ( ProjectOptionsForm->MakeApplication.Length() <= 0 )	{
        	SystemMessage( "MAKE not detected, aborting build." );
                return;
        }

        asCmdLine = "build";	//	Force to build mode, ie clean then make ProjectManagerForm->ActiveProject

        if ( !ShellExecute( Application->Handle, "open", ProjectOptionsForm->MakeApplication.c_str(),
        	asCmdLine.c_str(), ProjectOptionsForm->ProjectHomeDir.c_str(), SW_SHOWNORMAL ) )
                SystemMessage( "Unable to execute " + ProjectOptionsForm->MakeApplication + asCmdLine +
                	" on ProjectManagerForm->ActiveProject " + Name );
        else SystemMessage( "Executing " + ProjectOptionsForm->MakeApplication );

}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ProjectViewSourceExecute(TObject *Sender)
{	TComponent *pComponent = dynamic_cast< TComponent* >(Sender);

	if ( !Sender ) return;

	if ( !ProjectManagerForm->ActiveProject ) {
        	ClearSysMessages();
        	SystemMessage( "No active ProjectManagerForm->ActiveProject, please create or open an existing ProjectManagerForm->ActiveProject" );
                return;
        }

        if ( pComponent->Name == "ProjectManagerForm" ) {
        //	Double click on the ProjectManagerForm->ActiveProject manager form module

        	if ( !ProjectManagerForm->ListView1->Selected ) {	//	This should never be called
                	SystemMessage( "Please double click on a module in the ProjectManagerForm->ActiveProject manager" );
                	return;
                }

                TMDIChild	*pForm = new TMDIChild( MainForm );
                if ( pForm ) {
                	pForm->Caption = ProjectManagerForm->ListView1->Selected->Caption;
                	pForm->SynEdit1->Lines->LoadFromFile( ProjectManagerForm->ListView1->Selected->SubItems->Strings[ 0 ] );
                } else {
                	SystemMessage( "Unable to create new form" );
                }
                return;
        }

        if ( pComponent->Name == "ViewSource1" ) {
        //	Called from the main form's menu ie ProjectManagerForm->ActiveProject->View Source
                TMDIChild *pForm = new TMDIChild( MainForm );
                if ( pForm ) {
                	SetCurrentDir( ProjectOptionsForm->ProjectHomeDir );
                	pForm->Caption = Name;
                	pForm->SynEdit1->Lines->LoadFromFile( ProjectManagerForm->ListView1->Items->Item[ 0 ]->SubItems->Strings[ 0 ] );
                }
                return;
        }
}
//---------------------------------------------------------------------------
//	$Method		::	FormDestroy
//	$Purpose	::      Called when form destruction, allows for the ide
//				to save the current settings
//---------------------------------------------------------------------------
//	Form destruction event method
//---------------------------------------------------------------------------
void	__fastcall	TMainForm :: FormDestroy( TObject *Sender )
{
/*
	if ( EnviromentOptionsForm ) {
        	if ( ( EnviromentOptionsForm->Modified ) && ( EnviromentOptionsForm->AutoSaveDesktopFiles ) ) {
                	SystemMessage( "Auto saving enviroment options." );
        		EnviromentOptionsForm->WriteToRegistry( Sender );
                        ProjectManagerForm->PRJMAN_SaveProject( Sender );
                }
        }

        //	Save current settings to system registry

        if ( ProjectManagerForm->ActiveProject ) {
                if ( ProjectManagerForm->Modified )	{	//	ProjectManagerForm->ActiveProject ProjectManagerForm->Modified ?
	        	int mrCode;

	                mrCode = MessageBox( Application->Handle, AnsiString( Name + " modifed. Save ?" ).c_str(),
	                		Application->Title.c_str(), MB_YESNO | MB_ICONQUESTION );

	                if ( mrCode == mrYes ) {
	        		ProjectManagerForm->PRJMAN_SaveProject( Sender );
        	        }
	        }

        	if ( !Registry ) Registry = new TRegistry;

                Registry->LazyWrite = false;
                Registry->OpenKey( PSXIDE_REGKEY, true );

        	Registry->WriteString( "LastProject", MainForm->Name );
	        Registry->WriteString( "LastDir", ProjectOptionsForm->ProjectHomeDir );

	        Registry->CloseKey();

                delete Registry;
        }
*/

	// ....	was the emulator loaded successfully at startup, if so unload it
        if ( hEmulatorHandle != INVALID_HANDLE_VALUE )	//	if emulator is loaded, close it
        	FreeLibrary( hEmulatorHandle );

        // ....	and again for the debugger
        if ( hDebuggerHandle != INVALID_HANDLE_VALUE )	//	do the same with the debugger
        	FreeLibrary( hDebuggerHandle );

        // ....	and compiler
        if ( hCompilerHandle != INVALID_HANDLE_VALUE )	//	And compiler dll
        	FreeLibrary( hCompilerHandle );

}
//---------------------------------------------------------------------------
//
//	Asks for a new name for this project, not the title and then asks
//	the Project Manager to save it, and then saves the Project Options
//	and then generates a new makefile.
//
//---------------------------------------------------------------------------
void 	__fastcall 	TMainForm :: FileSaveProjectAsExecute( TObject *Sender )// 	this is wrong
{
        SystemMessage( "[NI] File Save Project As completed, no errors." );
}
//---------------------------------------------------------------------------
//	Attempts to load a project specified by the user, if available then
// asks the project manager to open the project.
//---------------------------------------------------------------------------
void 	__fastcall	TMainForm :: FileOpenProjectExecute( TObject *Sender )
{	TComponent	*Originator = dynamic_cast< TComponent* >(Sender);

	if ( Originator == NULL )
        	return;

        // ....	Setup the display dialog
        OpenDialog->Title = "Select project to load";
        OpenDialog->Filter = "Project Group Files (*.psxgrp)|*.psxgrp|Project Files (*.psxide)|*.psxide|All Files (*.*)|*.*";

        if ( OpenDialog->Execute() ) {
        	if ( FileExists( OpenDialog->FileName ) ) {
                	ProjectManagerForm->OpenProject( MainForm );
                }
        }

}
//---------------------------------------------------------------------------
//	This is called from the mainform file->New Unit menu item, it auto
//	generates a module for the ProjectManagerForm->ActiveProject, both the header and the main code
//	files are generated.
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileNewUnitExecute(TObject *Sender)
{	TComponent 	*Originator = dynamic_cast< TComponent* >(Sender);
	TMDIChild	*Code;
        TMDIChild	*Header;

	if ( !Originator ) {
        	SystemMessage( "Bad Sender, for File New Unit" );
                return;
        }

        if ( Originator->Name == "FileNewUnit" ) {	//	Mainform menu call
        	SystemMessage( "Enter a name for this new unit" );

        	ValueDialog->Caption = "Please select a name for this unit";
                ValueDialog->ShowModal();

                if ( ValueDialog->ModalResult != mrOk ) {
                	SystemMessage( "New unit Action cancelled" );
                        return;
                }

                Code = new TMDIChild( Application );

                Code->Caption = ValueDialog->Value;
                Code->FileName = ValueDialog->Value + ".cpp";

                Code->SynEdit1->Lines->Add( "//---------------------------------------------------------------------------" );
                Code->SynEdit1->Lines->Add( "#ifndef " + Code->Caption + "C" );
                Code->SynEdit1->Lines->Add( "#define " + Code->Caption + "C" );
                Code->SynEdit1->Lines->Add( "//---------------------------------------------------------------------------" );
                Code->SynEdit1->Lines->Add( "#include \"" + Code->Caption + ".h\"" );
                Code->SynEdit1->Lines->Add( "//---------------------------------------------------------------------------" );
                Code->SynEdit1->Lines->Add( "#endif" );
                Code->SynEdit1->Lines->Add( "//---------------------------------------------------------------------------" );

                Header = new TMDIChild( Application );

                Header->Caption = ValueDialog->Value;
                Header->FileName = ValueDialog->Value + ".h";

                Header->SynEdit1->Lines->Add( "//---------------------------------------------------------------------------" );
                Header->SynEdit1->Lines->Add( "#ifndef " + Header->Caption + "H" );
                Header->SynEdit1->Lines->Add( "#define " + Header->Caption + "H" );
                Header->SynEdit1->Lines->Add( "//---------------------------------------------------------------------------" );
                Header->SynEdit1->Lines->Add( "#endif" );
                Header->SynEdit1->Lines->Add( "//---------------------------------------------------------------------------" );

                if ( ProjectManagerForm->ActiveProject )	{	//	Active ProjectManagerForm->ActiveProject ?
                	TListItem *pItem = ProjectManagerForm->ListView1->Items->Add();

                        pItem->Caption = ValueDialog->Value;
                        pItem->SubItems->Add( AnsiString( ProjectOptionsForm->ProjectHomeDir + "\\src\\" + ValueDialog->Value + ".cpp"  ) );

			Header->FileName = ProjectOptionsForm->ProjectHomeDir + "\\include\\" + ValueDialog->Value + ".h";
                        Code->FileName = ProjectOptionsForm->ProjectHomeDir + "\\src\\" + ValueDialog->Value + ".cpp";

                }

                Header->IDESave( MainForm );
                Code->IDESave( MainForm );

                ProjectManagerForm->IDEGenerateMakeFile( MainForm );
                ProjectManagerForm->PRJMAN_SaveProject( Sender );
        }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileSaveAllExecute(TObject *Sender)
{	TMDIChild	*pForm;
	//	Save all files

        if ( !Sender ) return;

        if ( MDIChildCount <= 0 ) return;	//	Nothing to save

        for ( int i=MDIChildCount; i>0; i-- ) {
        	pForm = (TMDIChild*)MDIChildren[ 0 ];
                pForm->IDESave( this );
                pForm->Modified = false;
        }

        ProjectManagerForm->PRJMAN_SaveProject( Sender );
}
//---------------------------------------------------------------------------
void 	__fastcall 	TMainForm :: FileSave1Execute( TObject *Sender )
{       TComponent	*Originator = dynamic_cast< TComponent* >(Sender);
	TMDIChild	*pForm = (TMDIChild*)MDIChildren[ 0 ];

        if ( ( !Originator ) || ( !pForm ) )
        	return;

        ClearSysMessages();

        pForm->IDESave( this );

        pForm->Modified = false;

}
//---------------------------------------------------------------------------
void 	__fastcall 	TMainForm :: FileSaveAs1Execute( TObject *Sender )
{	TComponent	*Originator = dynamic_cast< TComponent* >(Sender);
	TMDIChild	*pForm = (TMDIChild*)MDIChildren[ 0 ];

        if ( !Originator )	return;

        SaveDialog->Title = "Specify new file name";
        SaveDialog->Filter = "C Files ( *.c )|*.c|C++ Files ( *.cpp )|*.cpp|All Files ( *.* )|*.*";
        if ( SaveDialog->Execute() ) {
        	pForm->FileName = SaveDialog->FileName;
                pForm->IDESave( this );
                pForm->Modified = false;
                // Something to update the list in the ProjectManagerForm->ActiveProject manager form
                if ( pForm->Index == -1 )	return;
                ProjectManagerForm->ListView1->Items->Item[ pForm->Index ]->SubItems->Strings[ 0 ] = pForm->FileName;
        }
}
//---------------------------------------------------------------------------
//	Opens Internet Explorer and directs to
//	https://playstation2-linux.com/projects/psxide/
//---------------------------------------------------------------------------
void __fastcall TMainForm::HelpProjectHomePageExecute(TObject *Sender)
{
	if ( !ShellExecute( Application->Handle, "open", "iexplore.exe",
        	"https://playstation2-linux.com/projects/psxide/",
                GetCurrentDir().c_str(), SW_SHOWNORMAL ) ) {
                SystemMessage( "Unable to launch Internet Explorer for viewing home page.\nPlease go to https://playstation2-linux.com/projects/psxide/" );
	}
}
//---------------------------------------------------------------------------
//	Main menu Help -> Index
//
//	Opens Internet Explorer and directs to the install directory, usually
//	C:\Program File\Liquid Silicon Developments\PSX IDE For Windows and
//	directs to the file index.html in the docs sub-directory
//---------------------------------------------------------------------------
void __fastcall TMainForm::HelpIndexExecute(TObject *Sender)
{
	ShellExecute( NULL, "open", "iexplore.exe", "http://localhost/", NULL, SW_SHOWNORMAL );
}
//---------------------------------------------------------------------------
//	Prints the current open module, needs to expanded to allow printing
//	from the ProjectManagerForm->ActiveProject manager form, ie right-clicking on the module and
//	selecting print from the drop down menu
//---------------------------------------------------------------------------
void __fastcall TMainForm::FilePrintExecute(TObject *Sender)
{       TMDIChild	*pForm = (TMDIChild*)MDIChildren[ 0 ];
	//	This attempts to print the current open file

        if ( !Sender ) return;

        if ( !pForm ) {
        	MessageBox( Application->Handle, "Ha Ha, Funny! Unable to print fresh air!", Application->Title.c_str(), MB_OK );
                return;
        }

        if ( PrintDialog->Execute() ) {
        	SystemMessage( "Printing " + pForm->Caption );
                pForm->SynEditPrint1->Print();
        }
}
//---------------------------------------------------------------------------
//      This adds an existing module to the current ProjectManagerForm->ActiveProject
//---------------------------------------------------------------------------
void __fastcall TMainForm::ProjectAddToProjectExecute(TObject *Sender)
{
	if ( !Sender ) return;	//	Bad Sender

        if ( !ProjectManagerForm->ActiveProject ) {
        	SystemMessage( "No open ProjectManagerForm->ActiveProject" );
                return;
        }

        OpenDialog->Title = "Select file to add to ProjectManagerForm->ActiveProject";

        if ( OpenDialog->Execute() ) {
        	SystemMessage( "Adding " + OpenDialog->FileName + " to ProjectManagerForm->ActiveProject " + Name );
                TListItem *pItem = ProjectManagerForm->ListView1->Items->Add();
                AnsiString mName = ExtractFileName( OpenDialog->FileName );

                pItem->SubItems->Add( OpenDialog->FileName );

                if ( mName.Pos( "." ) == 0 ) pItem->Caption = mName;
                else pItem->Caption = mName.SubString( 0, mName.Pos( "." ) - 1 );
        }
}
//---------------------------------------------------------------------------
//	This removes the currently selected item in the ProjectManagerForm->ActiveProject manager form
//	from the ProjectManagerForm->ActiveProject, it does not call for the ProjectManagerForm->ActiveProject, make, and
//	configuration files to be rebuilt at present
//---------------------------------------------------------------------------
void __fastcall TMainForm::ProjectRemoveFromProjectExecute(TObject *Sender)
{
	if ( !Sender ) return;

        if ( !ProjectManagerForm->ActiveProject ) {
        	SystemMessage( "No ProjectManagerForm->ActiveProject open" );
                return;
        }

        if ( !ProjectManagerForm->ListView1->Selected ) {
        	SystemMessage( "Please select a modules to remove from ProjectManagerForm->ActiveProject" );
                return;
        }

        int mrCode = MessageBox( Application->Handle,
        	AnsiString( "Confirm removal of module " +
                	ProjectManagerForm->ListView1->Selected->Caption +
                        " from ProjectManagerForm->ActiveProject " +
                        Name ).c_str(),
        	Application->Title.c_str(), MB_YESNO );

        if ( mrCode == ID_YES ) {
        	SystemMessage( "Deleting module " + ProjectManagerForm->ListView1->Selected->Caption );
                ProjectManagerForm->ListView1->Items->Delete( ProjectManagerForm->ListView1->Selected->Index );
        }
}
//---------------------------------------------------------------------------
//
//	Method		::	New Application Click
//	Parameters	::	TObject *Sender, originator of call. NOT USED
//	Purpose		::	Calls the FileApplicationExecute Action
//
//---------------------------------------------------------------------------
void 	__fastcall 	TMainForm :: NewApplication1Click( TObject *Sender )
{
	FileNewApplicationExecute( MainForm );
}
//---------------------------------------------------------------------------
//	VCL Event, called when the splitter is released
//---------------------------------------------------------------------------
void __fastcall TMainForm::ToolsShellExecute(TObject *Sender)
{
  	//	Launches a Command Line Interpreter, ie COMMAND.COM on Windows
        //	or BASH on UNIX

	ShellExecute( Handle, "open", "C:\\COMMAND.COM", NULL, "C:\\", SW_SHOWNORMAL );
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EditRedoExecute(TObject *Sender)
{       TMDIChild	*pForm = (TMDIChild*)MDIChildren[ 0 ];
	//	Edit Redo
        if ( MDIChildCount == 0 )	return;

        if ( !pForm )	return;

        pForm->SynEdit1->Redo();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EditCut1Execute(TObject *Sender)
{	TMDIChild *pForm = (TMDIChild*)MDIChildren[ 0 ];
	//	Edit Cut

        if ( MDIChildCount == 0 )	return;

        if ( !pForm )	return;

        pForm->SynEdit1->CutToClipboard();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EditCopy1Execute(TObject *Sender)
{	TMDIChild *pForm = (TMDIChild*)MDIChildren[ 0 ];
	//	Edit Copy
        if ( MDIChildCount == 0 )	return;

        if ( !pForm ) 	return;

        pForm->SynEdit1->CopyToClipboard();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EditPaste1Execute(TObject *Sender)
{	TMDIChild *pForm = (TMDIChild*)MDIChildren[ 0 ];
	//	Edit Paste
        if ( MDIChildCount == 0 )	return;
        if ( !pForm )	return;

        pForm->SynEdit1->PasteFromClipboard();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::HelpContentsExecute(TObject *Sender)
{
	//	Help Contents
        ShellExecute( Handle, "open", "iexplore.exe", "http://localhost/help/", NULL, SW_SHOWNORMAL );
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ProjectViewMakeFileExecute(TObject *Sender)
{
	//	ProjectManagerForm->ActiveProject View MakeFile
        if ( !ProjectManagerForm->ActiveProject )	{
        	SystemMessage( "No active ProjectManagerForm->ActiveProject, unable to view makefile" );
                return;
        }

        SetCurrentDir( ProjectOptionsForm->ProjectHomeDir );

        if ( !FileExists( "Makefile" ) ) {
        	SystemMessage( "Makefile is NOT present on disk." );
                return;
        }

        CreateMDIChild( "Makefile" );
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ProjectInformationExecute(TObject *Sender)
{
	//	ProjectManagerForm->ActiveProject Information
        if ( !Sender )	return;

        if ( !ProjectManagerForm->ActiveProject )	{
        	SystemMessage( "No active ProjectManagerForm->ActiveProject." );
                return;
        }

        ProgInfoDialog->ShowModal();
}
//---------------------------------------------------------------------------
//	Executes a make all for the ProjectManagerForm->ActiveProject, ie rebuilds ALL ProjectManagerForm->ActiveProject files
//	that have been ProjectManagerForm->Modified since last make was executed
//---------------------------------------------------------------------------
void __fastcall TMainForm::ProjectMakeAllExecute(TObject *Sender)
{
	//	ProjectManagerForm->ActiveProject Make All
}
//---------------------------------------------------------------------------
//	Same as above but rebuilds ALL ProjectManagerForm->ActiveProject files, whether they have been
//	changed or not
//---------------------------------------------------------------------------
void __fastcall TMainForm::ProjectBuildAllExecute(TObject *Sender)
{
	//	ProjectManagerForm->ActiveProject Build All
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::RunRunExecute(TObject *Sender)
{	TComponent	*Originator = dynamic_cast< TComponent*>(Sender);
	//	Run
        if ( !ProjectManagerForm->ActiveProject ) {
        	SystemMessage( "No active ProjectManagerForm->ActiveProject" );
                return;
        }

        SystemMessage( "Call to Run->RunExecute from " + Originator->Name );

        switch ( ProjectOptionsForm->PlatformId ) {

        	case ( PLATFORM_PSX ) : {	//	PlayStation, find and run emulator

                        if ( ( hEmulatorHandle == INVALID_HANDLE_VALUE ) && ( EnviromentOptionsForm->Emulator.Length() <= 0 ) ) {
                           SystemMessage( "Unable to execute active project, no internal or external emulator has been specified." );
                           return;
                        }

                	if ( hEmulatorHandle != INVALID_HANDLE_VALUE ) {
                        	SystemMessage( "Transferring program to Internal PlayStation Emulator." );
                                if ( ProjectOptionsForm->DebugMode ) {
                                	SystemMessage( "Executing current project in Emulator DEBUG Mode." );
                                	//EmulatorDebug();
                                } else {
                                	//EmulatorLoad( AnsiString( ProjectOptionsForm->ProjectHomeDir + "\\" +
                                        //	ProjectOptionsForm->ProjectName + ".exe" );

                                        //if ( lpfnEmulatorExecute != NULL )
                                        //	EmulatorExecute();

                                        SystemMessage( "Executing current project in Emulator Normal Mode." );
                                }

                        } else if ( EnviromentOptionsForm->Emulator.Length() > 0 )
                           	SystemMessage( "Transferring program to external PlayStation Emulator." );
                        else	SystemMessage( "No internal or external PlayStation emulator present. Defaulting to trying comms-link." );
                        break;
                }

                case ( PLATFORM_PS2 ) : {	//	PlayStation 2
                	SystemMessage( "Transferring program to PlayStation 2 Emulator." );
                        break;
                }

                case ( PLATFORM_N64 ) : {	//	Nintendo 64
                	SystemMessage( "Transferring program to Nintendo 64 Emulator." );
                        break;
                }

                case ( PLATFORM_PS2L ) : {	//	PlayStation 2 LINUX
                	SystemMessage( "Transferring to PlayStation 2 (LINUX) Development Client." );
                        break;
                }

                case ( PLATFORM_PCL ) : {	//	PC LINUX
                	SystemMessage( "Transferring to PC (LINUX) Development Client." );
                        break;
                }

                case ( PLATFORM_PCW ) : {	//	PC Windows
                	SystemMessage( "Transferring to PC (Windows) Test Client." );
                        if ( FileExists( ProjectOptionsForm->ProjectHomeDir + "\\" + ProjectManagerForm->ProjectName + ".exe" ) ) {
                        	if ( asRunParams.Length() <= 0 ) {
                                	ShellExecute( Application->Handle, "open",
                                        	AnsiString( ProjectOptionsForm->ProjectHomeDir + "\\" + ProjectManagerForm->ProjectName + ".exe" ).c_str(),
                                                NULL, ProjectOptionsForm->ProjectHomeDir.c_str(), SW_SHOWNORMAL );
                                } else {
                                	ShellExecute( Application->Handle, "open",
                                        	AnsiString( ProjectOptionsForm->ProjectHomeDir + "\\" + ProjectManagerForm->ProjectName + ".exe" ).c_str(),
                                                asRunParams.c_str(), ProjectOptionsForm->ProjectHomeDir.c_str(), SW_SHOWNORMAL );
                                }
                                SystemMessage( "Executing Application " + ProjectManagerForm->ProjectName );
                        }
                        break;
                }
        }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::RunParametersExecute(TObject *Sender)
{
	//	Run with extra parameters
        if ( !ProjectManagerForm->ActiveProject ) {
        	SystemMessage( "No active ProjectManagerForm->ActiveProject" );
                return;
        }
        ValueDialog->Value = "";
        ValueDialog->Caption = "Enter extra parameters to be passed to the prgram upon execution";
        ValueDialog->ShowModal();
        if ( ValueDialog->ModalResult != mrOk ) return;
        asRunParams = ValueDialog->Value;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::RunStepOverExecute(TObject *Sender)
{
	//	Run Step Over
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::RunTraceIntoExecute(TObject *Sender)
{
	//	Run Trace Into
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::RunPauseExecute(TObject *Sender)
{
	//	Run pause
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::RunResetExecute(TObject *Sender)
{
	//	Run Reset
        //EmulatorStop();
        //EmulatorReset();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ToolsCommSetupExecute(TObject *Sender)
{
	//	Setup the communications method for the target console
        ClearSysMessages();

        SystemMessage( "Not implemented yet. Here setup is launched for the desired." );
        SystemMessage( "communication method for the target console. Note not all" );
        SystemMessage( "methods are available for all targets, ie USB and NET are not" );
        SystemMessage( "suitable communications methods for example the PlayStation" );
        SystemMessage( "but is suitable for the PlayStation 2." );
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::LaunchPackageManagementTool1Click( TObject *Sender )
{
	//	Launches a package manager ie the ability to load at runtime
        //	dll files that have exported specific functions
        //if ( hDebuggerHandle ) //	Debugger present

        //if ( hEmulatorHandle ) //	Emulator present
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ToolsEmulatorConfigureExecute(TObject *Sender)
{
        ClearSysMessages();
        SystemMessage( "Configuring Emulator." );
        //EmulatorConfigure();	//	Imported from the Emulator DLL
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ToolsEmulatorExecuteExecute(TObject *Sender)
{
	if ( !ProjectManagerForm->ActiveProject ) {
        	SystemMessage( "No active project." );
                //return;
        }

	ClearSysMessages();

        if ( ( ProjectOptionsForm->PlatformId == PLATFORM_PSX ) &&
             ( hEmulatorHandle != INVALID_HANDLE_VALUE ) )	{	//	Internal emulator present ?
             	SystemMessage( "Executing internal PlayStation Emulator." );

                //if ( lpfnEmulatorExecute != NULL )
                //	EmulatorExecute();
                return;
        } else if ( ( EnviromentOptionsForm->Emulator.Length() > 0 ) &&
        	( EnviromentOptionsForm->Emulator != "Internal" ) ) {
                	SystemMessage( "Executing external emulator." );
                        ShellExecute( Application->Handle, "open",
                        	EnviromentOptionsForm->Emulator.c_str(),
                                NULL, GetCurrentDir().c_str(), SW_SHOWNORMAL );
                        //return;
        } else {
        	SystemMessage( "Internal and External Emulator is unknown." );
                SystemMessage( "Use the Enviroment Options Library tabsheet to specify an external emulator." );
                SystemMessage( "Internal emulator is for the PlayStation platform only." );
        }
}
//---------------------------------------------------------------------------
//!	ACTION		::	Tools Emulator Transfer Execute.
//! Attempts to open a file that the user specifies and then transfers to the
//! internal emulator, if present.
//---------------------------------------------------------------------------
void 	__fastcall	TMainForm :: ToolsEmulatorTransferExecute( TObject *Sender )
{

	if ( Sender == NULL )
        	return;

        //! ...	Starting

	ClearSysMessages();	//!	Clear message view

        //!	output nice message to user
        SystemMessage( "Select a program to transfer to emulator for execution." );

        //!	Set the file filter mode
	OpenDialog->Filter = "Applications (*.exe)|*.exe|All Files (*.*)|*.*";

        //if ( OpenDialog->Execute() ) //&& ( lpfnEmulatorTransfer != NULL ) )
        //	EmulatorTransfer( OpenDialog->FileName.c_str() );

        SystemMessage( "Transferring " + OpenDialog->FileName + " to emulator for to execution." );

}
//---------------------------------------------------------------------------
void __fastcall TMainForm::OpenDialogShow(TObject *Sender)
{
	OpenDialog->FileName = "";

        if ( ProjectManagerForm->ActiveProject ) OpenDialog->InitialDir = ProjectOptionsForm->ProjectHomeDir;
        else if ( EnviromentOptionsForm->SharedRepository.Length() > 0 )
        	OpenDialog->InitialDir = EnviromentOptionsForm->SharedRepository;
        else	OpenDialog->InitialDir = "C:\\My Documents";
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ViewWindowListExecute(TObject *Sender)
{       TMDIChild	*pForm;

	if ( MDIChildCount == 0 )	{
        	SystemMessage( "No windows open." );
                return;
        }

        WindowListDialog->ListView1->Items->Clear();

        for ( int i=MDIChildCount; i>0; i-- ) {
        	pForm = (TMDIChild*)MDIChildren[ i ];
                if ( pForm ) {
                	TListItem *pItem = WindowListDialog->ListView1->Items->Add();

                        pItem->Caption = pForm->Caption;
                        pItem->SubItems->Add( pForm->FileName );
                }
        }

        WindowListDialog->ShowModal();

        if ( WindowListDialog->ModalResult != mrOk ) 	return;

        if ( !WindowListDialog->ListView1->Selected )	return;

        pForm = (TMDIChild*)MDIChildren[ WindowListDialog->ListView1->Selected->Index ];

        if ( !pForm )	return;

        pForm->BringToFront();	//	Force this window to the front of the window z-stack

}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ToolsRepositoryExecute(TObject *Sender)
{
	//	Select new tools repository, ie the Shared repository
        EnviromentOptionsForm->SpeedButton7Click( Sender );
        if ( EnviromentOptionsForm->Modified )
        	EnviromentOptionsForm->WriteToRegistry( Sender );
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ToolsAudioExecute(TObject *Sender)
{
	//	Launches the audio editor tool
        if ( EnviromentOptionsForm->AudioEditor.Length() <= 0 ) {
        	SystemMessage( "No external Audio Editor has been specified." );
                SystemMessage( "Use the Enviroment Options Library tabsheet to specify an Audio Editor." );
        	return;
        }

        SystemMessage( "Executing external Audio Editor." );

        ShellExecute( Application->Handle, "open", EnviromentOptionsForm->AudioEditor.c_str(),
                      NULL, GetCurrentDir().c_str(), SW_SHOWNORMAL );
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ToolsGfx2DExecute(TObject *Sender)
{
	//	Launches Graphics Tools for 2D modification
        if ( EnviromentOptionsForm->Gfx2DEditor.Length() <= 0 ) {
        	SystemMessage( "No external Graphics Editor for 2D images has not been specified." );
                SystemMessage( "Use the Enviroment Options Library tabsheet to specify an external image editor." );
                return;
        }

        SystemMessage( "Graphics Tools 2D" );
        ShellExecute( Application->Handle, "open", EnviromentOptionsForm->Gfx2DEditor.c_str(),
                      NULL, GetCurrentDir().c_str(), SW_SHOWNORMAL );
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ToolsGfx3DExecute(TObject *Sender)
{
	//	Graphics Tools 3D
        if ( EnviromentOptionsForm->Gfx3DEditor.Length() <= 0 ) {
        	SystemMessage( "No external Graphics Editor for 3D objects has not been specified." );
                SystemMessage( "Use the Enviroment Options Library tabsheet to specifiy an external 3D object editor." );
                return;
        }

        SystemMessage( "Graphics Tools 3D" );

        ShellExecute( Application->Handle, "open", EnviromentOptionsForm->Gfx3DEditor.c_str(),
                      NULL, GetCurrentDir().c_str(), SW_SHOWNORMAL );
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ToolsGfxMovieExecute(TObject *Sender)
{
	//	Graphics tools Movie (animations)
        if ( EnviromentOptionsForm->MovieEditor.Length() <= 0 ) {
        	SystemMessage( "No external movie editor has been specified." );
                SystemMessage( "Use the Enviroment Options Library tabsheet to specify an external application." );
                return;
        }

        SystemMessage( "Graphics Tools Movies" );

        ShellExecute( Application->Handle, "open", EnviromentOptionsForm->MovieEditor.c_str(),
                      NULL, GetCurrentDir().c_str(), SW_SHOWNORMAL );
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ToolsCDBurnerExecute(TObject *Sender)
{
	//	Launches the CD Burner application
        if ( EnviromentOptionsForm->CDBurner.Length() <= 0 ) {
        	SystemMessage( "No external CD Burning software has been specified." );
                SystemMessage( "Use the Enviroment Options Library tabsheet to specify an external application." );
                return;
        }

        SystemMessage( "CD Burner" );
        ShellExecute( Application->Handle, "open", EnviromentOptionsForm->CDBurner.c_str(),
                      NULL, GetCurrentDir().c_str(), SW_SHOWNORMAL );
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ToolsPackageManagerExecute(TObject *Sender)
{
     PackagesForm->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ToolsClassWizardExecute(TObject *Sender)
{
	//	Execute a new class wizard
        SystemMessage( "Class Wizard is not implemented yet." );
}
//---------------------------------------------------------------------------
//	Form creation event method
//---------------------------------------------------------------------------
void 	__fastcall 	TMainForm :: FileOpenProjectGroupExecute( TObject *Sender )
{	TComponent	*Originator = dynamic_cast< TComponent* >(Sender);

	if ( !Originator )	return;

        ClearSysMessages();

        SystemMessage( "ProjectManagerForm->ActiveProject Group Load operation requested. " );
        SystemMessage( "From component " + Originator->Name );

        //	ProjectManagerForm->IDELoadGroup( Sender );

	//	Load a ProjectManagerForm->ActiveProject group
        if ( ( ProjectManagerForm->ActiveProject ) && ( ProjectManagerForm->Modified ) ) {	//	Current ProjectManagerForm->ActiveProject is ProjectManagerForm->Modified, save before load ?
        	int mrCode;

                SystemMessage( "Current ProjectManagerForm->ActiveProject is not saved." );

                mrCode = MessageBox( Application->Handle, "Current ProjectManagerForm->ActiveProject is not saved. Save ?",
                	Application->Title.c_str(), MB_YESNO | MB_ICONQUESTION );

                if ( mrCode == mrYes )	{
                	ProjectManagerForm->PRJMAN_SaveProject( Sender );
                        SystemMessage( "Saving current ProjectManagerForm->ActiveProject " + Name );
                } else {
                	SystemMessage( "Not saving ProjectManagerForm->ActiveProject " + Name + ". Abandoning changes." );
                }

                ProjectManagerForm->IDECloseProject( Sender );
                
                ProjectManagerForm->Modified = false;

        } else {

        	SystemMessage( "No current ProjectManagerForm->ActiveProject or not ProjectManagerForm->Modified." );

        }

        ProjectManagerForm->bActiveProject = false;

        // otherwise no ProjectManagerForm->ActiveProject or not ProjectManagerForm->Modified and does not need saving

        OpenDialog->Title = "Select ProjectManagerForm->ActiveProject group to load";
        OpenDialog->Filter = FILTER_DEFAULT;

        if ( !OpenDialog->Execute() )	{
        	SystemMessage( "Aborting operation." );
                return;
        }

        ProjectManagerForm->PRJMAN_OpenGroup( Sender );

        SystemMessage( "Load operation completed. OK." );
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SearchFindExecute(TObject *Sender)
{
        SearchReplaceDialog->SearchType = TYPE_SEARCH_LOCAL;
        SearchReplaceDialog->Show();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SearchFindInFilesExecute(TObject *Sender)
{
        SearchReplaceDialog->SearchType = TYPE_SEARCH_FILE;
        SearchReplaceDialog->Show();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SearchReplaceExecute(TObject *Sender)
{
        SearchReplaceDialog->SearchType = TYPE_SEARCH_REPLACE;
        SearchReplaceDialog->Show();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::RepairRegistry1Click(TObject *Sender)
{
	//	This restores the system registry to a known state.
        // Note that this is valid for the HKEY_CURRENT_USER\Liquid Silicon Developments\PSX IDE For Windows
        // only

        if ( Sender == NULL )	{
        	MessageBox( NULL, "Invalid Sender", "KonDev", MB_OK | MB_ICONEXCLAMATION );
        	return;
        }
        RepairRegistry();
}
//---------------------------------------------------------------------------
//      Used to repair a damaged, or missing, system registry entries for the ide
//---------------------------------------------------------------------------
__declspec( dllexport ) void	__fastcall	RepairRegistry( void )
{	TRegistry	*Registry;
	int		mrCode;

        mrCode = MessageBox( NULL, "Registry failure, repair?", "PSXIDE", MB_YESNO | MB_ICONQUESTION );
        if ( mrCode != mrYes )	return;

	Registry = new TRegistry;
        Registry->LazyWrite = false;

        //	Main registry key for psxide
        Registry->OpenKey( PSXIDE_REGKEY, true );	//	Force create main key

        Registry->WriteString( "InstallPath", NULL );

        Registry->CloseKey();

        //	Enviroment Options
        Registry->OpenKey( ENVIROMENT_OPTIONS_REGKEY, true );
        Registry->CloseKey();

        //	Write the preferences tab sheet to the registry
        Registry->OpenKey( ENV_OPTIONS_PREFERENCES, true );	//	Open key, create if not already exists

	Registry->WriteBool( "ShowCompilerProgress", true );
        Registry->WriteBool( "BeepOnCompletion", true );
        Registry->WriteBool( "CacheHeadersOnStartup", false );
        Registry->WriteBool( "WarnOnPackageRebuild", true );
        Registry->WriteBool( "AutoSaveEditorFiles", true );
        Registry->WriteBool( "AutoSaveDesktopFiles", false );
        Registry->WriteBool( "HideOnRun", false );
        Registry->WriteBool( "MinimiseOnRun", false );

        Registry->WriteString( "SharedRepository", NULL );

        Registry->WriteString( "ToolsRepository", NULL );

        Registry->CloseKey();

        //	Write the Library Tabsheet
        Registry->OpenKey( ENV_OPTIONS_LIBRARY, true );	//	Open key

        Registry->WriteString( "LibraryPath", NULL );
        Registry->WriteString( "PackageOutputPath", NULL );
        Registry->WriteString( "LibraryOutputPath", NULL );
        Registry->WriteString( "BrowsingPath", NULL );

        Registry->WriteString( "Emulator", "Internal" );
        Registry->WriteString( "AudioEditor", NULL );
        Registry->WriteString( "Gfx2DEditor", NULL );
        Registry->WriteString( "Gfx3DEditor", NULL );
        Registry->WriteString( "MovieEditor", NULL );
        Registry->WriteString( "CDBurner", NULL );

        Registry->CloseKey();

        //	Write the editor tabsheet
        Registry->OpenKey( ENV_OPTIONS_EDITOR, true );

        Registry->WriteBool( "AutoIndentMode", true );
        Registry->WriteBool( "InsertMode", true );
        Registry->WriteBool( "UseTabCharacter", true );
        Registry->WriteBool( "SmartTab", false );
        Registry->WriteBool( "OptimalFill", true );
        Registry->WriteBool( "BackspaceUnindents", true );
        Registry->WriteBool( "CursorThroughTabs", true );
        Registry->WriteBool( "GroupUndo", true );
        Registry->WriteBool( "CursorBeyondEOF", true );
        Registry->WriteBool( "UndoAfterSave", false );
        Registry->WriteBool( "KeepTrailingBlanks", false );
        Registry->WriteBool( "PersistentBlocks", true );
        Registry->WriteBool( "OverwriteBlocks", true );
        Registry->WriteBool( "DoubleClickLine", true );
        Registry->WriteBool( "FindTextAtCursor", true );
        Registry->WriteBool( "ForceCutCopyEnabled", true );
        Registry->WriteBool( "UseSyntaxHighlighting", true );

        Registry->CloseKey();

        //	Write the display tabsheet
        Registry->OpenKey( ENV_OPTIONS_DISPLAY, true );

        Registry->WriteBool( "BRIEFCursorShapes", true );
        Registry->WriteBool( "CreateBackupFiles", false );
        Registry->WriteBool( "PreserveLineFeeds", true );
        Registry->WriteBool( "ZoomToFullScreen", false );
        Registry->WriteBool( "VisibleRightMargin", true );
        Registry->WriteBool( "VisibleGutter", true );
        Registry->WriteInteger( "RightMargin", 80 );
        Registry->WriteInteger( "GutterWidth", 30 );
        Registry->WriteInteger( "FontSize", 12 );
        Registry->WriteString( "FontFace", "Tahoma" );

        Registry->CloseKey();

        //      Colours
        Registry->OpenKey( ENV_OPTIONS_ELEMENTS, true );

        Registry->WriteString( "DefaultStyle", "Default" );

        Registry->WriteInteger( "NumStyles", 3 );
        Registry->WriteInteger( "NumElements", 22 );

        Registry->CloseKey();

        //      Create the editor style now
        for ( int i=0; i<EnviromentOptionsForm->ComboBox3->Items->Count; i++ ) {
		AnsiString asKeyName = AnsiString( ENV_OPTIONS_ELEMENTS + "\\" + EnviromentOptionsForm->ComboBox3->Items->Strings[ i ] );

		//      Create the style key
		Registry->OpenKey( asKeyName, true );
		Registry->CloseKey();

		//      Now create the elements
		for ( int j=0; j<EnviromentOptionsForm->ListView4->Items->Count; j++ ) {

                        asKeyName += AnsiString( "\\" + EnviromentOptionsForm->ListView4->Items->Item[ j ]->Caption );

			Registry->OpenKey( asKeyName, true );

			asKeyName = NULL;

                        //      Write the element structure to the registry
                        Registry->WriteBool( "ForeDefault", false );
                        Registry->WriteBool( "BackDefault", false );
                        Registry->WriteBool( "Bold", false );
                        Registry->WriteBool( "Italic", false );
                        Registry->WriteBool( "Underline", false );

                        Registry->WriteInteger( "ForeGround", clBlack );
                        Registry->WriteInteger( "BackGround", clWhite );

                        Registry->CloseKey();

                        asKeyName = AnsiString( ENV_OPTIONS_ELEMENTS + "\\" + EnviromentOptionsForm->ComboBox3->Items->Strings[ i ] );

                }
        }

        //	palette
        Registry->OpenKey( ENV_OPTIONS_PALETTE, true );

        Registry->CloseKey();

        //	code insight
        Registry->OpenKey( ENV_OPTIONS_CODE_INSIGHT, true );

        Registry->WriteBool( "CodeCompletion", true );
        Registry->WriteBool( "CodeParameters", true );
        Registry->WriteBool( "TooltipExpressions", true );
        Registry->WriteInteger( "CodeInsightDelay", 2 );

        Registry->CloseKey();

        //	ProjectManagerForm->ActiveProject Manager
        Registry->OpenKey( PRJ_MANAGER_OPTIONS, true );

        Registry->WriteString( "CurrentProject", NULL );
        Registry->WriteString( "CurrentGroup", NULL );
        Registry->WriteString( "CurrentDir", NULL );

        Registry->CloseKey();

        //	Project Options, note does not write any specific Project options
        // to the registry, just restores the registry key tree structure

        AnsiString	asKeyName = AnsiString( PRJ_OPTIONS_DEFAULT + "\\Untitled" );

        //	Default Project Options
        Registry->OpenKey( PRJ_OPTIONS_DEFAULT, true );
        Registry->CloseKey();

        asKeyName = AnsiString( PRJ_OPTIONS_DEFAULT + "\\Untitled\\" + PRJ_OPTIONS_ADVANCED_COMPILER );

	Registry->OpenKey( asKeyName , true );	asKeyName = NULL;

        Registry->WriteInteger( "InstructionSet", -1 );
        Registry->WriteInteger( "Alignment", -1 );
        Registry->WriteInteger( "RegisterVars", -1 );
        Registry->WriteInteger( "CallingConvention", -1 );

        Registry->CloseKey();

        asKeyName = AnsiString( PRJ_OPTIONS_DEFAULT + "\\Untitled\\" + PRJ_OPTIONS_FPU );
	Registry->OpenKey( asKeyName, true );	asKeyName = NULL;

        Registry->WriteBool( "None", false );
        Registry->WriteBool( "Fast", false );
        Registry->WriteBool( "Soft", true );
        Registry->WriteBool( "Fix", false );

        Registry->CloseKey();

        asKeyName = AnsiString( PRJ_OPTIONS_DEFAULT + "\\Untitled\\" + PRJ_OPTIONS_ALIASES );
	Registry->OpenKey( asKeyName, true );	asKeyName = NULL;

        Registry->WriteString( "Aliases", NULL );

        Registry->CloseKey();

        asKeyName = AnsiString( PRJ_OPTIONS_DEFAULT + "\\Untitled\\" + PRJ_OPTIONS_APPLICATION );
	Registry->OpenKey( asKeyName, true );	asKeyName = NULL;

        Registry->WriteString( "Title", "Untitled" );
        Registry->WriteString( "HomeDir", "C:\\My Documents" );
        Registry->WriteString( "HelpFile", NULL );
        Registry->WriteString( "IconFile", NULL );

        Registry->WriteInteger( "PlatformId", -1 );
        Registry->WriteInteger( "Language", -1 );
        Registry->WriteInteger( "Interface", -1 );

        Registry->CloseKey();

        asKeyName = AnsiString( PRJ_OPTIONS_DEFAULT + "\\Untitled\\" + PRJ_OPTIONS_ASSEMBLER );
	Registry->OpenKey( asKeyName, true );	asKeyName = NULL;

        Registry->WriteString( "AssemblerPath", NULL );
        Registry->WriteString( "ASFlags", NULL );

        Registry->CloseKey();

        asKeyName = AnsiString( PRJ_OPTIONS_DEFAULT + "\\Untitled\\" + PRJ_OPTIONS_ATTRIBUTES );
	Registry->OpenKey( asKeyName, true );	asKeyName = NULL;

        Registry->WriteBool( "DebugAttr", false );

        Registry->WriteBool( "SpecialAttr", false );

        Registry->WriteBool( "PreReleaseAttr", false );

        Registry->WriteBool( "PrivateAttr", false );

        Registry->WriteBool( "DLLAttr", false );

        Registry->WriteBool( "GPLAttr", true );

        Registry->CloseKey();

        asKeyName = AnsiString( PRJ_OPTIONS_DEFAULT + "\\Untitled\\" + PRJ_OPTIONS_COMPILER );
	Registry->OpenKey( asKeyName, true );	asKeyName = NULL;

        Registry->WriteInteger( "OptimisationLevel", -1 );
        Registry->WriteInteger( "WarningsLevel", -1 );

        Registry->WriteBool( "DebugMode", false );
        Registry->WriteBool( "LineNumbering", false );
        Registry->WriteBool( "InlineExpansion", false );

        Registry->WriteString( "MakePath", NULL );
        Registry->WriteString( "MakeFileName", "MakeFile" );
        Registry->WriteInteger( "DefaultTarget", -1 );

        Registry->CloseKey();

        asKeyName = AnsiString( PRJ_OPTIONS_DEFAULT + "\\Untitled\\" + PRJ_OPTIONS_CONDITIONALS );
	Registry->OpenKey( asKeyName, true );	asKeyName = NULL;

        Registry->WriteString( "Conditions", NULL );

        Registry->CloseKey();

        asKeyName = AnsiString( PRJ_OPTIONS_DEFAULT + "\\Untitled\\" + PRJ_OPTIONS_CPP );
	Registry->OpenKey( asKeyName, true );	asKeyName = NULL;

        Registry->WriteString( "CompilerPath", NULL );
        Registry->WriteString( "CFlags", NULL );

        Registry->CloseKey();

        asKeyName = AnsiString( PRJ_OPTIONS_DEFAULT + "\\Untitled\\" + PRJ_OPTIONS_GDB );
	Registry->OpenKey( asKeyName, true );	asKeyName = NULL;

        Registry->WriteString( "DebugPath", NULL );
        Registry->WriteInteger( "DebugMode", -1 );
        Registry->WriteInteger( "DebugType", -1 );
        Registry->WriteString( "GDBFlags", NULL );

        Registry->CloseKey();

        asKeyName = AnsiString( PRJ_OPTIONS_DEFAULT + "\\Untitled\\" + PRJ_OPTIONS_DIRECTORIES );
	Registry->OpenKey( asKeyName, true );	asKeyName = NULL;

        Registry->WriteString( "IncludePath", NULL );
        Registry->WriteString( "LibraryPath", NULL );
        Registry->WriteString( "DebugPath", NULL );
        Registry->WriteBool( "TempPipes", true );
        Registry->WriteString( "TempPath", "C:\\Windows\\Temp" );
        Registry->WriteString( "FinalPath", NULL );
        Registry->WriteString( "LibOutPath", NULL );

        Registry->CloseKey();

        asKeyName = AnsiString( PRJ_OPTIONS_KEYS + "\\Untitled\\" + PRJ_OPTIONS_KEYS );
	Registry->OpenKey( asKeyName, true );	asKeyName = NULL;
        Registry->WriteInteger( "NumKeys", -1 );
        Registry->CloseKey();

        
	Registry->OpenKey( PRJ_OPTIONS_LD, true );
        Registry->CloseKey();
	Registry->OpenKey( PRJ_OPTIONS_MAKE, true );
        Registry->CloseKey();
	Registry->OpenKey( PRJ_OPTIONS_OUTPUT_SETTINGS, true );
        Registry->CloseKey();
	Registry->OpenKey( PRJ_OPTIONS_PACKAGES, true );
        Registry->CloseKey();
	Registry->OpenKey( PRJ_OPTIONS_DESIGN_TIME_PACKAGES, true );
        Registry->CloseKey();
	Registry->OpenKey( PRJ_OPTIONS_PLUGIN_PACKAGES, true );
        Registry->CloseKey();
	Registry->OpenKey( PRJ_OPTIONS_RUN_TIME_PACKAGES, true );
        Registry->CloseKey();
	Registry->OpenKey( PRJ_OPTIONS_VERSION_INFORMATION, true );
        Registry->CloseKey();
	Registry->OpenKey( PRJ_OPTIONS_WARNING, true );
        Registry->CloseKey();

        //	Packages and tools
        Registry->OpenKey( PSXIDE_PACKAGES, true );
        Registry->CloseKey();

        Registry->OpenKey( PSXIDE_TOOLS, true );
	Registry->CloseKey();

	//	Debugging options
}
//----------------------------------------------------------------------------
//	Execute 'Doxygen' if installed
//----------------------------------------------------------------------------
void 	__fastcall 	TMainForm :: ToolsDoxygenExecute( TObject *Sender )
{	HINSTANCE	hInstance = NULL;
	AnsiString	asFileName = NULL;

        if ( Sender == NULL )
        	return;

        ClearSysMessages();

        SystemMessage( "Attempting to execute external tool 'Doxygen'" );

        asFileName = AnsiString( DOXYGEN_INSTALL_DIR + "\\bin\\doxywizard.exe" );

        if ( !FileExists( asFileName ) )	{
        	//	Not found
                SystemMessage( "'Doxygen' not installed, aborting." );
                return;
        }

        SystemMessage( "Executing 'Doxygen'" );

        hInstance = ShellExecute( Handle, "open", asFileName.c_str(), NULL, NULL, SW_SHOWNORMAL );

        if ( hInstance == NULL ) {
        	SystemMessage( "Unable to execute " + asFileName );
                return;
        }
        SystemMessage( "'Doxygen' is executing" );
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ViewClassExplorerExecute(TObject *Sender)
{
	//	View the class explorer
        ClassExplorerForm->ShowModal();

        if ( ProjectManagerForm->ActiveProject ) {

        	SystemMessage( "Activating Class Explorer view for current module" );
        	ClassExplorerForm->TreeView1->Items->Clear();

                //ClassExplorerForm->DecodeModule( ProjectManagerForm->lpGroup->lpProjects[
                //	ProjectManagerForm->CurrProject ].lpModules[ ProjectManagerForm->CurrModule ].Name );
        }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SearchGotoLineNumberExecute(TObject *Sender)
{
	//	Goes to the specified line
        SystemMessage( "goto line number." );
}
//---------------------------------------------------------------------------
