//----------------------------------------------------------------------------
//
//	$FileName	::	Main.h
//	$Author		::	Chris Brooklyn
//	$Description	::	Header File for the MainForm of PSX IDE
//	$Version	::	0.1.0.120
//
//----------------------------------------------------------------------------
#ifndef MainH
#define MainH
//----------------------------------------------------------------------------
#include "ChildWin.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Messages.hpp>
#include <Buttons.hpp>
#include <Dialogs.hpp>
#include <StdCtrls.hpp>
#include <Menus.hpp>
#include <Controls.hpp>
#include <Forms.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <windows.h>
#include <System.hpp>
#include <ActnList.hpp>
#include <ImgList.hpp>
#include <StdActns.hpp>
#include <ToolWin.hpp>
#include <Registry.hpp>
//----------------------------------------------------------------------------
#include "Defines.h"
#include "RegEntries.h"
#include "winbase.h"
//----------------------------------------------------------------------------
class TMainForm : public TForm
{	friend	class	TProjectManagerForm;
	friend	class	TProjectOptionsForm;
        friend	class	TEnviromentOptionsForm;
        friend	class	TDebugOptionsForm;
        friend	class	TPackagesForm;
	protected:
__published:
	TMainMenu *MainMenu1;
	TMenuItem *File1;
	TMenuItem *FileNewItem;
	TMenuItem *FileOpenItem;
	TMenuItem *Window1;
	TMenuItem *Help1;
	TMenuItem *N1;
	TMenuItem *FileExitItem;
	TMenuItem *WindowCascadeItem;
	TMenuItem *WindowTileItem;
	TMenuItem *WindowArrangeItem;
	TMenuItem *HelpAboutItem;
	TOpenDialog *OpenDialog;
	TMenuItem *FileSaveItem;
	TMenuItem *FileSaveAsItem;
	TMenuItem *Edit1;
	TMenuItem *CutItem;
	TMenuItem *CopyItem;
	TMenuItem *PasteItem;
	TMenuItem *WindowMinimizeItem;
        TActionList *IDEActionList;
        TEditCut *EditCut1;
        TEditCopy *EditCopy1;
        TEditPaste *EditPaste1;
	TAction *FileNewFile;
        TAction *FileSave1;
        TAction *FileExit1;
        TAction *FileOpen1;
        TAction *FileSaveAs1;
        TWindowCascade *WindowCascade1;
        TWindowTileHorizontal *WindowTileHorizontal1;
        TWindowArrange *WindowArrangeAll1;
        TWindowMinimizeAll *WindowMinimizeAll1;
        TAction *HelpAbout1;
        TWindowClose *FileClose1;
        TWindowTileVertical *WindowTileVertical1;
        TMenuItem *WindowTileItem2;
        TToolBar *ToolBar2;
        TToolButton *ToolButton1;
        TToolButton *ToolButton2;
        TToolButton *ToolButton3;
        TToolButton *ToolButton4;
        TToolButton *ToolButton5;
        TToolButton *ToolButton6;
        TToolButton *ToolButton7;
        TToolButton *ToolButton8;
        TToolButton *ToolButton9;
        TToolButton *ToolButton10;
        TToolButton *ToolButton11;
        TImageList *IDEImageList;
        TSaveDialog *SaveDialog;
        TPrintDialog *PrintDialog;
        TPrinterSetupDialog *PrinterSetupDialog;
        TFindDialog *FindDialog;
        TReplaceDialog *ReplaceDialog;
        TAction *SearchFind;
        TAction *ProjectAddToProject;
        TAction *RunRun;
        TAction *ViewProjectManager;
        TAction *FileNewApplication;
        TAction *FileNewUnit;
        TAction *FileOpenProject;
        TAction *FileSaveProjectAs;
        TAction *FileSaveAll;
        TAction *FileCloseAll;
        TAction *FilePrint;
        TMenuItem *Close1;
        TMenuItem *NewApplication1;
        TMenuItem *FileNewUnit1;
        TMenuItem *OpenProject1;
        TMenuItem *SaveAll1;
        TMenuItem *SaveAll2;
        TMenuItem *CloseAll1;
        TMenuItem *Print1;
        TMenuItem *N2;
        TMenuItem *N3;
        TMenuItem *N4;
        TMenuItem *N5;
        TAction *SearchFindInFiles;
        TAction *SearchReplace;
        TAction *SearchSearchAgain;
        TAction *SearchIncrementalSearch;
        TAction *SearchGotoLineNumber;
        TMenuItem *Tools1;
        TMenuItem *Search1;
        TMenuItem *View1;
        TMenuItem *Project1;
        TAction *ToolsEnviromentOptions;
        TMenuItem *Find1;
        TMenuItem *FindInFiles1;
        TMenuItem *Replace1;
        TMenuItem *SearchAgain1;
        TMenuItem *IncrementalSearch1;
        TMenuItem *N6;
        TMenuItem *GotoLineNumber1;
        TAction *ToolsDebuggerOptions;
        TAction *ToolsRepository;
        TAction *ToolsConfigure;
        TMenuItem *EnviromentOptions1;
        TMenuItem *DebuggerOptions1;
        TMenuItem *Repository1;
        TMenuItem *ConfigureTools1;
        TAction *EditUndo;
        TAction *EditRedo;
        TAction *EditSelectAll;
        TMenuItem *N7;
        TMenuItem *SelectAll1;
        TMenuItem *Undo1;
        TMenuItem *Redo1;
        TAction *ViewWindowList;
        TMenuItem *ProjectManager1;
        TMenuItem *WindowList1;
        TAction *ProjectRemoveFromProject;
        TAction *ProjectViewSource;
        TAction *ProjectViewMakeFile;
        TAction *ProjectCompileUnit;
        TAction *ProjectMakeProject;
        TAction *ProjectBuildProject;
        TAction *ProjectInformation;
        TAction *ProjectMakeAll;
        TAction *ProjectBuildAll;
        TAction *ProjectOptions;
        TMenuItem *AddToProject1;
        TMenuItem *RemoveFromProject1;
        TMenuItem *ViewSource1;
        TMenuItem *ViewMakeFile1;
        TMenuItem *MakeProject1;
        TMenuItem *BuildProject1;
        TMenuItem *InformationforProject1;
        TMenuItem *MakeAll1;
        TMenuItem *BuildAll1;
        TMenuItem *Options1;
        TMenuItem *N8;
        TMenuItem *CompileUnit1;
        TMenuItem *N9;
        TMenuItem *N10;
        TMenuItem *Run1;
        TAction *RunParameters;
        TAction *RunStepOver;
        TAction *RunTraceInto;
        TAction *RunPause;
        TAction *RunReset;
        TMenuItem *Run2;
        TMenuItem *Parameters1;
        TMenuItem *StepOver1;
        TMenuItem *TraceInto1;
        TMenuItem *ProgramPause1;
        TMenuItem *ProgramReset1;
        TMenuItem *N11;
        TAction *HelpContents;
        TAction *HelpIndex;
        TAction *HelpProjectHomePage;
        TMenuItem *Contents1;
        TMenuItem *Index1;
        TMenuItem *N12;
        TMenuItem *ProjectHomePage1;
        TMenuItem *N13;
	TAction *FileNew;
	TMenuItem *FileNew1;
	TToolButton *ToolButton12;
	TToolButton *ToolButton13;
	TToolButton *ToolButton14;
	TToolButton *ToolButton15;
	TToolButton *ToolButton16;
	TToolButton *ToolButton17;
	TToolButton *ToolButton18;
	TToolButton *ToolButton19;
	TToolButton *ToolButton20;
	TToolButton *ToolButton21;
	TToolButton *ToolButton22;
	TToolButton *ToolButton23;
	TToolButton *ToolButton24;
	TMenuItem *N14;
	TMenuItem *Communications1;
	TMenuItem *Download1;
	TAction *ToolsCommSetup;
	TMenuItem *PackageManagement1;
	TMenuItem *LaunchPackageManagementTool1;
	TAction *ToolsPackageManager;
	TStatusBar *StatusBar1;
	TTimer *Timer1;
	TMenuItem *Emulator1;
	TAction *ToolsEmulatorExecute;
	TAction *ToolsClassWizard;
	TMenuItem *ClassWizard1;
	TAction *ToolsShell;
	TMenuItem *ToolsShell1;
	TMenuItem *Configure1;
	TMenuItem *Transfer1;
	TMenuItem *Execute1;
	TAction *ToolsEmulatorTransfer;
	TAction *ToolsEmulatorConfigure;
	TPanel *Panel1;
	TRichEdit *RichEdit1;
	TMenuItem *N16;
	TMenuItem *Audio1;
	TMenuItem *Graphics1;
	TMenuItem *N2D1;
	TMenuItem *N3D1;
	TMenuItem *Movies1;
	TAction *ToolsAudio;
	TAction *ToolsGfx2D;
	TAction *ToolsGfx3D;
	TAction *ToolsGfxMovie;
	TMenuItem *ToolsAudioEditor;
	TAction *ToolsCDBurner;
        TMenuItem *CDAuthoring1;
        TMenuItem *CDBurner1;
	TAction *FileOpenProjectGroup;
	TMenuItem *RepairRegistry1;
	TAction *ProjectGroupSave;
	TMenuItem *Doxygen1;
	TAction *ToolsDoxygen;
	TAction *ViewClassExplorer;
	TMenuItem *ClassExplorer1;
        void __fastcall FileNewFileExecute(TObject *Sender);
        void __fastcall FileOpen1Execute(TObject *Sender);
        void __fastcall HelpAbout1Execute(TObject *Sender);
        void __fastcall ProjectOptionsExecute(TObject *Sender);
        void __fastcall ViewProjectManagerExecute(TObject *Sender);
        void __fastcall ToolsEnviromentOptionsExecute(TObject *Sender);
        void __fastcall ToolsConfigureExecute(TObject *Sender);
        void __fastcall ToolsDebuggerOptionsExecute(TObject *Sender);
	void __fastcall FileClose1Execute(TObject *Sender);
	void __fastcall FileCloseAllExecute(TObject *Sender);
	void __fastcall EditUndoExecute(TObject *Sender);
	void __fastcall EditSelectAllExecute(TObject *Sender);
	void __fastcall Timer1Timer(TObject *Sender);
	void __fastcall FileExit1Execute(TObject *Sender);
	void __fastcall FileNewExecute(TObject *Sender);
	void __fastcall FileNewApplicationExecute(TObject *Sender);
	void __fastcall IDEGenerateConsoleExecute(TObject *Sender);
	void __fastcall ProjectCompileUnitExecute(TObject *Sender);
	void __fastcall ProjectMakeProjectExecute(TObject *Sender);
	void __fastcall ProjectBuildProjectExecute(TObject *Sender);
	void __fastcall ProjectViewSourceExecute(TObject *Sender);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall FileSaveProjectAsExecute(TObject *Sender);
	void __fastcall FileOpenProjectExecute(TObject *Sender);
	void __fastcall FileNewUnitExecute(TObject *Sender);
	void __fastcall FileSaveAllExecute(TObject *Sender);
	void __fastcall FileSave1Execute(TObject *Sender);
	void __fastcall FileSaveAs1Execute(TObject *Sender);
	void __fastcall HelpProjectHomePageExecute(TObject *Sender);
	void __fastcall HelpIndexExecute(TObject *Sender);
	void __fastcall FilePrintExecute(TObject *Sender);
	void __fastcall ProjectAddToProjectExecute(TObject *Sender);
	void __fastcall ProjectRemoveFromProjectExecute(TObject *Sender);
	void __fastcall NewApplication1Click(TObject *Sender);
	void __fastcall ToolsShellExecute(TObject *Sender);
	void __fastcall EditRedoExecute(TObject *Sender);
	void __fastcall EditCut1Execute(TObject *Sender);
	void __fastcall EditCopy1Execute(TObject *Sender);
	void __fastcall EditPaste1Execute(TObject *Sender);
	void __fastcall HelpContentsExecute(TObject *Sender);
	void __fastcall ProjectViewMakeFileExecute(TObject *Sender);
	void __fastcall ProjectInformationExecute(TObject *Sender);
	void __fastcall ProjectMakeAllExecute(TObject *Sender);
	void __fastcall ProjectBuildAllExecute(TObject *Sender);
	void __fastcall RunRunExecute(TObject *Sender);
	void __fastcall RunParametersExecute(TObject *Sender);
	void __fastcall RunStepOverExecute(TObject *Sender);
	void __fastcall RunTraceIntoExecute(TObject *Sender);
	void __fastcall RunPauseExecute(TObject *Sender);
	void __fastcall RunResetExecute(TObject *Sender);
	void __fastcall ToolsCommSetupExecute(TObject *Sender);
	void __fastcall LaunchPackageManagementTool1Click(TObject *Sender);
	void __fastcall ToolsEmulatorConfigureExecute(TObject *Sender);
	void __fastcall ToolsEmulatorExecuteExecute(TObject *Sender);
	void __fastcall ToolsEmulatorTransferExecute(TObject *Sender);
	void __fastcall OpenDialogShow(TObject *Sender);
	void __fastcall ViewWindowListExecute(TObject *Sender);
	void __fastcall ToolsRepositoryExecute(TObject *Sender);
	void __fastcall ToolsAudioExecute(TObject *Sender);
	void __fastcall ToolsGfx2DExecute(TObject *Sender);
	void __fastcall ToolsGfx3DExecute(TObject *Sender);
	void __fastcall ToolsGfxMovieExecute(TObject *Sender);
	void __fastcall ToolsCDBurnerExecute(TObject *Sender);
        void __fastcall ToolsPackageManagerExecute(TObject *Sender);
        void __fastcall ToolsClassWizardExecute(TObject *Sender);
	void __fastcall FileOpenProjectGroupExecute(TObject *Sender);
	void __fastcall SearchFindExecute(TObject *Sender);
	void __fastcall SearchFindInFilesExecute(TObject *Sender);
	void __fastcall SearchReplaceExecute(TObject *Sender);
	void __fastcall RepairRegistry1Click(TObject *Sender);
	void __fastcall ToolsDoxygenExecute(TObject *Sender);
	void __fastcall ViewClassExplorerExecute(TObject *Sender);
	void __fastcall SearchGotoLineNumberExecute(TObject *Sender);
protected:
private:
	TRegistry	*Registry;

        BYTE		vKeyStates[ 256 ];	//	This holds the virtual key codes

        bool		bNumLock;

        AnsiString      asRunParams;

        HINSTANCE	hCompilerHandle;
        HINSTANCE	hDebuggerHandle;
        HINSTANCE	hEmulatorHandle;

public:
	virtual __fastcall 	TMainForm            	( TComponent *Owner );
        void    __fastcall 	CreateMDIChild       	( const String Name );
__published:
	__property	bool	NumLock	= { read=bNumLock, write=bNumLock, stored=true, default=true };
};
//----------------------------------------------------------------------------
__declspec( dllimport )	TMainForm	*MainForm;
//----------------------------------------------------------------------------
__declspec( dllimport )	TMDIChild* 	__fastcall	MDIChildCreate	( void );
__declspec( dllimport )	void		__fastcall	GenerateMain	( TSynEdit *RichEdit );	//	Template Generation Code, FIXED
__declspec( dllimport )	void		__fastcall	GenerateWinMain	( TSynEdit *RichEdit );	//	Template Generation Code, FIXED
__declspec( dllimport )	void		__fastcall	GenerateWinDLL	( TSynEdit *RichEdit );	//	Template Generation Code, FIXED
__declspec( dllimport )	void		__fastcall	GenerateOpenGL	( TSynEdit *RichEdit ); //	Template Generation Code, FIXED
//----------------------------------------------------------------------------
__declspec( dllimport )	void	__fastcall	RepairRegistry( void );		//	Restores the system registry to a known state
//----------------------------------------------------------------------------
#include "lib\Emulator\EmulatorDLL.h"						//	Include Support for Emulator
#include "lib\Debugger\DebuggerDLL.h"						//	Include support for Debugger
//----------------------------------------------------------------------------
#endif
//---------------------------------------------------------------------------

