//---------------------------------------------------------------------------
//
//	$FileName	::	NewProjectUnit.cpp
//	$Author		::	Chris Brooklyn
//	$Description	::	Provides a 'simple' way of create new projects
//
//---------------------------------------------------------------------------
#include <vcl.h>
//---------------------------------------------------------------------------
#pragma hdrstop
//---------------------------------------------------------------------------
#include "NewProjectUnit.h"
#include "Main.h"
#include "Utilities.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
//---------------------------------------------------------------------------
TNewProjectForm *NewProjectForm;
//---------------------------------------------------------------------------
__fastcall TNewProjectForm::TNewProjectForm(TComponent* Owner)
	: TForm(Owner)
{
	dwProjectType = PROJECT_TYPE_UNSELECTED;
}
//---------------------------------------------------------------------------
void __fastcall TNewProjectForm::BitBtn2Click(TObject *Sender)
{
	ModalResult = mrIgnore;		//	Tell anything that relies on the ModalResult to ignore the settings
}
//---------------------------------------------------------------------------
void __fastcall TNewProjectForm::ViewAsLargeIcons1Click(TObject *Sender)
{
	ViewAsLargeIcons1->Checked = true;
        if ( PageControl1->ActivePage == TabSheet1 ) {	// NEW
        	ListView1->ViewStyle = vsIcon;
        	return;
        }

        if ( PageControl1->ActivePage == TabSheet2 ) {	// FORMS
        	ListView2->ViewStyle = vsIcon;
                return;
        }

        if ( PageControl1->ActivePage == TabSheet3 ) {	// DIALOGS
        	ListView3->ViewStyle = vsIcon;
                return;
        }

        if ( PageControl1->ActivePage == TabSheet4 ) {	// PROJECTS
        	ListView4->ViewStyle = vsIcon;
                return;
        }
}
//---------------------------------------------------------------------------
void __fastcall TNewProjectForm::ViewAsSmallIcons1Click(TObject *Sender)
{
	ViewAsLargeIcons1->Checked = true;
        if ( PageControl1->ActivePage == TabSheet1 ) {	// NEW
        	ListView1->ViewStyle = vsSmallIcon;
        	return;
        }

        if ( PageControl1->ActivePage == TabSheet2 ) {	// FORMS
        	ListView2->ViewStyle = vsSmallIcon;
                return;
        }

        if ( PageControl1->ActivePage == TabSheet3 ) {	// DIALOGS
        	ListView3->ViewStyle = vsSmallIcon;
                return;
        }

        if ( PageControl1->ActivePage == TabSheet4 ) {	// PROJECTS
        	ListView4->ViewStyle = vsSmallIcon;
                return;
        }
}
//---------------------------------------------------------------------------
void __fastcall TNewProjectForm::ViewAsList1Click(TObject *Sender)
{
	ViewAsList1->Checked = true;
        if ( PageControl1->ActivePage == TabSheet1 ) {	// NEW
        	ListView1->ViewStyle = vsList;
        	return;
        }

        if ( PageControl1->ActivePage == TabSheet2 ) {	// FORMS
        	ListView2->ViewStyle = vsList;
                return;
        }

        if ( PageControl1->ActivePage == TabSheet3 ) {	// DIALOGS
        	ListView3->ViewStyle = vsList;
                return;
        }

        if ( PageControl1->ActivePage == TabSheet4 ) {	// PROJECTS
        	ListView4->ViewStyle = vsList;
                return;
        }
}
//---------------------------------------------------------------------------
void __fastcall TNewProjectForm::ViewDetails1Click(TObject *Sender)
{
	ViewDetails1->Checked = true;
        if ( PageControl1->ActivePage == TabSheet1 ) {	// NEW
        	ListView1->ViewStyle = vsReport;
        	return;
        }

        if ( PageControl1->ActivePage == TabSheet2 ) {	// FORMS
        	ListView2->ViewStyle = vsReport;
                return;
        }

        if ( PageControl1->ActivePage == TabSheet3 ) {	// DIALOGS
        	ListView3->ViewStyle = vsReport;
                return;
        }

        if ( PageControl1->ActivePage == TabSheet4 ) {	// PROJECTS
        	ListView4->ViewStyle = vsReport;
                return;
        }
}
//---------------------------------------------------------------------------
void __fastcall TNewProjectForm::BitBtn1Click(TObject *Sender)
{
        if ( PageControl1->ActivePage == TabSheet1 ) {	//	'New' Tab Sheet
        	if ( !ListView1->Selected ) return;
                switch ( ListView1->Selected->Index ) {
                	case ( 0 ) : {			//	'Application' is selected
                        	dwProjectType = PROJECT_TYPE_APPLICATION;
                                break;
                        }

                        case ( 1 ) : {			//	'Batch File'
                        	dwProjectType = PROJECT_TYPE_BATCH_FILE;
                                break;
                        }

                        case ( 2 ) : {			//	'Component'
                        	dwProjectType = PROJECT_TYPE_COMPONENT;
                                break;
                        }

                        case ( 3 ) : {			//	'Console'
                        	dwProjectType = PROJECT_TYPE_CONSOLE;
                                break;
                        }

                        case ( 4 ) : {			//	'Data Module;
				dwProjectType = PROJECT_TYPE_DATA_MODULE;
                                break;
                        }

                        case ( 5 ) : {			//	'DLL'
				dwProjectType = PROJECT_TYPE_WINDLL;
                                break;
                        }

                        case ( 6 ) : {			//	'Form'
				dwProjectType = PROJECT_TYPE_FORM;
                                break;
                        }

                        case ( 7 ) : {			//	'Library'
				dwProjectType = PROJECT_TYPE_LIBRARY;
                                break;
                        }

                        case ( 8 ) : {			//	'Package'
				dwProjectType = PROJECT_TYPE_PACKAGE;
                                break;
                        }

                        case ( 9 ) : {			//	'Project Group'
				dwProjectType = PROJECT_TYPE_PROJECT_GROUP;
                                break;
                        }

                        case ( 10 ) : {			//	'Text File'
				dwProjectType = PROJECT_TYPE_TEXT;
                                break;
                        }

                        case ( 11 ) : {			//	'Thread Object'
				dwProjectType = PROJECT_TYPE_THREAD;
                                break;
                        }

                        case ( 12 ) : {			//	'Unit;
				dwProjectType = PROJECT_TYPE_UNIT;
                                break;
                        }
                        default	:	{
                        	dwProjectType = PROJECT_TYPE_DEFAULT;
                                break;
                        }
                }
        }

        if ( PageControl1->ActivePage == TabSheet2 ) {
        	if ( !ListView2->Selected ) return;
                switch ( ListView2->Selected->Index ) {
                	case ( 0 ) : {			//	'About Box'
                        	dwProjectType = PROJECT_TYPE_FORM_ABOUT_BOX;
                                break;
                        }
                }
        }

        if ( PageControl1->ActivePage == TabSheet3 ) {	//	Nothing on this page yet
        	if ( !ListView3->Selected ) return;
        }

        if ( PageControl1->ActivePage == TabSheet4 ) {
        	if ( !ListView4->Selected ) return;
                switch ( ListView4->Selected->Index ) {
                	case ( 0 ) : {			//	'MDI Application'
                        	dwProjectType = PROJECT_TYPE_MDI_APPLICATION;
                                break;
                        }

                        case ( 1 ) : {			//	'SDI Application'
				dwProjectType = PROJECT_TYPE_SDI_APPLICATION;
                                break;
                        }

                        case ( 2 ) : {			//	'Logo Application' ?
				dwProjectType = PROJECT_TYPE_LOGO_APPLICATION;
                                break;
                        }

                        case ( 3 ) : {			//	'Splash Application'
				dwProjectType = PROJECT_TYPE_SPLASH_APPLICATION;
                                break;
                        }
                }
        }

        if ( ProjectType != 0xFFFF ) ModalResult = mrOk;
        else ModalResult = mrIgnore;
}
//---------------------------------------------------------------------------
void __fastcall TNewProjectForm::FormCreate(TObject *Sender)
{
	dwProjectType = PROJECT_TYPE_UNSELECTED;
}
//---------------------------------------------------------------------------
