//---------------------------------------------------------------------------
#ifndef PackageUnitH
#define PackageUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <System.hpp>
#include <SysUtils.hpp>
#include <Registry.hpp>
#include <Windows.hpp>
//---------------------------------------------------------------------------
class	TPackage;
//---------------------------------------------------------------------------
typedef	void	__fastcall	( __closure *TPackageEvent)(TPackage *Package, int eCode );
//---------------------------------------------------------------------------
//	Package Types
//---------------------------------------------------------------------------
#define PACKAGE_DESIGNER	0x0001
#define PACKAGE_RUNTIME		0x0002
#define PACKAGE_PLUGIN		0x0004
#define PACKAGE_DESIGN_RUNTIME	( PACKAGE_DESIGNER | PACKAGE_RUNTIME )
#define PACKAGE_DEFAULT		( PACKAGE_DESIGN_RUNTIME )
//---------------------------------------------------------------------------
class	TPackage : public TObject
	{	friend	class	TPackagesForm;
        	protected:
                
                private:
                	//	Owner of this package, usually MainForm or the main application
                	TObject		*pOwner;		//	Either set to this or Owner passed at constructor

                        //	Name and description of package
                        AnsiString	asPackageName;	//	Package Name
                        AnsiString	asPackageDescription;	//	duh!
                        AnsiString	asPackageFile;

                        //	Windows handle to library
                        HINSTANCE	hInstance;	//	Package instance, used to access the internal methods of dll

                        //	Windows Resource handles
                        HRSRC		hrcName;	//	Resource Handle for package name
                        HRSRC		hrcDescription;	//	Description
                        HRSRC		hrcVersion;	//	Version

                        //	Package type
                        DWORD		dwPackageType;	//	Package Type

                        //	Events
                        TPackageEvent	FOnLeftClick;
                        TPackageEvent	FOnRightClick;
                        TPackageEvent	FOnEdit;

			AnsiString	asFileName;
		public:
				__fastcall	TPackage	( void ) { };
				__fastcall	TPackage	( TObject *Owner );
				__fastcall	TPackage	( AnsiString FileName );
				__fastcall	~TPackage	( void );

			int	__fastcall	LoadFromFile		( AnsiString FileName );
                        int	__fastcall	LoadFromRegistry	( AnsiString PackageName );
                        int	__fastcall	SaveToRegistry		( void );	
		__published:
			__property	AnsiString	PackageName	=	{ read=asPackageName, 	write=asPackageName, 	stored=true };
			__property	AnsiString	PackageFile	=	{ read=asFileName,	write=asFileName,	stored=true };
			__property	AnsiString	Description	=	{ read=asPackageDescription, write=asPackageDescription, stored=true };
			__property	DWORD		PackageType	=	{ read=dwPackageType,	write=dwPackageType,	stored=true };
		protected:
			__property	TPackageEvent	OnLeftClick	=	{ read=FOnLeftClick, write=FOnLeftClick, stored=true };
			__property	TPackageEvent	OnRightClick	=	{ read=FOnRightClick, write=FOnRightClick, stored=true };
			__property	TPackageEvent	OnEdit		=	{ read=FOnEdit, write=FOnEdit, stored=true };
	};
//---------------------------------------------------------------------------
#endif
//---------------------------------------------------------------------------
