//---------------------------------------------------------------------------
//
//      $FileName       ::      ProjectOptionsForm.h
//      $Author         ::      Chris Brroklyn
//      $Description    ::      Header file for Project Options Form Class
//      $Version        ::      0.1.0.0
//
//---------------------------------------------------------------------------
#ifndef ProjectOptionsFormUnitH
#define ProjectOptionsFormUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include <ActnList.hpp>
#include <Registry.hpp>
//---------------------------------------------------------------------------
#include "Defines.h"
#include "RegEntries.h"
//----------------------------------------------------------------------------
class TProjectOptionsForm : public TForm
{       friend  class   TMainForm;                      // 	Allows the ide's mainform itself to modify the options directly
        friend  class   TProjectManagerForm;            // 	Allows the project manager to modify the options directly
        protected:
        	int	__fastcall	SaveToRegistry		( TObject *Sender );

                int	__fastcall	LoadFromRegistry	( TObject *Sender );

                void    __fastcall      ConfigureForPlatform            ( int PlatFormType );
                void    __fastcall      ConfigureForDefault             ( TObject *Sender );
                void    __fastcall      ConfigureForPlayStation         ( TObject *Sender );
                void    __fastcall      ConfigureForPlayStation2        ( TObject *Sender );
                void    __fastcall      ConfigureForNintendo64          ( TObject *Sender );
                void    __fastcall      ConfigureForPlayStation2Linux   ( TObject *Sender );
                void    __fastcall      ConfigureForPCLinux             ( TObject *Sender );
                void    __fastcall      ConfigureForPCWindows           ( TObject *Sender );
__published:	// IDE-managed Components
        TPanel *Panel1;
        TBitBtn *OKButton;
        TBitBtn *CancelButton;
        TBitBtn *HelpButton;
        TPageControl *PageControl1;
        TTabSheet *ApplicationTab;
        TTabSheet *CompilerTab;
        TTabSheet *AdvancedCompilerTab;
        TTabSheet *CPPTab;
        TTabSheet *AssemblerTab;
        TTabSheet *LinkerTab;
        TTabSheet *DirectoriesTab;
        TTabSheet *VersionInfoTab;
        TTabSheet *PackagesTab;
        TGroupBox *GroupBox1;
        TLabel *Label1;
        TLabel *Label2;
        TLabel *Label3;
        TImage *Image1;
        TEdit *Edit1;
        TEdit *Edit2;
        TBitBtn *HelpFileBrowse;
        TBitBtn *IconBrowse;
        TGroupBox *GroupBox5;
        TCheckBox *CheckBox1;
        TCheckBox *CheckBox2;
        TCheckBox *CheckBox3;
        TGroupBox *GroupBox10;
        TCheckBox *CheckBox4;
        TCheckBox *CheckBox5;
        TCheckBox *CheckBox6;
        TGroupBox *GroupBox11;
	TBitBtn *DebugButton;
        TBitBtn *BitBtn9;
        TPanel *Panel2;
        TCheckBox *CheckBox7;
        TLabel *Label5;
        TEdit *Edit3;
        TEdit *Edit4;
        TEdit *Edit5;
        TEdit *Edit6;
        TUpDown *UpDown1;
        TUpDown *UpDown2;
        TUpDown *UpDown3;
        TUpDown *UpDown4;
        TLabel *Label6;
        TLabel *Label7;
        TLabel *Label8;
        TLabel *Label9;
        TGroupBox *GroupBox12;
        TListView *ListView1;
        TCheckBox *CheckBox8;
        TCheckBox *CheckBox9;
        TCheckBox *CheckBox10;
        TCheckBox *CheckBox11;
        TCheckBox *CheckBox12;
        TGroupBox *GroupBox13;
        TGroupBox *GroupBox14;
        TGroupBox *GroupBox15;
        TGroupBox *GroupBox16;
        TGroupBox *GroupBox17;
        TGroupBox *GroupBox18;
        TLabel *Label4;
        TLabel *Label10;
        TLabel *Label11;
        TLabel *Label12;
        TLabel *Label13;
        TLabel *Label14;
        TEdit *Edit7;
        TEdit *Edit8;
        TEdit *Edit9;
        TEdit *Edit10;
        TEdit *Edit11;
        TEdit *Edit12;
        TSpeedButton *SpeedButton1;
        TSpeedButton *SpeedButton2;
        TSpeedButton *SpeedButton3;
        TLabel *Label15;
        TEdit *Edit13;
        TLabel *Label16;
        TEdit *Edit14;
        TSpeedButton *SpeedButton4;
        TSpeedButton *SpeedButton5;
        TCheckBox *CheckBox13;
        TLabel *Label17;
        TEdit *Edit15;
        TSpeedButton *SpeedButton8;
        TLabel *Label18;
        TLabel *Label19;
        TLabel *Label20;
        TEdit *Edit16;
        TSpeedButton *SpeedButton7;
        TLabel *Label21;
        TLabel *Label22;
        TEdit *Edit17;
        TSpeedButton *SpeedButton6;
        TRadioGroup *RadioGroup1;
        TListView *ListView2;
        TListView *ListView3;
        TListView *ListView4;
        TCheckBox *CheckBox14;
        TSpeedButton *SpeedButton9;
        TLabel *Label23;
        TListView *ListView5;
        TListView *ListView6;
        TListView *ListView7;
        TListView *ListView8;
        TRadioGroup *InstructionSet;
        TRadioGroup *DataAlignment;
        TRadioGroup *RegisterVariables;
        TRadioGroup *CallingConvention;
        TRadioGroup *CodeOptimisation;
        TBitBtn *CodeOptimisationButton;
        TRadioGroup *WarningsLevel;
        TBitBtn *WarningsButton;
        TCheckBox *CheckBox15;
        TGroupBox *GroupBox3;
        TLabel *Label24;
        TEdit *Edit18;
        TLabel *Label25;
        TEdit *Edit19;
        TSpeedButton *SpeedButton10;
        TLabel *Label26;
        TComboBox *ComboBox1;
        TLabel *Label27;
        TEdit *Edit20;
        TBitBtn *BitBtn1;
	TBitBtn *BitBtn2;
	TBitBtn *BitBtn3;
	TBitBtn *BitBtn4;
	TBitBtn *BitBtn5;
	TRadioGroup *RadioGroup2;
	TRadioGroup *RadioGroup3;
	TRichEdit *RichEdit1;
	TOpenDialog *OpenDialog1;
	TPopupMenu *ApplicationVersionKeysPopupMenu;
	TMenuItem *Add1;
	TMenuItem *Edit21;
	TMenuItem *Delete1;
        void __fastcall CancelButtonClick(TObject *Sender);
        void __fastcall HelpFileBrowseClick(TObject *Sender);
        void __fastcall IconBrowseClick(TObject *Sender);
        void __fastcall OKButtonClick(TObject *Sender);
        void __fastcall SpeedButton1Click(TObject *Sender);
        void __fastcall SpeedButton2Click(TObject *Sender);
        void __fastcall SpeedButton3Click(TObject *Sender);
        void __fastcall SpeedButton8Click(TObject *Sender);
        void __fastcall SpeedButton7Click(TObject *Sender);
        void __fastcall SpeedButton6Click(TObject *Sender);
        void __fastcall CheckBox14Click(TObject *Sender);
        void __fastcall SpeedButton10Click(TObject *Sender);
        void __fastcall SpeedButton9Click(TObject *Sender);
	void __fastcall AdvancedCompilerTabShow(TObject *Sender);
	void __fastcall BitBtn1Click(TObject *Sender);
	void __fastcall DirectoriesTabShow(TObject *Sender);
	void __fastcall CodeOptimisationButtonClick(TObject *Sender);
	void __fastcall WarningsButtonClick(TObject *Sender);
	void __fastcall SpeedButton4Click(TObject *Sender);
	void __fastcall SpeedButton5Click(TObject *Sender);
	void __fastcall RadioGroup1Click(TObject *Sender);
	void __fastcall BitBtn3Click(TObject *Sender);
	void __fastcall BitBtn2Click(TObject *Sender);
	void __fastcall DebugButtonClick(TObject *Sender);
	void __fastcall BitBtn4Click(TObject *Sender);
	void __fastcall BitBtn5Click(TObject *Sender);
	void __fastcall Add1Click(TObject *Sender);
	void __fastcall Edit21Click(TObject *Sender);
	void __fastcall Delete1Click(TObject *Sender);
	void __fastcall CheckBox7Click(TObject *Sender);
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall CodeOptimisationClick(TObject *Sender);
	void __fastcall WarningsLevelClick(TObject *Sender);
private:	// User declarations
        // Properties
        TRegistry	*Registry;
        AnsiString	asProjectIconFile;
        bool            bModified;

        // 	PROPERTY METHODS	READ METHODS
        bool		__fastcall	GModified		( void );
        bool            __fastcall      GDebugMode      	( void );
        bool            __fastcall      GLineNumbering  	( void );
	bool            __fastcall      GTempPipe       	( void );
        bool            __fastcall      GInlineExpanding	( void );
        bool		__fastcall	GFPUNone		( void );
        bool		__fastcall	GFPUFast		( void );
        bool		__fastcall	GFPUFix			( void );
        bool		__fastcall	GFPUSoft		( void );
        bool		__fastcall	GIncludeVerInfo		( void );
        bool		__fastcall	GAutoIncVersion		( void );
        bool		__fastcall	GDebugAttr		( void );
        bool		__fastcall	GDLLAttr		( void );
        bool		__fastcall	GSpecialAttr		( void );
        bool		__fastcall	GPrivateAttr		( void );
        bool		__fastcall	GGPL			( void );
        bool		__fastcall	GPreRelease		( void );

        int             __fastcall      GMakeTarget     	( void );
        int             __fastcall      GPlatformId     	( void );
        int             __fastcall      GOptimisation   	( void );
        int             __fastcall      GWarnings       	( void );
        int             __fastcall      GInstructionSet 	( void );
        int             __fastcall      GDataAlignment  	( void );
        int             __fastcall      GRegVariables   	( void );
        int             __fastcall      GCallingConvention	( void );
        int             __fastcall      GAlignMode              ( void );
        int 		__fastcall	GMajor			( void );
        int 		__fastcall	GMinor			( void );
        int 		__fastcall	GRevision		( void );
        int 		__fastcall	GBuild			( void );
        int		__fastcall	GLanguage		( void );
        int		__fastcall	GInterface		( void );

        AnsiString      __fastcall      GCPPCompiler    	( void );
        AnsiString      __fastcall      GProjectTitle   	( void );
        AnsiString      __fastcall      GHelpFile       	( void );
        AnsiString      __fastcall      GMakePath       	( void );
        AnsiString      __fastcall      GMakeFileName   	( void );
        AnsiString      __fastcall      GASPath         	( void );
        AnsiString      __fastcall      GLDPath         	( void );
        AnsiString      __fastcall      GLibrary        	( int Index );
        AnsiString      __fastcall      GIncludePath    	( void );
        AnsiString      __fastcall      GLibraryPath     	( void );
        AnsiString      __fastcall      GDebugSourcePath 	( void );
        AnsiString      __fastcall      GTempOutput      	( void );
        AnsiString      __fastcall      GFinalOutput     	( void );
        AnsiString      __fastcall      GLibraryOutput   	( void );
        AnsiString      __fastcall      GConditionals    	( void );
        AnsiString      __fastcall      GAliases         	( void );
        AnsiString      __fastcall      GHomeDir        	( void );
        AnsiString      __fastcall      GIconFile               ( void );
        AnsiString      __fastcall      GDBPath                 ( void );
        AnsiString	__fastcall	GCFlags			( int Index );
        AnsiString	__fastcall	GASFlags		( int Index );
        AnsiString	__fastcall	GLDFlags		( int Index );
        AnsiString	__fastcall	GDBFlags		( int Index );

        //	PROPERTY METHODS	WRITE METHODS
        void		__fastcall	SFPUNone		( bool Value );
        void		__fastcall	SFPUFast		( bool Value );
        void		__fastcall	SFPUFix			( bool Value );
        void		__fastcall	SFPUSoft		( bool Value );
        void		__fastcall	SModified		( bool Value );
        void            __fastcall      SPlatformId     	( int Value );
        void            __fastcall      SProjectTitle   	( AnsiString Value );
        void            __fastcall      SHelpFile       	( AnsiString Value );
        void            __fastcall      SOptimisation   	( int Value );
        void            __fastcall      SWarnings       	( int Value );
        void            __fastcall      SDebugMode      	( bool Value );
        void            __fastcall      SLineNumbering  	( bool Value );
        void            __fastcall      SInlineExpanding	( bool Value );
        void            __fastcall      SMakePath       	( AnsiString Value );
        void            __fastcall      SMakeFileName   	( AnsiString Value );
        void            __fastcall      SMakeTarget     	( int Value );
        void            __fastcall      SInstructionSet 	( int Value );
        void            __fastcall      SDataAlignment  	( int Value );
        void            __fastcall      SRegVariables   	( int Value );
        void            __fastcall      SCallingConvention	( int Value );
        void            __fastcall      SCPPCompiler    	( AnsiString Value );
        void            __fastcall      SASPath         	( AnsiString Value );
        void            __fastcall      SLDPath         	( AnsiString Value );
        void            __fastcall      SLibrary        	( int Index, AnsiString Value );
        void            __fastcall      SIncludePath    	( AnsiString Value );
        void            __fastcall      SLibraryPath    	( AnsiString Value );
        void            __fastcall      SDebugSourcePath	( AnsiString Value );
        void            __fastcall      STempPipe       	( bool Value );
        void            __fastcall      STempOutput     	( AnsiString Value );
        void            __fastcall      SFinalOutput    	( AnsiString Value );
        void            __fastcall      SLibraryOutput  	( AnsiString Value );
        void            __fastcall      SConditionals   	( AnsiString Value );
        void            __fastcall      SAliases        	( AnsiString Value );
        void            __fastcall      SHomeDir                ( AnsiString Value );
        void            __fastcall      SIconFile               ( AnsiString Value );
        void            __fastcall      SAlignMode              ( int Value );
        void            __fastcall      SDBPath                 ( AnsiString Value );
        void		__fastcall	SIncludeVerInfo		( bool Value );
        void		__fastcall	SAutoIncVersion		( bool Value );
        void		__fastcall	SDebugAttr		( bool Value );
        void		__fastcall	SDLLAttr		( bool Value );
        void		__fastcall	SSpecialAttr		( bool Value );
        void		__fastcall	SPrivateAttr		( bool Value );
        void		__fastcall	SPreRelease		( bool Value );
        void		__fastcall	SMajor			( int Value );
        void		__fastcall	SMinor			( int Value );
        void		__fastcall	SRevision		( int Value );
        void		__fastcall	SBuild			( int Value );
        void		__fastcall	SLanguage		( int Value );
        void		__fastcall	SInterface		( int Value );
        void		__fastcall	SCFlags			( int Index, AnsiString Value );
        void		__fastcall	SASFlags		( int Index, AnsiString Value );
        void		__fastcall	SLDFlags		( int Index, AnsiString Value );
        void		__fastcall	SDBFlags		( int Index, AnsiString Value );

public:		// User declarations
		//	CONSTRUCTOR
        	__fastcall 	TProjectOptionsForm	( TComponent* Owner );
__published:	//	Project Options Properties

	//	Project Options Modified ?
        __property bool         Modified                	= { read=GModified, write=SModified, stored=true, default=false };

        //	Target Platform ID
        __property int          PlatformId              	= { read=GPlatformId, write=SPlatformId, stored=true, default=PLATFORM_DEFAULT };

        //	Project Title, project name is a MainForm property
        __property AnsiString   ProjectTitle            	= { read=GProjectTitle, write=SProjectTitle, stored=true, nodefault };

        //	Project's base directory
        __property AnsiString   ProjectHomeDir          	= { read=GHomeDir, write=SHomeDir, stored=true, nodefault };

        //	Help file, if applicable. This only relevent for certain Operating System Cores, ie Linux and Windows
        __property AnsiString   HelpFile                	= { read=GHelpFile, write=SHelpFile, stored=true, nodefault };

        //	Icon File, similar to the help file, but includes the PS2 Development Kit (ie Linux on PS2)
        __property AnsiString   IconFile                	= { read=GIconFile, write=SIconFile, stored=true, nodefault };

        //	Compiler base language, only C or C++ is supported at present
        __property int		Language			= { read=GLanguage, write=SLanguage };

        //	Application interface, depends on the platform type, options not available, GUI, console, dll, library
        __property int		Interface			= { read=GInterface, write=SInterface };

        //	Code optimisation level
        __property int          OptimisationLevel       	= { read=GOptimisation, write=SOptimisation, stored=true, default=0 };

        //	Code warnings level
        __property int          WarningLevel            	= { read=GWarnings, write=SWarnings, stored=true, default=1 };

        //	compile the project with debug information
        __property bool         DebugMode               	= { read=GDebugMode, write=SDebugMode, stored=true, default=false };

        //	include line numbering information in object file
        __property bool         LineNumbering           	= { read=GLineNumbering, write=SLineNumbering, stored=true, default=false };

        //	Target code calling convention, C/C++, Pascal, Register
        __property int          TargetCallingConvention       	= { read=GCallingConvention, write=SCallingConvention, stored=true, nodefault };

        //	Disable/Enable inline expansion
        __property bool         InlineExpansion         	= { read=GInlineExpanding, write=SInlineExpanding, stored=true, default=false };

        //	Make application for this project, ie does it require a specific version of make for the project's target
        __property AnsiString   MakeApplication         	= { read=GMakePath, write=SMakePath, stored=true, nodefault };

        //	Default project's makefile filename, this is the same as the GNU format ie it usually ie 'Makefile'
        __property AnsiString   MakeFileName            	= { read=GMakeFileName, write=SMakeFileName, stored=true, nodefault };

        //	Default target when make is executed on the project's makefile without specifying a target, ie 'clean, config etc'
        __property int          MakeTarget              	= { read=GMakeTarget, write=SMakeTarget, stored=true, default=-1 };

        //	Target instruction set. Eg PSX R3000, PS2 (EE or IOP), PC (i486 to PIII)
        __property int          TargetInstructionSet    	= { read=GInstructionSet, write=SInstructionSet, stored=true, default=0 };

        //	Target data alignment, note that not all compilers support this feature
        __property int          TargetDataAlignment     	= { read=GAlignMode, write=SAlignMode, stored=true, default=1 };

        //	copy data values to cpu registers for speed
        __property int          TargetRegisterVariables 	= { read=GRegVariables, write=SRegVariables, stored=true, default=0 };

        //	FPU section, if this is set then the rest of the FPU<name> properties are always false
        __property bool		FPUNone 			= { read=GFPUNone, write=SFPUNone, stored=true, default=false };

        //	Use the FPU hardware if present
        __property bool		FPUFast 			= { read=GFPUFast, write=SFPUFast, stored=true, default=true  };

        //	if using the Pentium CPU core then fix the bug present in the cpu core
        __property bool		FPUFix  			= { read=GFPUFix,  write=SFPUFix,  stored=true, default=false };

        //	use the maths emulator library
        __property bool		FPUSoft 			= { read=GFPUSoft, write=SFPUSoft, stored=true, default=false };

        //	C/C++ compiler path, this is written to the makefile so that make uses the correct compiler for the target instruction set
        __property AnsiString   CompilerPath            	= { read=GCPPCompiler, write=SCPPCompiler, stored=true, nodefault };

        //	CFLAGS, this is what makes the CFLAGS variable in the project's makefile
        __property AnsiString   CompilerFlags[ int Index ]	= { read=GCFlags,  write=SCFlags  };

        //	As above but for the assembler
        __property AnsiString   AssemblerPath           	= { read=GASPath,  write=SASPath,  stored=true, nodefault };

        //	Assembler flags ASFLAGS
      	__property AnsiString   AssemblerFlags[ int Index ]	= { read=GASFlags, write=SASFlags };

        //	Linker path
        __property AnsiString   LinkerPath              	= { read=GLDPath,  write=SLDPath,  stored=true, nodefault };

        //	Linker flags
      	__property AnsiString   LinkerFlags[ int Index ]	= { read=GLDFlags, write=SLDFlags };

        //	Debugger Path this should be always equal to the DebugOptionsForm->DebuggerPath property
        __property AnsiString   DebuggerPath            	= { read=GDBPath,  write=SDBPath,  stored=true, nodefault };

        //	Flags for above
      	__property AnsiString   DebuggerFlags[ int Index ]	= { read=GDBFlags, write=SDBFlags };

        //	Any extra libraries that the user wishes to include with their project
      	__property AnsiString   ExtraLibraries[ int Index ]	= { read=GLibrary, write=SLibrary };

        //	include path for header files, project specific NOT compiler headers location
        __property AnsiString   IncludePath             	= { read=GIncludePath, write=SIncludePath, stored=true, nodefault };

        //	As above but for any libraries that may be required during the compilation of the project
        __property AnsiString   LibraryPath             	= { read=GLibraryPath, write=SLibraryPath, stored=true, nodefault };

        //	can be used to specify a seperate source tree for code that has been written specifically for debugging purposes
        // this is generally the same as the project's source tree
        __property AnsiString   DebugSourcePath         	= { read=GDebugSourcePath, write=SDebugSourcePath, stored=true, nodefault };

        //	if using temporary output files for the compilation process then this is where they are stored
        __property AnsiString   TempOutputPath          	= { read=GTempOutput, write=STempOutput, stored=true, nodefault };

        //	used with above to determine if the compiler should uses pipes (memory) or temporary files (disk) for the compilation
        // and/or linking processes
        __property bool         TempOutputPiping        	= { read=GTempPipe, write=STempPipe, stored=true, default=true };

        //	Generally the bin sub-directory in the  project's home directory, or can be used to specify the install path
        // used when running make with the target as 'install'
        __property AnsiString   FinalOutputPath         	= { read=GFinalOutput, write=SFinalOutput, stored=true, nodefault };

        //	Directory to store any produced library files, usually the lib sub-directory in the project's home directory
        __property AnsiString   LibraryOutputPath       	= { read=GLibraryOutput, write=SLibraryOutput, stored=true, nodefault };

        //	any conditional statements that make be passed to make and/or any of the sub-processes during the compilation
        // of the project, eg if in DebugMode (see above) then DEBUG would be present
        __property AnsiString   Conditionals            	= { read=GConditionals, write=SConditionals, stored=true, nodefault };

        //	Aliases for modules ie PROJECTOPTIONS=ProjectOptionsForm, or something similar, have not really defined anything
        // about this property yet
        __property AnsiString   UnitAliases             	= { read=GAliases, write=SAliases, stored=true, nodefault };

        //	include version information in the project, ie generate a header file with the version information in it as #define statements
        __property bool		IncludeVerInfo 			= { read=GIncludeVerInfo, write=SIncludeVerInfo, stored=true, default=false };

        //	auto increment the version number of the project's executable
        __property bool		AutoIncVersion 			= { read=GAutoIncVersion, write=SAutoIncVersion, stored=true, default=false };

        //	see debugmode, this is a mirror of the DebugMode property but does not write the debugmode value, as this is
        // just a project version information key
        __property bool		DebugAttr 			= { read=GDebugAttr, write=SDebugAttr, stored=true, default=false };

        //	prerelease code level
        __property bool		PreReleaseAttr 			= { read=GPreRelease, write=SPreRelease, stored=true, default=false };

        //	DLL code , windows only
        __property bool		DLLAttr 			= { read=GDLLAttr, write=SDLLAttr, stored=true, default=false };

        //	Special attribute set
        __property bool		SpecialAttr			= { read=GSpecialAttr, write=SSpecialAttr, stored=true, default=false };

        //	private build attribute set
        __property bool		PrivateAttr			= { read=GPrivateAttr, write=SPrivateAttr, stored=true, default=false };

        //	GPL, part of the GPL license agreement
        __property bool		GPL				= { read=GGPL, stored=true, default=true };	//	ALWAYS ON IN PSX IDE BUT SWITCHABLE IN KONDEV

        //	Version Number	MAJOR : MINOR : REVISION : BUILD
        __property int		Major				= { read=GMajor, write=SMajor, stored=true };
        __property int		Minor                   	= { read=GMinor, write=SMinor, stored=true };
        __property int		Revision                	= { read=GRevision, write=SRevision, stored=true };
        __property int		Build                   	= { read=GBuild, write=SBuild, stored=true };

};
//---------------------------------------------------------------------------
extern PACKAGE TProjectOptionsForm *ProjectOptionsForm;
//---------------------------------------------------------------------------
#endif
//---------------------------------------------------------------------------
