//---------------------------------------------------------------------------
#include <vcl.h>
//---------------------------------------------------------------------------
#pragma hdrstop
//---------------------------------------------------------------------------
#include "SearchReplaceUnit.h"
#include "main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
//---------------------------------------------------------------------------
TSearchReplaceDialog *SearchReplaceDialog;
//---------------------------------------------------------------------------
__fastcall 	TSearchReplaceDialog :: TSearchReplaceDialog( TComponent* Owner ) : TForm( Owner )
{
	PageControl1->ActivePage = SearchSheet;	//	Default to a standard search only

        SearchType = TYPE_SEARCH_LOCAL;		//	Local search only
}
//---------------------------------------------------------------------------
AnsiString	__fastcall	TSearchReplaceDialog :: GSearchString		( void )
{
	switch ( SearchType ) {
        	case ( TYPE_SEARCH_LOCAL   ) : 	return( Edit1->Text );
                case ( TYPE_SEARCH_FILE    ) : 	return( Edit2->Text );
                case ( TYPE_SEARCH_REPLACE ) : 	return( Edit3->Text );
                default : 			return( NULL );
        }
}
//---------------------------------------------------------------------------
AnsiString	__fastcall	TSearchReplaceDialog :: GReplaceString		( void )
{
	if ( SearchType == TYPE_SEARCH_REPLACE ) return( Edit4->Text );
        else return( NULL );
}
//---------------------------------------------------------------------------
AnsiString	__fastcall	TSearchReplaceDialog :: GSearchPath		( void )
{
	if ( SearchType == TYPE_SEARCH_FILE ) return( Edit5->Text );
        else return( NULL );
}
//---------------------------------------------------------------------------
bool		__fastcall	TSearchReplaceDialog :: GReplaceAll		( void )
{
	return( CheckBox11->Checked );
}
//---------------------------------------------------------------------------
bool		__fastcall	TSearchReplaceDialog :: GReplacePrompt		( void )
{
	return( CheckBox10->Checked );
}
//---------------------------------------------------------------------------
bool		__fastcall	TSearchReplaceDialog :: GSearchSubDirs		( void )
{
	return( CheckBox12->Checked );
}
//---------------------------------------------------------------------------
bool		__fastcall	TSearchReplaceDialog :: GCaseSensistive		( void )
{
	switch ( SearchType ) {

        	case ( TYPE_SEARCH_LOCAL   ) : return( CheckBox1->Checked );
                case ( TYPE_SEARCH_FILE    ) : return( CheckBox4->Checked );
                case ( TYPE_SEARCH_REPLACE ) : return( CheckBox7->Checked );

                default :			return( false );
        }
}
//---------------------------------------------------------------------------
bool		__fastcall	TSearchReplaceDialog :: GWholeWords		( void )
{
	switch ( SearchType ) {

        	case ( TYPE_SEARCH_LOCAL   ) : return( CheckBox2->Checked );
                case ( TYPE_SEARCH_FILE    ) : return( CheckBox5->Checked );
                case ( TYPE_SEARCH_REPLACE ) : return( CheckBox8->Checked );

                default :			return( false );

        }
}
//---------------------------------------------------------------------------
bool		__fastcall	TSearchReplaceDialog :: GRegularExpressions	( void )
{
	switch ( SearchType ) {

        	case ( TYPE_SEARCH_LOCAL   ) : return( CheckBox3->Checked );
                case ( TYPE_SEARCH_FILE    ) : return( CheckBox6->Checked );
                case ( TYPE_SEARCH_REPLACE ) : return( CheckBox9->Checked );

                default :			return( false );

        }
}
//---------------------------------------------------------------------------
int		__fastcall	TSearchReplaceDialog :: GSearchType		( void )
{
	if ( PageControl1->ActivePage == SearchSheet ) return( TYPE_SEARCH_LOCAL );

        if ( PageControl1->ActivePage == SearchFilesSheet ) return( TYPE_SEARCH_FILE );

        if ( PageControl1->ActivePage == SearchReplaceSheet ) return( TYPE_SEARCH_REPLACE );

        return( -1 );
}
//---------------------------------------------------------------------------
int	__fastcall	TSearchReplaceDialog :: GSearchDirection( void )
{
	switch ( SearchType ) {

        	case ( TYPE_SEARCH_LOCAL ) : return( RadioGroup7->ItemIndex );

                case ( TYPE_SEARCH_REPLACE ) : return( RadioGroup4->ItemIndex );

                default : return( -1 );
        }
}
//---------------------------------------------------------------------------
int	__fastcall	TSearchReplaceDialog :: GSearchScope( void )
{
	switch ( SearchType ) {

        	case ( TYPE_SEARCH_LOCAL ) : return( RadioGroup8->ItemIndex );

                case ( TYPE_SEARCH_REPLACE ) : return( RadioGroup5->ItemIndex );

                default : return( -1 );
        }
}
//---------------------------------------------------------------------------
int	__fastcall	TSearchReplaceDialog :: GSearchOrigin( void )
{
	switch ( SearchType ) {

        	case ( TYPE_SEARCH_LOCAL ) : return( RadioGroup9->ItemIndex );

                case ( TYPE_SEARCH_REPLACE ) : return( RadioGroup6->ItemIndex );

                default : return( -1 );
        }
}
//---------------------------------------------------------------------------
void	__fastcall	TSearchReplaceDialog :: SSearchString		( AnsiString Value )
{
	switch ( SearchType ) {

        	case ( TYPE_SEARCH_LOCAL ) : {
                	if ( Edit1->Text != Value ) {
                        	Edit1->Text = Value;
                        }
                        break;
                }

                case ( TYPE_SEARCH_FILE ) : {
                	if ( Edit2->Text != Value ) {
                        	Edit2->Text = Value;
                        }
                        break;
                }

                case ( TYPE_SEARCH_REPLACE ) : {
                	if ( Edit3->Text != Value ) {
                        	Edit3->Text = Value;
                        }
                        break;
                }

        }
}
//---------------------------------------------------------------------------
void	__fastcall	TSearchReplaceDialog :: SReplaceString		( AnsiString Value )
{
	if ( SearchType == TYPE_SEARCH_REPLACE ) {
        	if ( Edit4->Text != Value ) {
                	Edit4->Text = Value;
                }
        }
}
//---------------------------------------------------------------------------
void	__fastcall	TSearchReplaceDialog :: SSearchPath		( AnsiString Value )
{
	if ( SearchType == TYPE_SEARCH_FILE ) {
        	if ( Edit5->Text != Value ) {
                	Edit5->Text = Value;
                }
        }
}
//---------------------------------------------------------------------------
void	__fastcall	TSearchReplaceDialog :: SReplaceAll		( bool Value )
{
	if ( SearchType == TYPE_SEARCH_REPLACE ) {
        	if ( CheckBox11->Checked != Value ) {
                	CheckBox11->Checked = Value;
                }
        }
}
//---------------------------------------------------------------------------
void	__fastcall	TSearchReplaceDialog :: SReplacePrompt		( bool Value )
{
	if ( SearchType == TYPE_SEARCH_REPLACE ) {
                if ( CheckBox10->Checked != Value ) {
                	CheckBox11->Checked = Value;
                }
        }
}
//---------------------------------------------------------------------------
void	__fastcall	TSearchReplaceDialog :: SSearchSubDirs		( bool Value )
{
	if ( SearchType == TYPE_SEARCH_FILE ) {
        	if ( CheckBox12->Checked != Value ) {
                	CheckBox12->Checked = Value;
                }
	}
}
//---------------------------------------------------------------------------
void	__fastcall	TSearchReplaceDialog :: SCaseSensistive		( bool Value )
{
	switch ( SearchType ) {

        	case ( TYPE_SEARCH_LOCAL ) : {
                	if ( CheckBox1->Checked != Value ) {
                        	CheckBox1->Checked = Value;
                        }
                        break;
                }

                case ( TYPE_SEARCH_FILE ) : {
                	if ( CheckBox4->Checked != Value ) {
                        	CheckBox4->Checked = Value;
                        }
                        break;
                }

                case ( TYPE_SEARCH_REPLACE ) : {
                	if ( CheckBox7->Checked != Value ) {
                        	CheckBox7->Checked = Value;
                        }
                        break;
                }
        }
}
//---------------------------------------------------------------------------
void	__fastcall	TSearchReplaceDialog :: SWholeWords		( bool Value )
{
	switch ( SearchType ) {

        	case ( TYPE_SEARCH_LOCAL ) : {
                	if ( CheckBox2->Checked != Value ) {
                        	CheckBox2->Checked = Value;
                        }
                        break;
                }

                case ( TYPE_SEARCH_FILE ) : {
                	if ( CheckBox5->Checked != Value ) {
                        	CheckBox5->Checked = Value;
                        }
                        break;
                }

                case ( TYPE_SEARCH_REPLACE ) : {
                	if ( CheckBox8->Checked != Value ) {
                        	CheckBox8->Checked = Value;
                        }
                        break;
                }
        }
}
//---------------------------------------------------------------------------
void	__fastcall	TSearchReplaceDialog :: SRegularExpressions	( bool Value )
{
	switch ( SearchType ) {

        	case ( TYPE_SEARCH_LOCAL ) : {
                	if ( CheckBox3->Checked != Value ) {
                        	CheckBox3->Checked = Value;
                        }
                        break;
                }

                case ( TYPE_SEARCH_FILE ) : {
                	if ( CheckBox6->Checked != Value ) {
                        	CheckBox6->Checked = Value;
                        }
                        break;
                }

                case ( TYPE_SEARCH_REPLACE ) : {
                	if ( CheckBox9->Checked != Value ) {
                        	CheckBox9->Checked = Value;
                        }
                        break;
                }
        }
}
//---------------------------------------------------------------------------
void	__fastcall	TSearchReplaceDialog :: SSearchType		( int Value )
{
	switch ( SearchType ) {
        	case ( TYPE_SEARCH_LOCAL ) : {
                	PageControl1->ActivePage = SearchSheet;
                        break;
                }

                case ( TYPE_SEARCH_FILE ) : {
                	PageControl1->ActivePage = SearchFilesSheet;
                        break;
                }

                case ( TYPE_SEARCH_REPLACE ) : {
                	PageControl1->ActivePage = SearchReplaceSheet;
                        break;
                }

                default : {
                	PageControl1->ActivePage = SearchSheet;
                        break;
                }
        }

        Update();
}
//---------------------------------------------------------------------------
void	__fastcall	TSearchReplaceDialog :: SSearchDirection( int Value )
{
	switch ( SearchType ) {

        	case ( TYPE_SEARCH_LOCAL ) : {
                	if ( RadioGroup7->ItemIndex != Value ) {
                        	RadioGroup7->ItemIndex = Value;
                        }
                        break;
                }

                case ( TYPE_SEARCH_REPLACE ) : {
                	if ( RadioGroup4->ItemIndex != Value ) {
                        	RadioGroup7->ItemIndex = Value;
                        }
                        break;
                }

        }

}
//---------------------------------------------------------------------------
void	__fastcall	TSearchReplaceDialog :: SSearchScope( int Value )
{
	switch ( SearchType ) {

        	case ( TYPE_SEARCH_LOCAL ) : {
                	if ( RadioGroup8->ItemIndex != Value ) {
                        	RadioGroup8->ItemIndex = Value;
                        }
                        break;
                }

                case ( TYPE_SEARCH_REPLACE ) : {
                	if ( RadioGroup5->ItemIndex != Value ) {
                        	RadioGroup5->ItemIndex = Value;
                        }
                        break;
                }
        }
}
//---------------------------------------------------------------------------
void	__fastcall	TSearchReplaceDialog :: SSearchOrigin( int Value )
{
	switch ( SearchType ) {

        	case ( TYPE_SEARCH_LOCAL ) : {
                	if ( RadioGroup9->ItemIndex != Value ) {
                        	RadioGroup9->ItemIndex = Value;
                        }
                        break;
                }

                case ( TYPE_SEARCH_REPLACE ) : {
                	if ( RadioGroup6->ItemIndex != Value ) {
                        	RadioGroup6->ItemIndex = Value;
                        }
                        break;
                }
        }
}
//---------------------------------------------------------------------------
void __fastcall TSearchReplaceDialog::BitBtn1Click(TObject *Sender)
{
	//	Initiate search, OK Button pressed

        switch ( SearchType ) {

        	case ( TYPE_SEARCH_LOCAL ) : {
                	if ( !SearchLocal( Sender ) ) {
                        	MessageBox( Application->Handle, "Search failure", Application->Title.c_str(), MB_OK | MB_ICONEXCLAMATION );
                                ModalResult = mrCancel;
                                break;
                        }
                        ModalResult = mrOk;
                        break;
                }

                case ( TYPE_SEARCH_FILE ) : {
                	if ( !SearchFiles( Sender ) ) {
                        	MessageBox( Application->Handle, "Search failure", Application->Title.c_str(), MB_OK | MB_ICONEXCLAMATION );
                                ModalResult = mrCancel;
                                break;
                        }
                        ModalResult = mrOk;
                        break;
                }

                case ( TYPE_SEARCH_REPLACE ) : {
                	if ( !SearchReplace( Sender ) ) {
                        	MessageBox( Application->Handle, "Search failure", Application->Title.c_str(), MB_OK | MB_ICONEXCLAMATION );
                                ModalResult = mrCancel;
                                break;
                        }
                        ModalResult = mrOk;
                        break;
                }

        }
}
//---------------------------------------------------------------------------
int	__fastcall	TSearchReplaceDialog :: SearchLocal( TObject *Sender )
{	AnsiString	asCmdLine;

	if ( SearchType != TYPE_SEARCH_LOCAL )	return( false );	//	Not a local search bad call

	//	Local Search work out what type of search it is
        if ( CaseSensistive ) asCmdLine = "-i+ ";
        else asCmdLine = "-i- ";

        if ( RegularExpressions ) asCmdLine += "-r+ ";
        else asCmdLine = "-r- ";

        if ( WholeWords ) asCmdLine += "-w+ ";
        else asCmdLine += "-w- ";

        //	Add default options ie only line numbers output
        asCmdLine += "-n+ ";

        //	Add search string
        asCmdLine += SearchString + " ";

        //	Add filename
        //asCmdLine += MainForm->CurrentFile + " ";

        asCmdLine += " > grep.txt";

        ShellExecute( Application->Handle, "open", "grep", asCmdLine.c_str(), GetCurrentDir().c_str(), SW_SHOWNORMAL );

        return( true );
}
//---------------------------------------------------------------------------
int	__fastcall	TSearchReplaceDialog :: SearchFiles( TObject *Sender )
{	AnsiString	asCmdLine;

	if ( SearchType != TYPE_SEARCH_FILE )	return( false );	//	Not a file search bad call

	//	Local Search work out what type of search it is
        if ( CaseSensistive ) asCmdLine = "-i+ ";
        else asCmdLine = "-i- ";

        if ( RegularExpressions ) asCmdLine += "-r+ ";
        else asCmdLine = "-r- ";

        if ( WholeWords ) asCmdLine += "-w+ ";
        else asCmdLine += "-w- ";

        if ( SearchSubDirs ) asCmdLine += "-d+ ";
        else asCmdLine += "-d- ";

        //	Add default options ie only line numbers output
        asCmdLine += "-n+ ";

        //	Add search string
        asCmdLine += SearchString + " ";

        //	Add filename
        //asCmdLine += MainForm->CurrentFile + " ";

        asCmdLine += " > grep.txt";

        ShellExecute( Application->Handle, "open", "grep", asCmdLine.c_str(), SearchPath.c_str(), SW_SHOWNORMAL );

        return( true );
}
//---------------------------------------------------------------------------
int	__fastcall	TSearchReplaceDialog :: SearchReplace( TObject *Sender )
{	AnsiString	asCmdLine;

	if ( SearchType != TYPE_SEARCH_REPLACE )	return( false );	//	Not a local search bad call

	//	Local Search work out what type of search it is
        if ( CaseSensistive ) asCmdLine = "-i+ ";
        else asCmdLine = "-i- ";

        if ( RegularExpressions ) asCmdLine += "-r+ ";
        else asCmdLine = "-r- ";

        if ( WholeWords ) asCmdLine += "-w+ ";
        else asCmdLine += "-w- ";

        //	Add default options ie only line numbers output
        asCmdLine += "-n+ ";

        //	Add search string
        asCmdLine += SearchString + " ";

        //	Add filename
        //asCmdLine += MainForm->CurrentFile + " ";

        asCmdLine += " > grep.txt";

        ShellExecute( Application->Handle, "open", "grep", asCmdLine.c_str(), GetCurrentDir().c_str(), SW_SHOWNORMAL );

        return( true );
}
//---------------------------------------------------------------------------
