//---------------------------------------------------------------------------
#ifndef SearchReplaceUnitH
#define SearchReplaceUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include "shellapi.h"
//---------------------------------------------------------------------------
//	Search types
//---------------------------------------------------------------------------
#define TYPE_SEARCH_LOCAL	0	//	Current open editor file only
#define TYPE_SEARCH_FILE	1	//	Search in specified files only
#define TYPE_SEARCH_REPLACE	2	//	Search and replace operation
//---------------------------------------------------------------------------
class TSearchReplaceDialog : public TForm
	{
		protected:
			int	__fastcall	SearchLocal	( TObject *Sender );
		        int	__fastcall	SearchFiles	( TObject *Sender );
		        int	__fastcall	SearchReplace	( TObject *Sender );

		__published:	// IDE-managed Components
			TPanel *Panel1;
			TPageControl *PageControl1;
			TTabSheet *SearchSheet;
			TTabSheet *SearchFilesSheet;
			TTabSheet *SearchReplaceSheet;
			TLabel *Label1;
			TEdit *Edit1;
			TLabel *Label2;
			TEdit *Edit2;
			TLabel *Label3;
			TLabel *Label4;
			TEdit *Edit3;
			TEdit *Edit4;
			TRadioGroup *RadioGroup7;
			TGroupBox *SearchOptions;
			TRadioGroup *RadioGroup8;
			TRadioGroup *RadioGroup9;
			TBitBtn *BitBtn1;
			TBitBtn *BitBtn2;
			TBitBtn *BitBtn3;
			TCheckBox *CheckBox1;
			TCheckBox *CheckBox2;
			TCheckBox *CheckBox3;
			TGroupBox *GroupBox1;
			TCheckBox *CheckBox4;
			TCheckBox *CheckBox5;
			TCheckBox *CheckBox6;
			TGroupBox *GroupBox2;
			TCheckBox *CheckBox7;
			TCheckBox *CheckBox8;
			TCheckBox *CheckBox9;
			TRadioGroup *RadioGroup4;
			TRadioGroup *RadioGroup5;
			TRadioGroup *RadioGroup6;
			TCheckBox *CheckBox11;
			TCheckBox *CheckBox10;
			TGroupBox *GroupBox4;
			TRadioGroup *RadioGroup1;
			TEdit *Edit5;
			TCheckBox *CheckBox12;
			TSpeedButton *SpeedButton1;

			void __fastcall BitBtn1Click(TObject *Sender);
		private:	// User declarations

		//	Property read methods
			AnsiString	__fastcall	GSearchString		( void );
		        AnsiString	__fastcall	GReplaceString		( void );
		        AnsiString	__fastcall	GSearchPath		( void );

		        bool		__fastcall	GReplaceAll		( void );
		        bool		__fastcall	GReplacePrompt		( void );
		        bool		__fastcall	GSearchSubDirs		( void );
		        bool		__fastcall	GCaseSensistive		( void );
		        bool		__fastcall	GWholeWords		( void );
		        bool		__fastcall	GRegularExpressions	( void );

		        int		__fastcall	GSearchType		( void );
                        int		__fastcall	GSearchDirection	( void );
                        int		__fastcall	GSearchScope		( void );
                        int		__fastcall	GSearchOrigin		( void );

        	//	Property write methods
		        void	__fastcall	SSearchString		( AnsiString Value );
		        void	__fastcall	SReplaceString		( AnsiString Value );
		        void	__fastcall	SSearchPath		( AnsiString Value );

		        void	__fastcall	SReplaceAll		( bool Value );
		        void	__fastcall	SReplacePrompt		( bool Value );
		        void	__fastcall	SSearchSubDirs		( bool Value );
		        void	__fastcall	SCaseSensistive		( bool Value );
		        void	__fastcall	SWholeWords		( bool Value );
		        void	__fastcall	SRegularExpressions	( bool Value );

		        void	__fastcall	SSearchType		( int Value );
                        void	__fastcall	SSearchDirection	( int Value );
                        void	__fastcall	SSearchScope		( int Value );
                        void	__fastcall	SSearchOrigin		( int Value );
		public:		// User declarations
			__fastcall TSearchReplaceDialog(TComponent* Owner);
		__published:
			__property	AnsiString	SearchString		= { read=GSearchString, 	write=SSearchString, 		stored=true, nodefault     };
		        __property	AnsiString	ReplaceString		= { read=GReplaceString, 	write=SReplaceString, 		stored=true, nodefault     };
		        __property	AnsiString	SearchPath		= { read=GSearchPath, 		write=SSearchPath, 		stored=true, nodefault     };

		        __property	bool		ReplaceAll		= { read=GReplaceAll, 		write=SReplaceAll, 		stored=true, default=false };
		        __property	bool		PromptOnReplace         = { read=GReplacePrompt, 	write=SReplacePrompt,  		stored=true, default=true  };
		        __property	bool		SearchSubDirs           = { read=GSearchSubDirs, 	write=SSearchSubDirs,		stored=true, default=false };
		        __property	bool		CaseSensistive          = { read=GCaseSensistive, 	write=SCaseSensistive,		stored=true, default=false };
		        __property	bool		WholeWords              = { read=GWholeWords, 		write=SWholeWords,		stored=true, default=true  };
		        __property	bool		RegularExpressions      = { read=GRegularExpressions,	write=SRegularExpressions,	stored=true, default=false };

			__property	int		SearchType		= { read=GSearchType,		write=SSearchType,		stored=true, nodefault     };
                        __property	int		SearchDirection		= { read=GSearchDirection,	write=SSearchDirection,		stored=true, nodefault	   };
                        __property	int		SearchScope		= { read=GSearchScope,		write=SSearchScope,		stored=true, nodefault	   };
                        __property	int		SearchOrigin		= { read=GSearchOrigin,		write=SSearchOrigin,		stored=true, nodefault	   };
	};
//---------------------------------------------------------------------------
extern PACKAGE TSearchReplaceDialog *SearchReplaceDialog;
//---------------------------------------------------------------------------
#endif
//---------------------------------------------------------------------------
