//---------------------------------------------------------------------------
#include <vcl.h>
//---------------------------------------------------------------------------
#pragma hdrstop
//---------------------------------------------------------------------------
#include "Tools.h"
#include "ToolsAPI.h"
#include "EditToolDialog.h"
#include "main.h"
#include "Utilities.h"
#include "EnviromentOptionsUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
//---------------------------------------------------------------------------
TToolDialog *ToolDialog;
__declspec( dllimport ) dwNumTools;
//---------------------------------------------------------------------------
__fastcall	TToolDialog :: TToolDialog( TComponent* Owner ) : TForm( Owner )
{               //          Load the tools from the registry and by checking
                //          for executable files specified within the MainFrom
                //          and/or Enviroment Options Form
        pTool = new TIDETool( dynamic_cast< TObject* >(Owner) );
        pTool->LoadFromRegistry( dynamic_cast< TObject* >(Owner) );

        if ( dwNumTools <= 0 ) return;         //       No tools registered in system registry

        for ( int i=0; i<=dwNumTools; i++ ) {
            TListItem *pItem = ListView1->Items->Add();

            pItem->Caption = IdeTools[ i ].Caption;
        }
}
//---------------------------------------------------------------------------
void __fastcall TToolDialog::ToolEditButtonClick(TObject *Sender)
{
        if ( !ListView1->Selected ) return;
        ToolEditDialog->ToolTitle->Text = pTool->Caption;
        ToolEditDialog->ToolPath->Width = 300;
        ToolEditDialog->SpeedButton1->Visible = false;
        ToolEditDialog->ToolPath->Text = pTool->ToolPath;
        ToolEditDialog->ToolWorkDirectory->Text = pTool->WorkingDirectory;
        ToolEditDialog->ToolParameters->Text = pTool->Parameters;
        ToolEditDialog->Caption = "Editing Tool " + pTool->Caption;
        if ( ToolEditDialog->ShowModal() == mrOk ) {
                IdeTools->Remove( dynamic_cast< TObject *>(pTool) );
                IdeTools->Install( dynamic_cast< TObject *>(pTool) );
                TListItem *pItem = ListView1->Items->Add();
                if ( !pItem ) return;
                pItem->Caption = pTool->Caption;
                pItem->SubItems->Add( pTool->Caption );
        }
        Update();
}
//---------------------------------------------------------------------------
void __fastcall TToolDialog::ToolRemoveButtonClick(TObject *Sender)
{       int     mrCode;
        if ( !ListView1->Selected ) {
                MessageBox( Application->Handle, "Please selected a tool for deletion", Application->Title.c_str(), MB_OK );
                return;
        }
        mrCode = MessageBox( Application->Handle, strcat( "Delete tool ", ListView1->Selected->Caption.c_str() ), "Confirm tool deletion", MB_YESNO );
        if ( mrCode == mrNo ) return;
        if ( mrCode == mrYes ) IdeTools->Remove( dynamic_cast< TObject *>(pTool) );
        ListView1->Items->Delete( ListView1->Selected->Index );
}
//---------------------------------------------------------------------------
void __fastcall TToolDialog::ToolAddButtonClick(TObject *Sender)
{
        ToolEditDialog->Caption = "Install new tool";
        ToolEditDialog->ToolPath->Width = 270;
        ToolEditDialog->SpeedButton1->Visible = true;
        ToolEditDialog->ShowModal();
        if ( ToolEditDialog->ModalResult == mrCancel ) return;
	if ( !pTool ) pTool = new TIDETool( Application );
        pTool->Caption = ToolEditDialog->ToolTitle->Text;
        pTool->ToolPath = ToolEditDialog->ToolPath->Text;
        pTool->WorkingDirectory = ToolEditDialog->ToolWorkDirectory->Text;
        pTool->Parameters = ToolEditDialog->ToolParameters->Text;
        pTool->Install( (TObject*)pTool );
        TListItem *plItem = ListView1->Items->Add();
        if ( !plItem ) {
                MessageBox( Application->Handle, strcat( "Unable to install tool ", pTool->Caption.c_str() ), Application->Title.c_str(), MB_OK );
                delete pTool;
                return;
        }
        plItem->Caption = pTool->Caption;
        Update();
}
//---------------------------------------------------------------------------
