//---------------------------------------------------------------------------
//
//	$FileName	::	ToolsAPI.h
//	$Author		::	Chris Brooklyn
//	$Purpose	::	To allow externals applications to be used within
//				a project in the ide, ie to be installed in the
//				'Tools' menu. This similar to the 'Plugins'
//				apart from being based on a 'TThread'
//
//---------------------------------------------------------------------------
#ifndef ToolsAPIH
#define ToolsAPIH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <System.hpp>
#include <SysUtils.hpp>
#include <Windows.hpp>
#include <Registry.hpp>
//---------------------------------------------------------------------------
#include "Defines.h"
#include "RegEntries.h"
#include "Tools.h"
//---------------------------------------------------------------------------
//	MACROS	::	MACRO DEFINITIONS
//---------------------------------------------------------------------------
#define	MACRO_COL               AnsiString( "COL"	  )		//	Return current editor window x position of cursor
#define	MACRO_ROW               AnsiString( "ROW"	  )		//	return current editor window y position of cursor
#define	MACRO_CURTOKEN          AnsiString( "CURTOKEN"	  )		//	current word in current editor window at current cursor position
#define	MACRO_PATH              AnsiString( "PATH"	  )		//	current enviroment variable 'PATH'
#define	MACRO_NAME              AnsiString( "NAME"	  )		//	full file-path name of current editor window
#define	MACRO_NAMEONLY          AnsiString( "NAMEONLY"	  )		//	filename only of current editor window
#define	MACRO_EXT               AnsiString( "EXT"	  )		//	file extension only of current editor window
#define	MACRO_EDNAME            AnsiString( "EDNAME"	  )		//	editor exe ?
#define	MACRO_EXENAME           AnsiString( "EXENAME"	  )		//	projects executable file, (note does not mean that the file exists!)
#define	MACRO_PARAMS            AnsiString( "PARAMS"	  )		//	prompt user for parameters
#define	MACRO_PROMPT            AnsiString( "PROMPT"	  )		//	prompt user for parameters
#define	MACRO_SAVE              AnsiString( "SAVE"	  )		//	save current editor window
#define	MACRO_SAVEALL           AnsiString( "SAVEALL"	  )		//	save all editor windows and options
#define	MACRO_CC                AnsiString( "CC"	  )		//	current C/C++ compiler path
#define	MACRO_CFLAGS            AnsiString( "CCFLAGS"	  )		//	any defined flags for compiler
#define	MACRO_AS                AnsiString( "AS"	  )		//	assembler
#define	MACRO_ASFLAGS           AnsiString( "ASFLAGS"	  )		//		flags
#define	MACRO_LD                AnsiString( "LD"	  )		//	linker
#define	MACRO_LDFLAGS           AnsiString( "LDFLAGS"	  )		//		flags
#define	MACRO_MAKE              AnsiString( "MAKE"	  )		//	make application
#define	MACRO_MAKEFLAGS         AnsiString( "MAKEFLAGS"	  )		//		flags
#define	MACRO_GDB               AnsiString( "GDB"	  )		//	debugger
#define	MACRO_GDBFLAGS          AnsiString( "GDBFLAGS"	  )		//		flags
#define	MACRO_GROUPNAME         AnsiString( "GROUPNAME"	  )		//	current project group name
#define	MACRO_GROUPHOME         AnsiString( "GROUPHOME"	  )		//	current project group's home directory
#define	MACRO_PROJECTNAME       AnsiString( "PROJECTNAME" )		//	current project's name
#define	MACRO_PROJECTHOME       AnsiString( "PROJECTHOME" )		//	current project's home directory
#define	MACRO_MODULENAME        AnsiString( "MODULENAME"  )		//	current module open in the class explorer
#define	MACRO_MODULEFILE        AnsiString( "MODULEFILE"  )		//	current module's full file-path name
//---------------------------------------------------------------------------
class   PACKAGE TIDETool : public TObject
{       friend  class   TMainForm;
        friend  class   TToolDialog;
        protected:
                int	__fastcall      LoadFromRegistry( TObject *Sender );
                int	__fastcall      SaveToRegistry  ( TObject *Sender );
        private:
        	TRegistry		*Registry;
                AnsiString              asCaption;
                AnsiString              asToolPath;
                AnsiString              asWorkDir;
                AnsiString              asParameters;
                AnsiString              Name;
                bool			bModified;
                TObject                 *pOwner;
                TMenuItem               *pMenuItem;
                DWORD			IdNum;

                void    __fastcall      DoExecute       ( TObject *Sender );
        public:
                        __fastcall      TIDETool        ( TObject *Owner  );
                        __fastcall	~TIDETool	( void );

                void    __fastcall      Install         ( TObject *Sender );

                void    __fastcall      Remove          ( TObject *Sender );

                void    __fastcall      Execute         ( TObject *Sender );

        __published:
                __property AnsiString   Caption          = { read=asCaption,    write=asCaption,    stored=false, nodefault     };
                __property AnsiString   ToolPath         = { read=asToolPath,   write=asToolPath,   stored=false, nodefault     };
                __property AnsiString   WorkingDirectory = { read=asWorkDir,    write=asWorkDir,    stored=false, nodefault     };
                __property AnsiString   Parameters       = { read=asParameters, write=asParameters, stored=false, nodefault     };
                __property bool		Modified	 = { read=bModified,	write=bModified,    stored=false, default=false };
};
//---------------------------------------------------------------------------
extern PACKAGE TIDETool        *IdeTools;
//---------------------------------------------------------------------------
__declspec( dllimport )	AnsiString	__fastcall	DecodeMacro( AnsiString asLine );
//---------------------------------------------------------------------------
#endif
//---------------------------------------------------------------------------
