//---------------------------------------------------------------------
#include <vcl.h>
#include "About.h"
#include "shellapi.h"
#include "adCpuUsage.hpp"
#include "GetAppFileVersionInfoStrings.h"
#include "Utilities.h"
#include <windows.h>
//---------------------------------------------------------------------
#pragma hdrstop
//---------------------------------------------------------------------
#pragma resource "*.dfm"
//---------------------------------------------------------------------
TAboutBox 			*AboutBox;
GetApplicationFileVersionInfo 	*FileVersion;
MEMORYSTATUS    		*MemInfo = new MEMORYSTATUS;
//---------------------------------------------------------------------
__fastcall TAboutBox::TAboutBox(TComponent *Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------
void __fastcall TAboutBox::FormClose(TObject *Sender, TCloseAction &Action)
{
        Timer1->Enabled = false;
        Action = caHide;
}
//---------------------------------------------------------------------------
void __fastcall TAboutBox::Timer1Timer(TObject *Sender)
{
        CollectCPUData();               // Collect information about the number of processors
        double d = GetCPUUsage( 0 ) * 100;
        AnsiString as = FloatToStr( d ) + "%";
        Label6->Caption = as;
        memset( MemInfo, 0, sizeof( MEMORYSTATUS ) );
        MemInfo->dwLength = sizeof( MEMORYSTATUS );
        GlobalMemoryStatus( MemInfo );
        Label8->Caption = IntToStr( MemInfo->dwMemoryLoad ) + "%";
        Label10->Caption = IntToStr( ( MemInfo->dwTotalPhys / 1024 ) / 1024 ) + " MB";
        Label12->Caption = IntToStr( ( MemInfo->dwAvailPhys / 1024 ) / 1024 ) + " MB";
        Update();
}
//---------------------------------------------------------------------------
void 	__fastcall 	TAboutBox :: FormCreate( TObject *Sender )
{	//	Display system information

        if ( !FileVersion )
        	FileVersion = new GetApplicationFileVersionInfo;

        RichEdit1->Lines->Clear();
        Label2->Caption = "Version Number " + FileVersion->GetAppFileVerNumStr();
        Label6->Caption = "0%";
        Label8->Caption = "0%";
        Timer1->Enabled = true;
        memset( MemInfo, 0, sizeof( MEMORYSTATUS ) );
        MemInfo->dwLength = sizeof( MEMORYSTATUS );
        GlobalMemoryStatus( MemInfo );
        Label10->Caption = IntToStr( ( MemInfo->dwTotalPhys / 1024 ) / 1024 ) + " MB";
	Label12->Caption = IntToStr( ( MemInfo->dwAvailPhys / 1024 ) / 1024 ) + " MB";
        Label8->Caption = IntToStr( MemInfo->dwMemoryLoad );

        RichEdit1->Lines->Add( AnsiString( "Company Name     	: " + FileVersion->GetAppFileVersionInfoString( AnsiString( "CompanyName" ) ) ) );
        RichEdit1->Lines->Add( AnsiString( "File Description 	: " + FileVersion->GetAppFileVersionInfoString( AnsiString( "FileDescription" ) ) ) );
        RichEdit1->Lines->Add( AnsiString( "File Version     	: " + FileVersion->GetAppFileVersionInfoString( AnsiString( "FileVersion" ) ) ) );
        RichEdit1->Lines->Add( AnsiString( "InternalName	: " + FileVersion->GetAppFileVersionInfoString( AnsiString( "InternalName" ) ) ) );
        RichEdit1->Lines->Add( AnsiString( "LegalCopyright	: " + FileVersion->GetAppFileVersionInfoString( AnsiString( "LegalCopyright" ) ) ) );
        RichEdit1->Lines->Add( AnsiString( "LegalTrademarks	: " + FileVersion->GetAppFileVersionInfoString( AnsiString( "LegalTrademarks" ) ) ) );
        RichEdit1->Lines->Add( AnsiString( "OriginalFilename	: " + FileVersion->GetAppFileVersionInfoString( AnsiString( "InternalFilename" ) ) ) );
        RichEdit1->Lines->Add( AnsiString( "ProductName		: " + FileVersion->GetAppFileVersionInfoString( AnsiString( "ProductName" ) ) ) );
        RichEdit1->Lines->Add( AnsiString( "ProductVersion	: " + FileVersion->GetAppFileVersionInfoString( AnsiString( "ProductVersion" ) ) ) );
        RichEdit1->Lines->Add( AnsiString( "Comments		: " + FileVersion->GetAppFileVersionInfoString( AnsiString( "Comments" ) ) ) );
        RichEdit1->Lines->Add( AnsiString( "PrivateBuild	: " + FileVersion->GetAppFileVersionInfoString( AnsiString( "PrivateBuild" ) ) ) );
}
//---------------------------------------------------------------------------
void __fastcall TAboutBox::ProgramIconDblClick(TObject *Sender)
{
	//	Go to the http://playstation2-linux.com website
        ShellExecute( Application->Handle, "open", "iexplore.exe", "http://playstation2-linux.com", NULL, SW_SHOWDEFAULT );
}
//---------------------------------------------------------------------------
