//---------------------------------------------------------------------------
//
//      $FileName       ::      RegEntries.h
//      $Author         ::      Chris Brooklyn
//      $Description    ::      Declares standard defines and registry locations
//                              for loading/saving of projects, project options,
//                              and the enviroment
//
//---------------------------------------------------------------------------
#ifndef RegEntriesH
#define RegEntriesH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <System.hpp>
#include <SysUtils.hpp>
#include <Registry.hpp>
#include <Windows.hpp>
//---------------------------------------------------------------------------
#ifndef DefinesH
#include "Defines.h"
#endif
//---------------------------------------------------------------------------
// Allows the code to use either the registry, file streams ( or streams in general )
// or allow you to ignore any changes made ( useful when debugging at times )
// NOTE ACTIVE YET
//---------------------------------------------------------------------------
#define ENV_USE_REGISTRY                    	0x0001
#define ENV_USE_FILE                        	0x0002
#define ENV_USE_NONE                        	0x8000
#define ENV_USE_DEFAULT                     	USE_REGISTRY
//---------------------------------------------------------------------------
// 	Registry Key Locations, BASE REGISTRY LOCATION, from HKEY_CURRENT_USER
//---------------------------------------------------------------------------
#define PSXIDE_REGKEY				"Software\\Liquid Silicon Developments\\PSX IDE For Windows"
//---------------------------------------------------------------------------
// These are offsets from HKEY_CURRENT_USER     ie Borland Default for TRegistry Class
//---------------------------------------------------------------------------
#define ENVIROMENT_OPTIONS_REGKEY		AnsiString( "Software\\Liquid Silicon Developments\\PSX IDE For Windows\\Enviroment Options" )
#define ENV_OPTIONS_PREFERENCES                 AnsiString( "Software\\Liquid Silicon Developments\\PSX IDE For Windows\\Enviroment Options\\Preferences" )
#define ENV_OPTIONS_LIBRARY                     AnsiString( "Software\\Liquid Silicon Developments\\PSX IDE For Windows\\Enviroment Options\\Library" )
#define ENV_OPTIONS_EDITOR                      AnsiString( "Software\\Liquid Silicon Developments\\PSX IDE For Windows\\Enviroment Options\\Editor" )
#define ENV_OPTIONS_DISPLAY                     AnsiString( "Software\\Liquid Silicon Developments\\PSX IDE For Windows\\Enviroment Options\\Display" )
#define ENV_OPTIONS_COLOURS                     AnsiString( "Software\\Liquid Silicon Developments\\PSX IDE For Windows\\Enviroment Options\\Colours" )
#define ENV_OPTIONS_ELEMENTS			AnsiString( "Software\\Liquid Silicon Developments\\PSX IDE For Windows\\Enviroment Options\\Colours\\Elements" )
#define ENV_OPTIONS_PALETTE                     AnsiString( "Software\\Liquid Silicon Developments\\PSX IDE For Windows\\Enviroment Options\\Palette" )
#define ENV_OPTIONS_CODE_INSIGHT                AnsiString( "Software\\Liquid Silicon Developments\\PSX IDE For Windows\\Enviroment Options\\CodeInsight" )
#define ENV_OPTIONS_CODE_TEMPLATES		AnsiString( "Software\\Liquid Silicon Developments\\PSX IDE For Windows\\Enviroment Options\\CodeTemplates" )
//---------------------------------------------------------------------------
// Registry Locations for Project Manager Options
//---------------------------------------------------------------------------
#define PRJ_MANAGER_OPTIONS                     AnsiString( "Software\\Liquid Silicon Developments\\PSX IDE For Windows\\Project Manager Options" )
#define PRJ_MANAGER_PROJECTS                    AnsiString( "Software\\Liquid Silicon Developments\\PSX IDE For Windows\\Projects" )
#define PSX_IDE_PROJECTS			PRJ_MANAGER_PROJECTS
//---------------------------------------------------------------------------
// Registry Paths for Project Options
//---------------------------------------------------------------------------
#define PRJ_OPTIONS_DEFAULT                     AnsiString( "Software\\Liquid Silicon Developments\\PSX IDE For Windows\\Projects" )
#define PRJ_OPTIONS_ADVANCED_COMPILER           AnsiString( "Advanced Compiler" )
#define PRJ_OPTIONS_FPU                         AnsiString( "Advanced Compiler\\FPU" )
#define PRJ_OPTIONS_ALIASES                     AnsiString( "Aliases" )
#define PRJ_OPTIONS_APPLICATION                 AnsiString( "Application" )
#define PRJ_OPTIONS_ASSEMBLER                   AnsiString( "Assembler" )
#define PRJ_OPTIONS_ATTRIBUTES                  AnsiString( "Attributes" )
#define PRJ_OPTIONS_COMPILER                    AnsiString( "Compiler" )
#define PRJ_OPTIONS_CONDITIONALS                AnsiString( "Conditionals" )
#define PRJ_OPTIONS_CPP                         AnsiString( "CPP" )
#define PRJ_OPTIONS_GDB                         AnsiString( "Debugging" )
#define PRJ_OPTIONS_DIRECTORIES                 AnsiString( "Directories" )
#define PRJ_OPTIONS_KEYS                        AnsiString( "Keys" )
#define PRJ_OPTIONS_LD                          AnsiString( "Linker" )
#define PRJ_OPTIONS_MAKE                        AnsiString( "Make" )
#define PRJ_OPTIONS_OUTPUT_SETTINGS             AnsiString( "Output Settings" )
#define PRJ_OPTIONS_PACKAGES                    AnsiString( "Packages" )
#define PRJ_OPTIONS_DESIGN_TIME_PACKAGES        AnsiString( "Packages\\Design Time Packages" )
#define PRJ_OPTIONS_PLUGIN_PACKAGES             AnsiString( "Packages\\Plugin Packages" )
#define PRJ_OPTIONS_RUN_TIME_PACKAGES           AnsiString( "Packages\\Run Time Packages" )
#define PRJ_OPTIONS_VERSION_INFORMATION         AnsiString( "Version Information" )
#define PRJ_OPTIONS_WARNING                     AnsiString( "Warnings" )
#define PRJ_OPTIONS_UNITS			AnsiString( "Units" )
//---------------------------------------------------------------------------
//	External Tools
//---------------------------------------------------------------------------
#define PSXIDE_TOOLS				AnsiString( "Software\\Liquid Silicon Developments\\PSX IDE For Windows\\Tools" )
//---------------------------------------------------------------------------
//	THIS SECTION IS FOR THE PACKAGES SECTION OF THE IDE
//---------------------------------------------------------------------------
#define PACKAGE_ROOT				AnsiString( "Software\\Liquid Silicon Developments\\PSX IDE For Windows\\Packages" )
#define PSXIDE_PACKAGES				PACKAGE_ROOT
//---------------------------------------------------------------------------
//	Debugger
//---------------------------------------------------------------------------
#define DEBUGGER				AnsiString( "Software\\Liquid Silicon Developments\\PSX IDE For Windows\\Debugger" )
#define DEBUG_OPTIONS_EXCEPTIONS_LANGUAGE	AnsiString( "Software\\Liquid Silicon Developments\\PSX IDE For Windows\\Debugger\\Exceptions\\Language" )
#define DEBUG_OPTIONS_EXCEPTIONS_OS		AnsiString( "Software\\Liquid Silicon Developments\\PSX IDE For Windows\\Debugger\\Exceptions\\OS" )
//---------------------------------------------------------------------------
#define DEBUGGING_PORT_UNKNOWN			-1
#define DEBUGGING_PORT_AUTO			0		//	*
#define DEBUGGING_PORT_COM1			1
#define DEBUGGING_PORT_COM2     		2
#define DEBUGGING_PORT_COM3     		3
#define DEBUGGING_PORT_COM4     		4
#define DEBUGGING_PORT_LPT1     		5
#define DEBUGGING_PORT_LPT2     		6
#define DEBUGGING_PORT_USB      		7
#define DEBUGGING_PORT_NET      		8
//---------------------------------------------------------------------------
#define DEBUGGING_PORT_SPEED_UNKNOWN		-1
#define DEBUGGING_PORT_SPEED_AUTO		0		//	*
#define DEBUGGING_PORT_SPEED_9600		1
#define DEBUGGING_PORT_SPEED_19200      	2
#define DEBUGGING_PORT_SPEED_38400      	3
#define DEBUGGING_PORT_SPEED_76800      	4
#define DEBUGGING_PORT_SPEED_153600     	5
//---------------------------------------------------------------------------
#endif
//---------------------------------------------------------------------------
